/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e=e||self).tf=e.tf||{})}(this,(function(e){"use strict";class t{constructor(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}setPlatform(e,t){null!=this.platform&&console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${t}.`),this.platformName=e,this.platform=t}registerFlag(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){const t=this.urlFlags[e];console.warn(`Setting feature override from URL ${e}: ${t}.`),this.set(e,t)}}async getAsync(e){return e in this.flags||(this.flags[e]=await this.evaluateFlag(e)),this.flags[e]}get(e){if(e in this.flags)return this.flags[e];const t=this.evaluateFlag(e);if(t instanceof Promise)throw new Error(`Flag ${e} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[e]=t,this.flags[e]}getNumber(e){return this.get(e)}getBool(e){return this.get(e)}getFlags(){return this.flags}get features(){return this.flags}set(e,t){if(null==this.flagRegistry[e])throw new Error(`Cannot set flag ${e} as it has not been registered.`);this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)}evaluateFlag(e){if(null==this.flagRegistry[e])throw new Error(`Cannot evaluate flag '${e}': no evaluation function found.`);return this.flagRegistry[e].evaluationFn()}setFlags(e){this.flags=Object.assign({},e)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if(void 0===this.global||void 0===this.global.location||void 0===this.global.location.search)return;const e=function(e){const t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(e,...n)=>(function(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}(t,n[0],n[1]),n.join("="))),t}(this.global.location.search);if("tfjsflags"in e){e.tfjsflags.split(",").forEach(e=>{const[t,n]=e.split(":");this.urlFlags[t]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if(""+ +t===t)return+t;throw new Error(`Could not parse value flag value ${t} for flag ${e}.`)}(t,n)})}}}function n(){return e.ENV}let r;function s(){if(null==r){let e;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}r=e}return r}function o(e,t){const n=function(){const e=s();return null==e._tfGlobals&&(e._tfGlobals=new Map),e._tfGlobals}();if(n.has(e))return n.get(e);{const r=t();return n.set(e,r),n.get(e)}}e.ENV=null;const a=o("kernelRegistry",()=>new Map),i=o("gradRegistry",()=>new Map);function u(e,t){const n=p(e,t);return a.get(n)}function l(e){return i.get(e)}function c(e){const t=a.entries(),n=[];for(;;){const{done:r,value:s}=t.next();if(r)break;const[o,a]=s,[i]=o.split("_");i===e&&n.push(a)}return n}function h(e){const{kernelName:t}=e;i.has(t)&&n().getBool("DEBUG")&&console.warn(`Overriding the gradient for '${t}'`),i.set(t,e)}function p(e,t){return`${t}_${e}`}function d(e){let t=e.length,n=0,r=0;for(;t>0;)r=Math.random()*t|0,t--,n=e[t],e[t]=e[r],e[r]=n}function f(e,t,n){return Math.max(e,Math.min(t,n))}function m(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function g(e,t,n=""){m(k(e,t),()=>n+` Shapes ${e} and ${t} must match`)}function b(e){m(null!=e,()=>"The input to the tensor constructor must be a non-null value.")}function y(e,t=[],n=!1){if(null==t&&(t=[]),Array.isArray(e)||M(e)&&!n)for(let r=0;r<e.length;++r)y(e[r],t,n);else t.push(e);return t}function w(e){if(0===e.length)return 1;let t=e[0];for(let n=1;n<e.length;n++)t*=e[n];return t}function k(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(let n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function v(e){return e%1==0}function x(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function S(e,t){let n=1,r=-1;for(let t=0;t<e.length;++t)if(e[t]>=0)n*=e[t];else if(-1===e[t]){if(-1!==r)throw Error(`Shapes can only have 1 implicit size. Found -1 at dim ${r} and dim ${t}`);r=t}else if(e[t]<0)throw Error(`Shapes can not be < 0. Found ${e[t]} at dim ${t}`);if(-1===r){if(t>0&&t!==n)throw Error(`Size(${t}) must match the product of shape ${e}`);return e}if(0===n)throw Error(`Cannot infer the missing size in [${e}] when there are 0 elements`);if(t%n!=0)throw Error(`The implicit shape can't be a fractional number. Got ${t} / ${n}`);const s=e.slice();return s[r]=t/n,s}function E(e,t){const n=t.length;return m((e=null==e?t.map((e,t)=>t):[].concat(e)).every(e=>e>=-n&&e<n),()=>`All values in axis param must be in range [-${n}, ${n}) but got axis `+e),m(e.every(e=>v(e)),()=>"All values in axis param must be integers but got axis "+e),e.map(e=>e<0?n+e:e)}function D(e,t){const n=[],r=[],s=null!=t&&Array.isArray(t)&&0===t.length,o=null==t||s?null:E(t,e).sort();let a=0;for(let t=0;t<e.length;++t){if(null!=o){if(o[a]===t&&1!==e[t])throw new Error(`Can't squeeze axis ${t} since its dim '${e[t]}' is not 1`);(null==o[a]||o[a]>t)&&1===e[t]&&(n.push(e[t]),r.push(t)),o[a]<=t&&a++}1!==e[t]&&(n.push(e[t]),r.push(t))}return{newShape:n,keptDims:r}}function N(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else{if("bool"!==e)throw new Error("Unknown data type "+e);n=new Uint8Array(t)}return n}function I(e,t){let n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error("Unknown data type "+e);n=new Array(t)}return n}function F(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(isNaN(r)||!isFinite(r))throw Error(`A tensor of type ${t} being uploaded contains ${r}.`)}}function A(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}function T(e,t){return"complex64"!==t&&(("float32"!==t||"complex64"===e)&&(("int32"!==t||"float32"===e||"complex64"===e)&&("bool"!==t||"bool"!==e)))}function M(e){return e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array}function $(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error("Unknown dtype "+e)}function _(e){if(null==e)return 0;let t=0;return e.forEach(e=>t+=e.length),t}function B(e){return"string"==typeof e||e instanceof String}function R(e){return"boolean"==typeof e}function C(e){return"number"==typeof e}function P(e){return Array.isArray(e)?P(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array?"int32":C(e)?"float32":B(e)?"string":R(e)?"bool":"float32"}function z(e){return!!(e&&e.constructor&&e.call&&e.apply)}function q(e,t){for(let n=t;n<e;++n)if(e%n==0)return n;return e}function L(e){const t=e.length;if(t<2)return[];const n=new Array(t-1);n[t-2]=e[t-1];for(let r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function O(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=y(e)),n().getBool("DEBUG")&&F(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){const t=new Uint8Array(e.length);for(let n=0;n<t.length;++n)0!==Math.round(e[n])&&(t[n]=1);return t}throw new Error("Unknown data type "+t)}function W(e,t){if(0===e.length)return t[0];const n=e.reduce((e,t)=>e*t);if(0===n)return[];if(n!==t.length)throw new Error(`[${e}] does not match the input size ${t.length}.`);return function e(t,n,r){const s=new Array;if(1===n.length){const e=n[0];for(let n=0;n<e;n++)s[n]=r[t+n]}else{const o=n[0],a=n.slice(1),i=a.reduce((e,t)=>e*t);for(let n=0;n<o;n++)s[n]=e(t+n*i,a,r)}return s}(0,e,t)}function K(e,t){const n=G(e,t);for(let e=0;e<n.length;e++)n[e]=1;return n}function G(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error("Unknown data type "+t)}function U(){return n().platform.now()}function V(e){e.forEach(t=>{m(Number.isInteger(t)&&t>=0,()=>`Tensor must have a shape comprised of positive integers but got shape [${e}].`)})}function H(e,t="utf-8"){return t=t||"utf-8",n().platform.encode(e,t)}function j(e,t="utf-8"){return t=t||"utf-8",n().platform.decode(e,t)}var J=Object.freeze({__proto__:null,shuffle:d,clamp:f,nearestLargerEven:function(e){return e%2==0?e:e+1},sum:function(e){let t=0;for(let n=0;n<e.length;n++)t+=e[n];return t},randUniform:function(e,t){const n=Math.random();return t*n+(1-n)*e},distSquared:function(e,t){let n=0;for(let r=0;r<e.length;r++){const s=Number(e[r])-Number(t[r]);n+=s*s}return n},assert:m,assertShapesMatch:g,assertNonNull:b,flatten:y,sizeFromShape:w,isScalarShape:function(e){return 0===e.length},arraysEqual:k,isInt:v,tanh:function(e){if(null!=Math.tanh)return Math.tanh(e);if(e===1/0)return 1;if(e===-1/0)return-1;{const t=Math.exp(2*e);return(t-1)/(t+1)}},sizeToSquarishShape:function(e){const t=Math.ceil(Math.sqrt(e));return[t,Math.ceil(e/t)]},createShuffledIndices:function(e){const t=new Uint32Array(e);for(let n=0;n<e;++n)t[n]=n;return d(t),t},rightPad:x,repeatedTry:function(e,t=(e=>0),n){return new Promise((r,s)=>{let o=0;const a=()=>{if(e())return void r();o++;const i=t(o);null!=n&&o>=n?s():setTimeout(a,i)};a()})},inferFromImplicitShape:S,parseAxisParam:E,squeezeShape:D,getTypedArrayFromDType:N,getArrayFromDType:I,checkConversionForErrors:F,isValidDtype:A,hasEncodingLoss:T,isTypedArray:M,bytesPerElement:$,bytesFromStringArray:_,isString:B,isBoolean:R,isNumber:C,inferDtype:P,isFunction:z,nearestDivisor:q,computeStrides:L,toTypedArray:O,toNestedArray:W,makeOnesTypedArray:K,makeZerosTypedArray:G,makeZerosNestedTypedArray:function(e,t){const n=e.reduce((e,t)=>e*t,1);if(null==t||"float32"===t)return W(e,new Float32Array(n));if("int32"===t)return W(e,new Int32Array(n));if("bool"===t)return W(e,new Uint8Array(n));throw new Error("Unknown data type "+t)},now:U,assertNonNegativeIntegerDimensions:V,fetch:function(e,t){return n().platform.fetch(e,t)},encodeString:H,decodeString:j,locToIndex:function(e,t,n){if(0===t)return 0;if(1===t)return e[0];let r=e[e.length-1];for(let t=0;t<e.length-1;++t)r+=n[t]*e[t];return r},indexToLoc:function(e,t,n){if(0===t)return[];if(1===t)return[e];const r=new Array(t);for(let t=0;t<r.length-1;++t)r[t]=Math.floor(e/n[t]),e-=r[t]*n[t];return r[r.length-1]=e,r}});class Y{constructor(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new Z)}profileKernel(e,t,n){let r;const s=this.backendTimer.time(()=>{r=n()});return r.map(t=>{t.data().then(n=>{!function(e,t,n){if("float32"!==t)return!1;for(let t=0;t<e.length;t++){const r=e[t];if(isNaN(r)||!isFinite(r))return console.warn(`Found ${r} in the result of '${n}'`),!0}}(n,t.dtype,e)})}),{kernelName:e,outputs:r,inputs:t,timeMs:s.then(e=>e.kernelMs),extraInfo:s.then(e=>null!=e.getExtraProfileInfo?e.getExtraProfileInfo():"")}}logKernelProfile(e){const{kernelName:t,outputs:n,timeMs:r,inputs:s,extraInfo:o}=e;n.forEach(e=>{Promise.all([e.data(),r,o]).then(n=>{this.logger.logKernelProfile(t,e,n[0],n[1],s,n[2])})})}}class Z{logKernelProfile(e,t,n,r,s,o){const a="number"==typeof r?x(r+"ms",9):r.error,i=x(e,25),u=t.rank,l=t.size,c=x(t.shape.toString(),14);let h="";for(const e in s){const n=s[e].shape||t.shape,r=n.length;h+=`${e}: ${r}D ${r>0?n:""} `}console.log(`%c${i}\t%c${a}\t%c${u}D ${c}\t%c${l}\t%c${h}\t%c${o}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function X(e,t,n,r){const s=L(t),o=function(e,t,n,r){const s=w(t),o=r[r.length-1],a=new Array(o).fill(0),i=t.length,u="complex64"===n?te(e):e;if(i>1)for(let e=0;e<s/o;e++){const t=e*o;for(let e=0;e<o;e++)a[e]=Math.max(a[e],Q(u[t+e],0,n).length)}return a}(e,t,n,s),a=t.length,i=function e(t,n,r,s,o,a=!0){const i="complex64"===r?2:1,u=n[0],l=n.length;if(0===l){if("complex64"===r){return[Q(te(t)[0],0,r)]}return"bool"===r?[ee(t[0])]:[t[0].toString()]}if(1===l){if(u>20){const e=3*i;let n=Array.from(t.slice(0,e)),s=Array.from(t.slice((u-3)*i,u*i));return"complex64"===r&&(n=te(n),s=te(s)),["["+n.map((e,t)=>Q(e,o[t],r)).join(", ")+", ..., "+s.map((e,t)=>Q(e,o[u-3+t],r)).join(", ")+"]"]}return["["+("complex64"===r?te(t):Array.from(t)).map((e,t)=>Q(e,o[t],r)).join(", ")+"]"]}const c=n.slice(1),h=s.slice(1),p=s[0]*i,d=[];if(u>20){for(let n=0;n<3;n++){const s=n*p,a=s+p;d.push(...e(t.slice(s,a),c,r,h,o,!1))}d.push("...");for(let n=u-3;n<u;n++){const s=n*p,a=s+p;d.push(...e(t.slice(s,a),c,r,h,o,n===u-1))}}else for(let n=0;n<u;n++){const s=n*p,a=s+p;d.push(...e(t.slice(s,a),c,r,h,o,n===u-1))}const f=2===l?",":"";d[0]="["+d[0]+f;for(let e=1;e<d.length-1;e++)d[e]=" "+d[e]+f;let m=",\n";for(let e=2;e<l;e++)m+="\n";return d[d.length-1]=" "+d[d.length-1]+"]"+(a?"":m),d}(e,t,n,s,o),u=["Tensor"];return r&&(u.push("  dtype: "+n),u.push("  rank: "+a),u.push(`  shape: [${t}]`),u.push("  values:")),u.push(i.map(e=>"    "+e).join("\n")),u.join("\n")}function Q(e,t,n){let r;return r=Array.isArray(e)?parseFloat(e[0].toFixed(7))+" + "+parseFloat(e[1].toFixed(7))+"j":B(e)?`'${e}'`:"bool"===n?ee(e):parseFloat(e.toFixed(7)).toString(),x(r,t)}function ee(e){return 0===e?"false":"true"}function te(e){const t=[];for(let n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}class ne{constructor(e,t,n){if(this.dtype=t,this.shape=e.slice(),this.size=w(e),null!=n){const e=n.length;m(e===this.size,()=>`Length of values '${e}' does not match the size inferred by the shape '${this.size}'.`)}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||I(t,this.size),this.strides=L(e)}set(e,...t){0===t.length&&(t=[0]),m(t.length===this.rank,()=>`The number of provided coordinates (${t.length}) must match the rank (${this.rank})`);const n=this.locToIndex(t);this.values[n]=e}get(...e){0===e.length&&(e=[0]);let t=0;for(const n of e){if(n<0||n>=this.shape[t]){const t=`Requested out of range element at ${e}.   Buffer shape=`+this.shape;throw new Error(t)}t++}let n=e[e.length-1];for(let t=0;t<e.length-1;++t)n+=this.strides[t]*e[t];return this.values[n]}locToIndex(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];let t=e[e.length-1];for(let n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t}indexToLoc(e){if(0===this.rank)return[];if(1===this.rank)return[e];const t=new Array(this.shape.length);for(let n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t}get rank(){return this.shape.length}toTensor(){return re().makeTensor(this.values,this.shape,this.dtype)}}let re=null,se=null;class oe{constructor(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=w(e),this.strides=L(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const e=await this.data();return se.buffer(this.shape,this.dtype,e)}bufferSync(){return se.buffer(this.shape,this.dtype,this.dataSync())}async array(){const e=await this.data();return W(this.shape,e)}arraySync(){return W(this.shape,this.dataSync())}async data(){this.throwIfDisposed();const e=re().read(this.dataId);if("string"===this.dtype){const t=await e;try{return t.map(e=>j(e))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return e}dataSync(){this.throwIfDisposed();const e=re().readSync(this.dataId);if("string"===this.dtype)try{return e.map(e=>j(e))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e}async bytes(){this.throwIfDisposed();const e=await re().read(this.dataId);return"string"===this.dtype?e:new Uint8Array(e.buffer)}dispose(){this.isDisposed||(re().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(e=!1){return se.print(this,e)}clone(){return this.throwIfDisposed(),se.clone(this)}toString(e=!1){return X(this.dataSync(),this.shape,this.dtype,e)}cast(e){return this.throwIfDisposed(),se.cast(this,e)}variable(e=!0,t,n){return this.throwIfDisposed(),re().makeVariable(this,e,t,n)}}Object.defineProperty(oe,Symbol.hasInstance,{value:e=>!!e&&null!=e.dataId&&null!=e.shape&&null!=e.dtype});class ae extends oe{constructor(e,t,n,r){super(e.shape,e.dtype,e.dataId,r),this.trainable=t,this.name=n}assign(e){if(e.dtype!==this.dtype)throw new Error(`dtype of the new value (${e.dtype}) and previous value (${this.dtype}) must match`);if(!k(e.shape,this.shape))throw new Error(`shape of the new value (${e.shape}) and previous value (${this.shape}) must match`);re().disposeTensor(this),this.dataId=e.dataId,re().incRef(this,null)}dispose(){re().disposeVariable(this),this.isDisposedInternal=!0}}var ie,ue,le,ce,he;Object.defineProperty(ae,Symbol.hasInstance,{value:e=>e instanceof oe&&null!=e.assign&&e.assign instanceof Function}),(ie=e.Rank||(e.Rank={})).R0="R0",ie.R1="R1",ie.R2="R2",ie.R3="R3",ie.R4="R4",ie.R5="R5",ie.R6="R6",function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(ue||(ue={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(le||(le={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(ce||(ce={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(he||(he={}));const pe={float32:ce,int32:ue,bool:le,complex64:he};function de(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error(`Can not upcast ${e} with ${t}`)}return pe[e][t]}function fe(e,t){if(e.dtype===t.dtype)return[e,t];const n=de(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function me(e,t){m(e.dtype===t.dtype,()=>`The dtypes of the first(${e.dtype}) and second(${t.dtype}) input must match`)}function ge(e){const t=[];return function e(t,n,r){if(null==t)return;if(t instanceof oe)return void n.push(t);if(s=t,!Array.isArray(s)&&"object"!=typeof s)return;var s;const o=t;for(const t in o){const s=o[t];r.has(s)||(r.add(s),e(s,n,r))}}(e,t,new Set),t}var be=Object.freeze({__proto__:null,makeTypesMatch:fe,assertTypesMatch:me,isTensorInList:function(e,t){return t.some(t=>t.id===e.id)},getTensorsInContainer:ge});class ye{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null}}dispose(){for(const e in this.registeredVariables)this.registeredVariables[e].dispose()}}class we{constructor(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new ye}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then(()=>{});if(null!=this.backendInstance)return;const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:e,asyncInit:t}=this.initializeBackendsAndReturnBest();if(t)throw new Error(`The highest priority backend '${e}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(e)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;{const{asyncInit:t}=this.initializeBackend(e);if(t)return null}}return this.registry[e]}findBackendFactory(e){return e in this.registryFactory?this.registryFactory[e].factory:null}registerBackend(e,t,n=1){return e in this.registryFactory?(console.warn(e+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[e]={factory:t,priority:n},!0)}async setBackend(e){if(null==this.registryFactory[e])throw new Error(`Backend name '${e}' not found in registry`);if(this.backendName=e,null==this.registry[e]){this.backendInstance=null;const{success:t,asyncInit:n}=this.initializeBackend(e);if(!(n?await t:t))return!1}return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new Y(this.backendInstance),!0}setupRegisteredKernels(){c(this.backendName).forEach(e=>{null!=e.setupFunc&&e.setupFunc(this.backendInstance)})}disposeRegisteredKernels(e){c(e).forEach(t=>{null!=t.disposeFunc&&t.disposeFunc(this.registry[e])})}initializeBackend(e){const t=this.registryFactory[e];if(null==t)throw new Error(`Cannot initialize backend ${e}, no registration found.`);try{const n=t.factory();if(Promise.resolve(n)===n){const t=++this.pendingBackendInitId,r=n.then(n=>!(t<this.pendingBackendInitId)&&(this.registry[e]=n,this.pendingBackendInit=null,!0)).catch(n=>(t<this.pendingBackendInitId||(this.pendingBackendInit=null,console.warn(`Initialization of backend ${e} failed`),console.warn(n.stack||n.message)),!1));return this.pendingBackendInit=r,{success:r,asyncInit:!0}}return this.registry[e]=n,{success:!0,asyncInit:!1}}catch(t){return console.warn(`Initialization of backend ${e} failed`),console.warn(t.stack||t.message),{success:!1,asyncInit:!1}}}removeBackend(e){if(!(e in this.registryFactory))throw new Error(e+" backend not found in registry");this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((e,t)=>this.registryFactory[t].priority-this.registryFactory[e].priority)}initializeBackendsAndReturnBest(){const e=this.getSortedBackends();for(let t=0;t<e.length;t++){const n=e[t],{success:r,asyncInit:s}=this.initializeBackend(n);if(s||r)return{name:n,asyncInit:s}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(e,t){const n=this.state.tensorInfo.get(t),r=n.backend,s=this.readSync(t);r.disposeData(t),n.backend=e,e.move(t,s,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(e,t){let n,r=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");r=e}return this.scopedRun(()=>this.startScope(r),()=>this.endScope(n),()=>(n=t(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n))}scopedRun(e,t,n){e();try{const e=n();return t(),e}catch(e){throw t(),e}}nextTensorId(){return we.nextTensorId++}nextVariableId(){return we.nextVariableId++}clone(e){const t=this.makeTensorFromDataId(e.dataId,e.shape,e.dtype),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],e=>({x:()=>e.toFloat()}),[],{}),t}runKernel(e,t,n,r,s){return this.runKernelFunc(null,t,null,e,n,r,s)}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(e,t,n){const r=this.backend.numDataIds();let s=0;n.forEach(e=>{s+="complex64"===e.dtype?3:1});const o=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],a=r-t-s-o;if(a>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${a} data ids) after running '${e}'`)}runKernelFunc(e,t,n,r,s,o,a){let i,l=[];const c=this.isTapeOn();null==r&&(r=null!=this.state.activeScope?this.state.activeScope.name:"");const h=this.state.numBytes,p=this.state.numTensors;let d;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0);const f=u(r,this.backendName);let m;if(null!=f)d=()=>{const e=this.backend.numDataIds();m=f.kernelFunc({inputs:t,attrs:s,backend:this.backend});const n=Array.isArray(m)?m:[m];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(r,e,n);const i=n.map(({dataId:e,shape:t,dtype:n})=>this.makeTensorFromDataId(e,t,n));if(c){let e=this.getTensorsForGradient(r,t,i);if(null==e){null==a&&(a=[]);const t=i.filter((e,t)=>a[t]);e=(o||[]).slice().concat(t)}l=this.saveTensorsForBackwardMode(e)}return i};else{const t=e=>{c&&(l=e.map(e=>this.keep(this.clone(e))))};d=()=>{const n=this.backend.numDataIds();m=this.tidy(()=>e(this.backend,t));const s=Array.isArray(m)?m:[m];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(r,n,s),s}}return this.scopedRun(()=>this.state.kernelDepth++,()=>this.state.kernelDepth--,()=>{if(this.ENV.getBool("DEBUG")){let e;e=this.profiler.profileKernel(r,t,()=>d()),this.profiler.logKernelProfile(e),i=e.outputs}else i=d()}),c&&this.addTapeNode(r,t,i,n,l,s),this.state.profiling&&this.state.activeProfile.kernels.push({name:r,bytesAdded:this.state.numBytes-h,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-p,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(t).map(e=>null!=t[e]?t[e].shape:null),outputShapes:i.map(e=>e.shape)}),Array.isArray(m)?i:i[0]}saveTensorsForBackwardMode(e){return e.map(e=>this.keep(this.clone(e)))}getTensorsForGradient(e,t,n){const r=l(e);if(null!=r){const e=r.inputsToSave||[],s=r.outputsToSave||[];let o;r.saveAllInputs?(m(Array.isArray(t),()=>"saveAllInputs is true, expected inputs to be an array."),o=Object.keys(t).map(e=>t[e])):o=e.map(e=>t[e]);const a=n.filter((e,t)=>s[t]);return o.concat(a)}return null}makeTensor(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;let s=e;"string"===n&&B(e[0])&&(s=e.map(e=>H(e)));const o=r.write(s,t,n),a=new oe(t,n,o,this.nextTensorId());if(this.incRef(a,r),"string"===n){const e=this.state.tensorInfo.get(o),t=_(s);this.state.numBytes+=t-e.bytes,e.bytes=t}return a}makeTensorFromDataId(e,t,n,r){const s=new oe(t,n=n||"float32",e,this.nextTensorId());return this.incRef(s,r),s}makeVariable(e,t=!0,n,r){n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));const s=new ae(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[s.name])throw new Error(`Variable with name ${s.name} was already registered`);return this.state.registeredVariables[s.name]=s,this.incRef(s,this.backend),s}incRef(e,t){const n=this.state.tensorInfo.has(e.dataId)?this.state.tensorInfo.get(e.dataId).refCount:0;if(this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;let n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*$(e.dtype)),this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n,refCount:0}),this.state.numBytes+=n}this.state.tensorInfo.get(e.dataId).refCount++,e instanceof ae||this.track(e)}disposeTensor(e){if(!this.state.tensorInfo.has(e.dataId))return;this.state.numTensors--,"string"===e.dtype&&this.state.numStringTensors--;const t=this.state.tensorInfo.get(e.dataId);t.refCount<=1?("complex64"!==e.dtype&&(this.state.numBytes-=t.bytes),this.state.numDataBuffers--,t.backend.disposeData(e.dataId),this.state.tensorInfo.delete(e.dataId)):this.state.tensorInfo.get(e.dataId).refCount--}disposeVariables(){for(const e in this.state.registeredVariables){const t=this.state.registeredVariables[e];this.disposeVariable(t)}}disposeVariable(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]}memory(){const e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e}async profile(e){this.state.profiling=!0;const t=this.state.numBytes,n=this.state.numTensors;return this.state.activeProfile.kernels=[],this.state.activeProfile.result=await e(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map(e=>e.totalBytesSnapshot)),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n,this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(e,t,n,r,s,o){const a={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:s},i=l(e);null!=i&&(r=i.gradFunc),null!=r&&(a.gradient=e=>(e=e.map((e,t)=>{if(null==e){const e=n[t],r=G(e.size,e.dtype);return this.makeTensor(r,e.shape,e.dtype)}return e}),r(e.length>1?e:e[0],s,o))),this.state.activeTape.push(a)}keep(e){return e.kept=!0,e}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(e){const t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t}endScope(e){const t=ge(e),n=new Set(t.map(e=>e.id));for(let e=0;e<this.state.activeScope.track.length;e++){const t=this.state.activeScope.track[e];t.kept||n.has(t.id)||t.dispose()}const r=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],t.forEach(e=>{e.kept||e.scopeId!==r.id||this.track(e)})}gradients(e,t,n,r=!1){if(m(t.length>0,()=>"gradients() received an empty list of xs."),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const s=this.scopedRun(()=>this.startTape(),()=>this.endTape(),()=>this.tidy("forward",e));m(s instanceof oe,()=>"The result y returned by f() must be a tensor.");const o=function(e,t,n){const r={},s={};for(let e=0;e<t.length;e++)r[t[e].id]=!0;for(let n=0;n<e.length;n++){const o=e[n],a=o.inputs;for(const e in a){const n=a[e];let i=!1;for(let e=0;e<t.length;e++)if(r[n.id]){o.outputs.forEach(e=>r[e.id]=!0),i=!0,s[o.id]=!0;break}if(i)break}}const o={};o[n.id]=!0;const a={};for(let t=e.length-1;t>=0;t--){const n=e[t],r=n.inputs;for(let e=0;e<n.outputs.length;e++)if(o[n.outputs[e].id]){for(const e in r)o[r[e].id]=!0,a[n.id]=!0;break}}const i=[];for(let t=0;t<e.length;t++){const n=e[t];if(s[n.id]&&a[n.id]){const e={};for(const t in n.inputs){const s=n.inputs[t];r[s.id]&&(e[t]=s)}const t=Object.assign({},n);t.inputs=e,t.outputs=n.outputs,i.push(t)}}return i}(this.state.activeTape,t,s);if(!r&&0===o.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",()=>{const e={};e[s.id]=null==n?function(e){const t=K(w(e),"float32");return ke.makeTensor(t,e,"float32")}(s.shape):n,function(e,t,n){for(let r=t.length-1;r>=0;r--){const s=t[r],o=[];if(s.outputs.forEach(t=>{const n=e[t.id];null!=n?o.push(n):o.push(null)}),null==s.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${s.kernelName}.`);const a=s.gradient(o);for(const t in s.inputs){if(!(t in a))throw new Error(`Cannot backprop through input ${t}. Available gradients found: ${Object.keys(a)}.`);const r=n(()=>a[t]());if("float32"!==r.dtype)throw new Error(`Error in gradient for op ${s.kernelName}. The gradient of input ${t} must have 'float32' dtype, but has '${r.dtype}'`);const o=s.inputs[t];if(!k(r.shape,o.shape))throw new Error(`Error in gradient for op ${s.kernelName}. The gradient of input '${t}' has shape '${r.shape}', which does not match the shape of the input '${o.shape}'`);if(null==e[o.id])e[o.id]=r;else{const t=e[o.id];e[o.id]=t.add(r),t.dispose()}}}}(e,o,e=>this.tidy(e));const r=t.map(t=>e[t.id]);return 0===this.state.gradientDepth&&(this.state.activeTape.forEach(e=>{for(const t of e.saved)t.dispose()}),this.state.activeTape=null),{value:s,grads:r}})}customGrad(e){return m(z(e),()=>"The f passed in customGrad(f) must be a function."),(...t)=>{let n;m(t.every(e=>e instanceof oe),()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors");const r={};return t.forEach((e,t)=>{r[t]=e}),this.runKernelFunc((r,s)=>(n=e(...t,s),m(n.value instanceof oe,()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"),m(z(n.gradFunc),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."),n.value),r,(e,r)=>{const s=n.gradFunc(e,r),o=Array.isArray(s)?s:[s];m(o.length===t.length,()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."),m(o.every(e=>e instanceof oe),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.");const a={};return o.forEach((e,t)=>{a[t]=()=>e}),a})}}readSync(e){return this.state.tensorInfo.get(e).backend.readSync(e)}read(e){return this.state.tensorInfo.get(e).backend.read(e)}async time(e){const t=U(),n=await this.backend.time(e);return n.wallMs=U()-t,n}track(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new ye;for(const e in this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}we.nextTensorId=0,we.nextVariableId=0;const ke=function(){const n=s();if(null==n._tfengine){const e=new t(n);n._tfengine=new we(e)}var r;return r=n._tfengine.ENV,e.ENV=r,re=()=>n._tfengine,n._tfengine}();function ve(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var xe=Object.freeze({__proto__:null,isMobile:function(){if("undefined"!=typeof navigator&&null!=navigator){const e=navigator.userAgent||navigator.vendor||window.opera;return/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(e)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(e.substr(0,4))}return!1},isBrowser:ve});const Se=n();Se.registerFlag("DEBUG",()=>!1,e=>{e&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")}),Se.registerFlag("IS_BROWSER",()=>ve()),Se.registerFlag("IS_NODE",()=>"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node),Se.registerFlag("IS_CHROME",()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)),Se.registerFlag("PROD",()=>!1),Se.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",()=>Se.getBool("DEBUG")),Se.registerFlag("DEPRECATION_WARNINGS_ENABLED",()=>!0),Se.registerFlag("IS_TEST",()=>!1);function Ee(e,t){let r=e;if(M(e))return"string"===t?[]:[e.length];if(!Array.isArray(e))return[];const s=[];for(;Array.isArray(r)||M(r)&&"string"!==t;)s.push(r.length),r=r[0];return Array.isArray(e)&&n().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function e(t,n,r){if(r=r||[],!Array.isArray(t)&&!M(t))return void m(0===n.length,()=>`Element arr[${r.join("][")}] is a primitive, but should be an array/TypedArray of ${n[0]} elements`);m(n.length>0,()=>`Element arr[${r.join("][")}] should be a primitive, but is an array of ${t.length} elements`),m(t.length===n[0],()=>`Element arr[${r.join("][")}] should have ${n[0]} elements, but has ${t.length} elements`);const s=n.slice(1);for(let n=0;n<t.length;++n)e(t[n],s,r.concat(n))}(e,s,[]),s}function De(e,t,n,r){if(null!=e&&("numeric"!==e&&e!==t||"numeric"===e&&"string"===t))throw new Error(`Argument '${n}' passed to '${r}' must be ${e} tensor, but got ${t} tensor`)}function Ne(e,t,n,r="numeric"){if(e instanceof oe)return De(r,e.dtype,t,n),e;let s=P(e);if("string"!==s&&["bool","int32","float32"].indexOf(r)>=0&&(s=r),De(r,s,t,n),null==e||!M(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){const r=null==e?"null":e.constructor.name;throw new Error(`Argument '${t}' passed to '${n}' must be a Tensor or TensorLike, but got '${r}'`)}const o=Ee(e,s);M(e)||Array.isArray(e)||(e=[e]);const a="string"!==s?O(e,s):y(e,[],!0);return ke.makeTensor(a,o,s)}function Ie(e,t,n,r="numeric"){if(!Array.isArray(e))throw new Error(`Argument ${t} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return e.map((e,r)=>Ne(e,`${t}[${r}]`,n),r)}function Fe(e){const t=Object.keys(e);if(1!==t.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+t.length+" keys.");let n=t[0];const r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1));const s=(...e)=>{ke.startScope(n);try{const t=r(...e);return t instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),ke.endScope(t),t}catch(e){throw ke.endScope(null),e}};return Object.defineProperty(s,"name",{value:n,configurable:!0}),s}const Ae=Fe({cast_:function(e,t){const n=Ne(e,"x","cast");if(!A(t))throw new Error("Failed to cast to unknown dtype "+t);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const r={x:n},s={dtype:t};return ke.runKernelFunc(e=>e.cast(n,t),r,null,"Cast",s)}});const Te=Fe({mul_:function(e,t){let n=Ne(e,"a","mul"),r=Ne(t,"b","mul");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.multiply(n,r);return t([n,r]),s},s,null,"Multiply")}});const Me=Fe({step_:function(e,t=0){const n=Ne(e,"x","step"),r={x:n},s={alpha:t};return ke.runKernelFunc(e=>e.step(n,t),r,null,"Step",s)}}),$e={kernelName:"Abs",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,Me(Ae(n,"float32"),-1))}}};const _e=Fe({floorDiv_:function(e,t){let n=Ne(e,"a","floorDiv"),r=Ne(t,"b","floorDiv");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.floorDiv(n,r);return t([n,r]),s},s,null,"FloorDiv")}});const Be=Fe({div_:function(e,t){let n=Ne(e,"a","div"),r=Ne(t,"b","div");if([n,r]=fe(n,r),"int32"===n.dtype&&"int32"===r.dtype)return _e(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.realDivide(n,r);return t([n,r]),s},s,null,"Div",{})}});const Re=Fe({neg_:function(e){const t=Ne(e,"x","neg"),n={x:t};return ke.runKernelFunc(e=>e.neg(t),n,null,"Negate")}});function Ce(e,t,n,r){if(null==r&&(r=P(e)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!M(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){V(t);const e=w(t),r=w(n);m(e===r,()=>`Based on the provided shape, [${t}], the tensor should have ${e} values but has ${r}`);for(let e=0;e<n.length;++e){const r=n[e],s=e!==n.length-1||r!==w(t.slice(e));m(n[e]===t[e]||!s,()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${t}). `)}}return M(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?O(e,r):y(e,[],!0),ke.makeTensor(e,t,r)}function Pe(e,t){if((M(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&M(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return Ce(e,[],[],t)}const ze=Fe({sqrt_:function(e){const t=Ne(e,"x","sqrt"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.sqrt(t);return n([t]),r},n,null,"Sqrt")}});const qe=Fe({square_:function(e){const t=Ne(e,"x","square"),n=[t];return ke.runKernelFunc((e,n)=>(n([t]),e.square(t)),{x:t},null,"Square",{},n,[])}});const Le=Fe({sub_:function(e,t){let n=Ne(e,"a","sub"),r=Ne(t,"b","sub");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.subtract(n,r);return t([n,r]),s},s,null,"Sub")}}),Oe={kernelName:"Acos",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=qe(Ae(n,"float32")),r=ze(Le(Pe(1),t));return Re(Be(e,r))}}}},We={kernelName:"Acosh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=ze(Le(qe(Ae(n,"float32")),1));return Be(e,t)}}}};function Ke(e,t){const n=[];for(let r=0;r<t.length;r++){const s=e[e.length-r-1],o=t.length-r-1,a=t[o];(null==s||1===s&&a>1)&&n.unshift(o)}return n}function Ge(e,t){const n=[],r=Math.max(e.length,t.length);for(let s=0;s<r;s++){let r=e[e.length-s-1];null==r&&(r=1);let o=t[t.length-s-1];if(null==o&&(o=1),1===r)n.unshift(o);else if(1===o)n.unshift(r);else{if(r!==o){throw Error(`Operands could not be broadcast together with shapes ${e} and ${t}.`)}n.unshift(r)}}return n}const Ue={kernelName:"Add",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{let t=e;const r=Ke(n.shape,s);return r.length>0&&(t=t.sum(r)),t.reshape(n.shape)},b:()=>{let t=e;const n=Ke(r.shape,s);return n.length>0&&(t=t.sum(n)),t.reshape(r.shape)}}}},Ve={kernelName:"AddN",saveAllInputs:!0,gradFunc:(e,t)=>{const n={};return t.forEach((t,r)=>{n[r]=()=>e.clone()}),n}};const He=Fe({zerosLike_:function(e){const t=Ne(e,"x","zerosLike"),n={x:t};return ke.runKernelFunc(e=>e.zerosLike(t),n,null,"ZerosLike")}}),je={kernelName:"ArgMax",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>He(n)}}},Je={kernelName:"ArgMin",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>He(n)}}},Ye={kernelName:"Asin",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,ze(Le(Pe(1),qe(Ae(n,"float32")))))}}};const Ze=Fe({add_:function(e,t){let n=Ne(e,"a","add"),r=Ne(t,"b","add");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.add(n,r);return t([n,r]),s},s,null,"Add")}}),Xe={kernelName:"Asinh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=ze(Ze(Pe(1),qe(Ae(n,"float32"))));return Be(e,t)}}}};const Qe=Fe({reshape_:function(e,t){const n=Ne(e,"x","reshape",null);t=S(t,n.size),m(n.size===w(t),()=>"new shape and old shape must have the same number of elements.");const r={x:n},s={shape:t};return ke.runKernelFunc((e,r)=>(r([n]),e.reshape(n,t)),r,null,"Reshape",s)}});function et(e,t){for(let n=0;n<e.length;++n)if(e[e.length-n-1]!==t-1-n)return!1;return!0}function tt(e,t,n){const r=e.length+t.length,s=[];let o=0,a=0;for(let i=0;i<r;i++)-1===n.indexOf(i)?s.push(e[o++]):s.push(t[a++]);return s}function nt(e,t){const n=[],r=e.length;for(let s=0;s<r;s++)-1===t.indexOf(s)&&n.push(e[s]);return[n,t.map(t=>e[t])]}function rt(e,t){return tt(e,t.map(e=>1),t)}function st(e,t){if(et(e,t))return null;const n=[];for(let r=0;r<t;++r)-1===e.indexOf(r)&&n.push(r);return e.forEach(e=>n.push(e)),n}function ot(e){return e.map((e,t)=>[t,e]).sort((e,t)=>e[1]-t[1]).map(e=>e[0])}function at(e,t){const n=[];for(let r=t-e;r<t;++r)n.push(r);return n}const it=Fe({sum_:function(e,t=null,n=!1){let r=Ne(e,"x","sum");"bool"===r.dtype&&(r=r.toInt());const s={x:r},o={axis:t,keepDims:n};return ke.runKernelFunc((e,s)=>{s([r]);const o=E(t,r.shape),a=st(o,r.rank);let i=o,u=r;null!=a&&(u=r.transpose(a),i=at(i.length,r.rank));let l=e.sum(u,i);if(n){const e=rt(l.shape,o);l=l.reshape(e)}return l},s,null,"Sum",o)}}),ut={kernelName:"Atan2",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{const t=Ze(qe(n),qe(r));let o=Te(e,Be(r,t));const a=Ke(n.shape,s);return a.length>0&&(o=it(o,a)),Qe(o,n.shape)},b:()=>{const t=Ze(qe(n),qe(r));let o=Re(Te(e,Be(n,t)));const a=Ke(r.shape,s);return a.length>0&&(o=it(o,a)),Qe(o,r.shape)}}}},lt={kernelName:"Atan",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,Ze(qe(Ae(n,"float32")),1))}}},ct={kernelName:"Atanh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,Le(Pe(1),qe(Ae(n,"float32"))))}}};function ht(e,t,n,r,s,o,a="channelsLast"){const[i,u]=gt(t);let l;if("channelsLast"===a)l=[i,u,e[3],e[3]];else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);l=[i,u,e[1],e[1]]}return dt(e,l,n,r,s,o,!1,a)}function pt(e,t,n,r,s,o,a="NDHWC"){const[i,u,l]=bt(t);let c,h;if("NDHWC"===a)h="channelsLast",c=[i,u,l,e[4],e[4]];else{if("NCDHW"!==a)throw new Error("Unknown dataFormat "+a);h="channelsFirst",c=[i,u,l,e[1],e[1]]}return ft(e,c,n,r,s,!1,h,o)}function dt(e,t,n,r,s,o,a=!1,i="channelsLast"){let[u,l,c,h]=[-1,-1,-1,-1];if("channelsLast"===i)[u,l,c,h]=e;else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);[u,h,l,c]=e}const[p,d,,f]=t,[g,b]=gt(n),[y,w]=gt(r),k=yt(p,y),x=yt(d,w),{padInfo:S,outHeight:E,outWidth:D}=function(e,t,n,r,s,o,a,i,u){let l,c,h;if("number"==typeof e){l={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};const s=function(e,t,n,r,s){null==r&&(r=mt(e,t,n));const o=e[0],a=e[1],i=wt((o-t+2*r)/n+1,s);m(v(i),()=>`The output # of rows (${i}) must be an integer. Change the stride and/or zero pad parameters`);const u=wt((a-t+2*r)/n+1,s);return m(v(u),()=>`The output # of columns (${u}) must be an integer. Change the stride and/or zero pad parameters`),[i,u]}([t,n],o,r,e,i);c=s[0],h=s[1]}else if("same"===e){c=Math.ceil(t/r),h=Math.ceil(n/s);const e=Math.max(0,(c-1)*r+o-t),i=Math.max(0,(h-1)*s+a-n),u=Math.floor(e/2),p=e-u,d=Math.floor(i/2);l={top:u,bottom:p,left:d,right:i-d,type:"SAME"}}else if("valid"===e)l={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((t-o+1)/r),h=Math.ceil((n-a+1)/s);else{if("object"!=typeof e)throw Error("Unknown padding parameter: "+e);{const p="channelsLast"===u?e[1][0]:e[2][0],d="channelsLast"===u?e[1][1]:e[2][1],f="channelsLast"===u?e[2][0]:e[3][0],m="channelsLast"===u?e[2][1]:e[3][1];l={top:p,bottom:d,left:f,right:m,type:0===p&&0===d&&0===f&&0===m?"VALID":"EXPLICIT"},c=wt((t-o+p+d)/r+1,i),h=wt((n-a+f+m)/s+1,i)}}return{padInfo:l,outHeight:c,outWidth:h}}(s,l,c,g,b,k,x,o,i),N=a?f*h:f;let I;return"channelsFirst"===i?I=[u,N,E,D]:"channelsLast"===i&&(I=[u,E,D,N]),{batchSize:u,dataFormat:i,inHeight:l,inWidth:c,inChannels:h,outHeight:E,outWidth:D,outChannels:N,padInfo:S,strideHeight:g,strideWidth:b,filterHeight:p,filterWidth:d,effectiveFilterHeight:k,effectiveFilterWidth:x,dilationHeight:y,dilationWidth:w,inShape:e,outShape:I,filterShape:t}}function ft(e,t,n,r,s,o=!1,a="channelsLast",i){let[u,l,c,h,p]=[-1,-1,-1,-1,-1];if("channelsLast"===a)[u,l,c,h,p]=e;else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);[u,p,l,c,h]=e}const[d,f,g,,b]=t,[y,w,k]=bt(n),[x,S,E]=bt(r),D=yt(d,x),N=yt(f,S),I=yt(g,E),{padInfo:F,outDepth:A,outHeight:T,outWidth:M}=function(e,t,n,r,s,o,a,i,u,l,c){let h,p,d,f;if("number"==typeof e){h={top:e,bottom:e,left:e,right:e,front:e,back:e,type:0===e?"VALID":"NUMBER"};const o=function(e,t,n,r,s,o){null==s&&(s=mt(e,t,r));const a=e[0],i=e[1],u=e[2],l=wt((a-t+2*s)/r+1,o);m(v(l),()=>`The output # of depths (${l}) must be an integer. Change the stride and/or zero pad parameters`);const c=wt((i-t+2*s)/r+1,o);m(v(c),()=>`The output # of rows (${c}) must be an integer. Change the stride and/or zero pad parameters`);const h=wt((u-t+2*s)/r+1,o);return m(v(h),()=>`The output # of columns (${h}) must be an integer. Change the stride and/or zero pad parameters`),[l,c,h,n]}([t,n,r,1],i,1,s,e,c);p=o[0],d=o[1],f=o[2]}else if("same"===e){p=Math.ceil(t/s),d=Math.ceil(n/o),f=Math.ceil(r/a);const e=(p-1)*s+i-t,c=(d-1)*o+u-n,m=(f-1)*a+l-r,g=Math.floor(e/2),b=e-g,y=Math.floor(c/2),w=c-y,k=Math.floor(m/2);h={top:y,bottom:w,left:k,right:m-k,front:g,back:b,type:"SAME"}}else{if("valid"!==e)throw Error("Unknown padding parameter: "+e);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},p=Math.ceil((t-i+1)/s),d=Math.ceil((n-u+1)/o),f=Math.ceil((r-l+1)/a)}return{padInfo:h,outDepth:p,outHeight:d,outWidth:f}}(s,l,c,h,y,w,k,D,N,I,i),$=o?b*p:b;let _;return"channelsFirst"===a?_=[u,$,A,T,M]:"channelsLast"===a&&(_=[u,A,T,M,$]),{batchSize:u,dataFormat:a,inDepth:l,inHeight:c,inWidth:h,inChannels:p,outDepth:A,outHeight:T,outWidth:M,outChannels:$,padInfo:F,strideDepth:y,strideHeight:w,strideWidth:k,filterDepth:d,filterHeight:f,filterWidth:g,effectiveFilterDepth:D,effectiveFilterHeight:N,effectiveFilterWidth:I,dilationDepth:x,dilationHeight:S,dilationWidth:E,inShape:e,outShape:_,filterShape:t}}function mt(e,t,n,r=1){const s=yt(t,r);return Math.floor((e[0]*(n-1)-n+s)/2)}function gt(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function bt(e){return"number"==typeof e?[e,e,e]:e}function yt(e,t){return t<=1?e:e+(e-1)*(t-1)}function wt(e,t){if(!t)return e;switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error("Unknown roundingMode "+t)}}function kt(e){const[t,n,r]=gt(e);return 1===t&&1===n&&1===r}function vt(e,t){return kt(e)||kt(t)}function xt(e){if("NHWC"===e)return"channelsLast";if("NCHW"===e)return"channelsFirst";throw new Error("Unknown dataFormat "+e)}const St=Fe({avgPool3dBackprop_:function(e,t,n,r,s=[1,1,1],o,a){const i=Ne(e,"dy","avgPool3dBackprop"),u=Ne(t,"input","avgPool3dBackprop");let l=i,c=u,h=!1;4===u.rank&&(h=!0,l=Qe(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]]),c=Qe(u,[1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]])),m(5===l.rank,()=>"Error in avgPool3dBackprop: dy must be rank 5 but got rank "+l.rank+"."),m(5===c.rank,()=>"Error in avgPool3dBackprop: input must be rank 5 but got rank "+c.rank+"."),m(vt(r,s),()=>`Error in avgPool3dBackprop: Either strides or dilations must be 1. Got strides ${r} and dilations '${s}'`),null!=a&&m(v(o),()=>`Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode ${a} but got pad ${o}.`);const p={dy:l,input:c},d={filterSize:n,strides:r,dilations:s,pad:o,dimRoundingMode:a},f=ke.runKernelFunc(e=>{const t=pt(c.shape,n,r,s,o,a);return e.avgPool3dBackprop(l,c,t)},p,null,"AvgPool3DBackprop",d);return h?Qe(f,[f.shape[1],f.shape[2],f.shape[3],f.shape[4]]):f}}),Et={kernelName:"AvgPool3D",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{filterSize:s,strides:o,dilations:a,pad:i,dimRoundingMode:u}=n,l=null==a?[1,1,1]:a;return{x:()=>St(e,r,s,o,l,i,u)}}};const Dt=Fe({avgPoolBackprop_:function(e,t,n,r,s){const o=Ne(e,"dy","avgPoolBackprop"),a=Ne(t,"input","avgPoolBackprop");m(a.rank===o.rank,()=>`Rank of input (${a.rank}) does not match rank of dy (${o.rank})`);let i=a,u=o,l=!1;3===a.rank&&(l=!0,i=Qe(a,[1,a.shape[0],a.shape[1],a.shape[2]]),u=Qe(o,[1,o.shape[0],o.shape[1],o.shape[2]])),m(4===u.rank,()=>"Error in avgPoolBackprop: dy must be rank 4 but got rank "+u.rank+"."),m(4===i.rank,()=>"Error in avgPoolBackprop: input must be rank 4 but got rank "+i.rank+".");const c={dy:u,input:i},h={filterSize:n,strides:r,pad:s},p=ke.runKernelFunc(e=>{const t=ht(i.shape,n,r,1,s);return e.avgPoolBackprop(u,i,t)},c,null,"AvgPoolBackprop",h);return l?Qe(p,[p.shape[1],p.shape[2],p.shape[3]]):p}}),Nt={kernelName:"AvgPool",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{filterSize:s,strides:o,pad:a}=n;return{x:()=>Dt(e,r,s,o,a)}}};const It=Fe({matMul_:function(e,t,n=!1,r=!1){let s=Ne(e,"a","matMul"),o=Ne(t,"b","matMul");[s,o]=fe(s,o),m(s.rank>=2&&o.rank>=2&&s.rank===o.rank,()=>`Error in matMul: inputs must have the same rank of at least 2, got ranks ${s.rank} and ${o.rank}.`);const a=n?s.shape[s.rank-2]:s.shape[s.rank-1],i=r?o.shape[o.rank-1]:o.shape[o.rank-2],u=n?s.shape[s.rank-1]:s.shape[s.rank-2],l=r?o.shape[o.rank-2]:o.shape[o.rank-1],c=s.shape.slice(0,-2),h=o.shape.slice(0,-2),p=w(c),d=w(h);m(k(c,h),()=>`Error in matMul: outer dimensions (${c}) and (${h}) of Tensors with shapes ${s.shape} and `+o.shape+" must match."),m(a===i,()=>`Error in matMul: inner shapes (${a}) and (${i}) of Tensors with shapes ${s.shape} and ${o.shape} and transposeA=${n} and transposeB=${r} must match.`);const f=s.shape.slice(0,-2).concat([u,l]),g=Qe(s,n?[p,a,u]:[p,u,a]),b=Qe(o,r?[d,l,i]:[d,i,l]),y={a:g,b:b},v={transposeA:n,transposeB:r},x=ke.runKernelFunc((e,t)=>(t([g,b]),e.batchMatMul(g,b,n,r)),y,null,"BatchMatMul",v);return Qe(x,f)}}),Ft={kernelName:"BatchMatMul",inputsToSave:["a","b"],gradFunc:(e,t,n)=>{const[r,s]=t,{transposeA:o,transposeB:a}=n;return o||a?!o&&a?{a:()=>It(e,s,!1,!1),b:()=>It(e,r,!0,!1)}:o&&!a?{a:()=>It(s,e,!1,!0),b:()=>It(r,e,!1,!1)}:{a:()=>It(s,e,!0,!0),b:()=>It(e,r,!0,!0)}:{a:()=>It(e,s,!1,!0),b:()=>It(r,e,!0,!1)}}};const At=Fe({spaceToBatchND_:function(e,t,n){const r=Ne(e,"x","spaceToBatchND");m(r.rank>=1+t.length,()=>`input rank ${r.rank} should be > than [blockShape] ${t.length}`),m(n.length===t.length,()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${t.length}`),m(r.shape.reduce((e,r,s)=>s>0&&s<=t.length?e&&(r+n[s-1][0]+n[s-1][1])%t[s-1]==0:e,!0),()=>`input spatial dimensions ${r.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${t.toString()}`);const s={x:r},o={blockShape:t,paddings:n};return ke.runKernelFunc(e=>e.spaceToBatchND(r,t,n),s,null,"SpaceToBatchND",o)}}),Tt={kernelName:"BatchToSpaceND",gradFunc:(e,t,n)=>{const{blockShape:r,crops:s}=n;return{x:()=>At(e,r,s)}}},Mt={kernelName:"BroadcastTo",gradFunc:(e,t,n)=>{const r=n,s=r.inputShape,o=r.shape,a=Array.from(o);for(let e=s.length-1;e>=0;e--)if(s[e]===o[e])a[e]=1;else if(1!==s[e])throw new Error(`broadcastTo(): [${s}] cannot be broadcast to [${o}].`);const i=[];for(let e=0;e<a.length;e++)a[e]>1&&i.push(e);return{x:()=>it(e,i,!0)}}},$t={kernelName:"Cast",gradFunc:e=>({x:()=>e.clone()})},_t={kernelName:"Ceil",gradFunc:e=>({x:()=>He(e)})};const Bt=Fe({greaterEqual_:function(e,t){let n=Ne(e,"a","greaterEqual"),r=Ne(t,"b","greaterEqual");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.greaterEqual(n,r);return t([n,r]),s},s,null,"GreaterEqual")}});const Rt=Fe({lessEqual_:function(e,t){let n=Ne(e,"a","lessEqual"),r=Ne(t,"b","lessEqual");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.lessEqual(n,r);return t([n,r]),s},s,null,"LessEqual")}});const Ct=Fe({logicalAnd_:function(e,t){const n=Ne(e,"a","logicalAnd","bool"),r=Ne(t,"b","logicalAnd","bool");Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc(e=>e.logicalAnd(n,r),s,null,"LogicalAnd")}});const Pt=Fe({where_:function(e,t,n){const r=Ne(t,"a","where"),s=Ne(n,"b","where"),o=Ne(e,"condition","where","bool"),a=Ge(r.shape,s.shape),i=r.broadcastTo(a),u=s.broadcastTo(a);1===o.rank&&m(o.shape[0]===r.shape[0],()=>"The first dimension of `a` must match the size of `condition`."),1!==o.rank&&g(o.shape,u.shape,"Error in where: ");const l={condition:o,t:i,e:u};return ke.runKernelFunc((e,t)=>{const n=e.select(o,i,u);return t([o]),n},l,null,"SelectV2")}}),zt={kernelName:"ClipByValue",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{clipValueMin:s,clipValueMax:o}=n;return{x:()=>Pt(Ct(Bt(r,s),Rt(r,o)),e,He(e))}}};function qt(e,t,n=0){let r=[];if("number"==typeof t)m(e.shape[n]%t==0,()=>"Number of splits must evenly divide the axis."),r=new Array(t).fill(e.shape[n]/t);else{m(t.reduce((e,t)=>(-1===t&&(e+=1),e),0)<=1,()=>"There should be only one negative value in split array.");const s=t.indexOf(-1);if(-1!==s){const r=t.reduce((e,t)=>t>0?e+t:e);t[s]=e.shape[n]-r}m(e.shape[n]===t.reduce((e,t)=>e+t),()=>"The sum of sizes must match the size of the axis dimension."),r=t}return r}const Lt=Fe({split_:function(e,t,n=0){const r=Ne(e,"x","split"),s={x:r},o={numOrSizeSplits:t,axis:n};return ke.runKernelFunc((e,s)=>{const o=E(n,r.shape)[0],a=qt(r,t,o);return e.split(r,a,o)},s,null,"SplitV",o)}}),Ot={kernelName:"Concat",saveAllInputs:!0,gradFunc:(e,t,n)=>{const r=t.map(e=>e.shape),{axis:s}=n,o=E(s,t[0].shape)[0],a=r.map(e=>e[o]);return Lt(e,a,o).map(e=>()=>e)}};const Wt=Fe({conv2DBackpropFilter_:function(e,t,n,r,s,o="NHWC",a){let i=e;3===e.rank&&(i=Qe(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let u=t;3===u.rank&&(u=Qe(t,[1,t.shape[0],t.shape[1],t.shape[2]])),m(4===i.rank,()=>"Error in conv2dDerFilter: input must be rank 4, but got shape "+i.shape+"."),m(4===u.rank,()=>"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."),m(4===n.length,()=>"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+".");const l="NHWC"===o?i.shape[3]:i.shape[1],c="NHWC"===o?u.shape[3]:u.shape[1];m(l===n[2],()=>`Error in conv2dDerFilter: depth of input ${l}) must match input depth in filter (${n[2]}.`),m(c===n[3],()=>`Error in conv2dDerFilter: depth of dy (${c}) must match output depth for filter (${n[3]}).`),null!=a&&m(v(s),()=>`Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode ${a} but got pad ${s}.`);const h={x:i,dy:u},p={strides:r,pad:s,dataFormat:o,dimRoundingMode:a};return ke.runKernelFunc(e=>{const t=xt(o),l=dt(i.shape,n,r,1,s,a,!1,t);return e.conv2dDerFilter(i,u,l)},h,null,"Conv2DBackpropFilter",p)}});const Kt=Fe({conv2DBackpropInput_:function(e,t,n,r,s,o="NHWC",a){m(e.length===t.rank,()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`);let i=e,u=t,l=!1;3===t.rank&&(l=!0,u=Qe(t,[1,t.shape[0],t.shape[1],t.shape[2]]),i=[1,e[0],e[1],e[2]]),m(4===i.length,()=>"Error in conv2dDerInput: inShape must be length 4, but got length "+i.length+"."),m(4===u.rank,()=>"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank),m(4===n.rank,()=>"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank);const c="NHWC"===o?i[3]:i[1],h="NHWC"===o?u.shape[3]:u.shape[1];m(c===n.shape[2],()=>`Error in conv2dDerInput: depth of input (${c}) must match input depth for filter ${n.shape[2]}.`),m(h===n.shape[3],()=>`Error in conv2dDerInput: depth of output (${h}) must match output depth for filter ${n.shape[3]}.`),null!=a&&m(v(s),()=>`Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode ${a} but got pad ${s}.`);const p={dy:u,filter:n},d={strides:r,pad:s,dataFormat:o,dimRoundingMode:a,inputShape:i},f=ke.runKernelFunc((e,t)=>{const l=xt(o),c=dt(i,n.shape,r,1,s,a,!1,l),h=e.conv2dDerInput(u,n,c);return t([u,n]),h},p,null,"Conv2DBackpropInput",d);return l?Qe(f,[f.shape[1],f.shape[2],f.shape[3]]):f}}),Gt={kernelName:"Conv2D",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const[r,s]=t,{dilations:o,strides:a,pad:i,dataFormat:u}=n;return m(kt(o),()=>`Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${o}'`),{x:()=>Kt(r.shape,e,s,a,i,u),filter:()=>Wt(r,e,s.shape,a,i,u)}}};const Ut=Fe({conv2d_:function(e,t,n,r,s="NHWC",o=[1,1],a){const i=Ne(e,"x","conv2d"),u=Ne(t,"filter","conv2d");let l=i,c=!1;3===i.rank&&(c=!0,l=Qe(i,[1,i.shape[0],i.shape[1],i.shape[2]])),m(4===l.rank,()=>`Error in conv2d: input must be rank 4, but got rank ${l.rank}.`),m(4===u.rank,()=>"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."),null!=a&&m(v(r),()=>`Error in conv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`);const h="NHWC"===s?l.shape[3]:l.shape[1];m(h===u.shape[2],()=>`Error in conv2d: depth of input (${h}) must match input depth for filter ${u.shape[2]}.`),m(vt(n,o),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`);const p={x:l,filter:u},d={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a},f=ke.runKernelFunc((e,t)=>{const i=xt(s),c=dt(l.shape,u.shape,n,o,r,a,!1,i),h=e.conv2d(l,u,c);return t([l,u]),h},p,null,"Conv2D",d);return c?Qe(f,[f.shape[1],f.shape[2],f.shape[3]]):f}}),Vt={kernelName:"Conv2DBackpropInput",inputsToSave:["dy","filter"],gradFunc:(e,t,n)=>{const[r,s]=t,{strides:o,pad:a,dataFormat:i,dimRoundingMode:u}=n;return{dy:()=>Ut(e,s,o,a,i,1,u),filter:()=>Wt(e,r,s.shape,o,a,i,u)}}};const Ht=Fe({conv3DBackpropFilter_:function(e,t,n,r,s){let o=e;4===e.rank&&(o=Qe(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]]));let a=t;4===a.rank&&(a=Qe(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]])),m(5===o.rank,()=>"Error in conv3dDerFilter: input must be rank 5, but got shape "+o.shape+"."),m(5===a.rank,()=>"Error in conv3dDerFilter: dy must be rank 5, but got shape "+a.shape+"."),m(5===n.length,()=>"Error in conv3dDerFilter: filterShape must be length 5, but got "+n+"."),m(o.shape[4]===n[3],()=>`Error in conv3dDerFilter: depth of input ${o.shape[4]}) must match input depth in filter (${n[3]}.`),m(a.shape[4]===n[4],()=>`Error in conv3dDerFilter: depth of dy (${a.shape[4]}) must match output depth for filter (${n[4]}).`);const i={x:o,y:a},u={strides:r,pad:s};return ke.runKernelFunc(e=>{const t=ft(o.shape,n,r,1,s);return e.conv3dDerFilter(o,a,t)},i,null,"Conv3DBackpropFilterV2",u)}});const jt=Fe({conv3DBackpropInput_:function(e,t,n,r,s){m(e.length===t.rank,()=>`Length of inShape (${e.length}) and rank of dy (${t.rank}) must match`);let o=e,a=t,i=!1;4===t.rank&&(i=!0,a=Qe(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),o=[1,e[0],e[1],e[2],e[3]]);const u=o[4],l=a.shape[4];m(5===o.length,()=>"Error in conv3dDerInput: inShape must be length 5, but got length "+o.length+"."),m(5===a.rank,()=>"Error in conv3dDerInput: dy must be rank 5, but got rank "+a.rank),m(5===n.rank,()=>"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank),m(u===n.shape[3],()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`),m(l===n.shape[4],()=>`Error in conv3dDerInput: depth of output (${l}) must match output depth for filter ${n.shape[4]}.`);const c={dy:a},h={pad:s},p=ke.runKernelFunc(e=>{const t=ft(o,n.shape,r,1,s);return e.conv3dDerInput(a,n,t)},c,null,"Conv3DBackpropInputV2",h);return i?Qe(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}}),Jt={kernelName:"Conv3D",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const{dilations:r,strides:s,pad:o}=n;m(kt(r),()=>`Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${r}'`);const[a,i]=t;return{x:()=>jt(a.shape,e,i,s,o),filter:()=>Ht(a,e,i.shape,s,o)}}};const Yt=Fe({sin_:function(e){const t=Ne(e,"x","sin"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.sin(t);return n([t]),r},n,null,"Sin")}}),Zt={kernelName:"Cos",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(Re(Yt(Ae(n,"float32"))),e)}}};const Xt=Fe({sinh_:function(e){const t=Ne(e,"x","sinh"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.sinh(t);return n([t]),r},n,null,"Sinh")}}),Qt={kernelName:"Cosh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(Xt(Ae(n,"float32")),e)}}};const en=Fe({transpose_:function(e,t){const n=Ne(e,"x","transpose");if(null==t&&(t=n.shape.map((e,t)=>t).reverse()),m(n.rank===t.length,()=>`Error in transpose: rank of input ${n.rank} must match length of perm ${t}.`),t.forEach(e=>{m(e>=0&&e<n.rank,()=>"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+t)}),n.rank<=1)return n.clone();const r={x:n},s={perm:t};return ke.runKernelFunc(e=>e.transpose(n,t),r,null,"Transpose",s)}});const tn=Fe({cumsum_:function(e,t=0,n=!1,r=!1){const s=Ne(e,"x","cumsum"),o={x:s},a={axis:t,exclusive:n,reverse:r};return ke.runKernelFunc((e,o)=>{const a=st([t],s.rank);let i=s;null!=a&&(i=en(s,a));const u=at(1,s.rank)[0];let l=e.cumsum(i,u,n,r);if(o([s]),null!=a){const e=ot(a);l=en(l,e)}return l},o,null,"Cumsum",a)}}),nn={kernelName:"Cumsum",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{axis:s,exclusive:o,reverse:a}=n;return{x:()=>{const t=st([s],r.rank);let n=tn(e,s,o,!a);return null!=t&&(n=en(n,t)),n}}}};const rn=Fe({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r){let s=e;3===e.rank&&(s=Qe(e,[1,e.shape[0],e.shape[1],e.shape[2]]));let o=t;3===o.rank&&(o=Qe(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const a={x:s,dy:o};return ke.runKernelFunc(e=>e.depthwiseConv2DDerFilter(s,o,r),a,null,"DepthwiseConv2dNativeBackpropFilter")}});const sn=Fe({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r){let s=t,o=!1;3===t.rank&&(o=!0,s=Qe(t,[1,t.shape[0],t.shape[1],t.shape[2]]));const a={dy:s},i=ke.runKernelFunc(e=>e.depthwiseConv2DDerInput(s,n,r),a,null,"DepthwiseConv2dNativeBackpropInput");return o?Qe(i,[i.shape[1],i.shape[2],i.shape[3]]):i}}),on={kernelName:"DepthwiseConv2dNative",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const{dilations:r,strides:s,pad:o,dimRoundingMode:a}=n,i=null==r?[1,1]:r;m(kt(i),()=>`Error in gradient of depthwiseConv2dNative: dilation rates greater than 1 are not yet supported. Got dilations '${i}'`);const[u,l]=t;m(4===u.rank,()=>`Error in gradient of depthwiseConv2dNative: input must be rank 4, but got rank ${u.rank}.`),m(4===l.rank,()=>`Error in gradient of depthwiseConv2dNative: filter must be rank 4, but got rank ${l.rank}.`),m(u.shape[3]===l.shape[2],()=>`Error in gradient of depthwiseConv2d: number of input channels (${u.shape[3]}) must match the inChannels dimension in filter ${l.shape[2]}.`),m(vt(s,i),()=>`Error in gradient of depthwiseConv2d: Either strides or dilations must be  1. Got strides ${s} and dilations '${i}'.`),null!=a&&m(v(o),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${o}.`);const c=dt(u.shape,l.shape,s,i,o,a,!0);return{x:()=>sn(u.shape,e,l,c),filter:()=>rn(u,e,l.shape,c)}}},an={kernelName:"Dilation2D",inputsToSave:["x","filter"],gradFunc:(e,t,n)=>{const[r,s]=t,o={x:r,filter:s,dy:e},a={x:r,filter:s,dy:e};return{x:()=>ke.runKernel("Dilation2DBackpropInput",o,n),filter:()=>ke.runKernel("Dilation2DBackpropFilter",a,n)}}},un={kernelName:"Div",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{const t=Be(e,r.toFloat()),o=Ke(n.shape,s);return o.length>0?it(t,o).reshape(n.shape):t},b:()=>{let t=Te(e,n.toFloat());const o=Ke(r.shape,s);o.length>0&&(t=Qe(it(t,o),r.shape));const a=qe(r);return Re(Be(t,a.toFloat()))}}}},ln={kernelName:"Elu",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t,r=t=>t.eluDer(e,n),s={dy:e,y:n};return{x:()=>ke.runKernelFunc(r,s,null,"EluGrad")}}};const cn=Fe({exp_:function(e){const t=Ne(e,"x","exp"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.exp(t);return n([r]),r},n,null,"Exp")}}),hn={kernelName:"Erf",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t,r=Te(cn(Re(qe(n))),2/Math.sqrt(Math.PI));return{x:()=>Te(e,r)}}},pn={kernelName:"Exp",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,n)}}},dn={kernelName:"Expm1",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,cn(n))}}},fn={kernelName:"Floor",gradFunc:e=>({x:()=>He(e)})},mn={kernelName:"FloorDiv",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{const t=e.div(r.toFloat()),o=Ke(n.shape,s);return o.length>0?t.sum(o).reshape(n.shape):t},b:()=>{let t=e.mul(n.toFloat());const o=Ke(r.shape,s);o.length>0&&(t=t.sum(o).reshape(r.shape));const a=r.square();return t.div(a.toFloat()).neg()}}}};const gn=Fe({rsqrt_:function(e){const t=Ne(e,"x","rsqrt"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.rsqrt(t);return n([t]),r},n,null,"Rsqrt")}});const bn=Fe({tile_:function(e,t){const n=Ne(e,"x","tile",null);m(n.rank===t.length,()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${t}.`);const r=[n],s={x:n},o={reps:t};return ke.runKernelFunc((e,r)=>{const s=e.tile(n,t);return r([n]),s},s,null,"Tile",o,r)}}),yn={kernelName:"FusedBatchNorm",inputsToSave:["x","mean","variance","scale"],gradFunc:(e,t,n)=>{const{varianceEpsilon:r}=n,[s,o,a,i]=t,u=null==i?Pe(1):i,l=Ke(o.shape,s.shape),c=[];if(1===o.rank){for(let e=0;e<s.shape.length-1;++e)c.push(s.shape[e]);c.push(1)}const h=Le(s,o),p=Te(e,u),d=gn(Ze(a,Pe(r))),f=Te(Te(Te(d,d),d),Pe(-.5));return{x:()=>1===o.rank?Qe(Te(Te(e,bn(d.as4D(1,1,1,o.shape[0]),c)),u),s.shape):Qe(Te(Te(e,d),u),s.shape),mean:()=>{let e=Te(Te(d,Pe(-1)),p);return 1===o.rank&&(e=it(e,l)),Qe(e,o.shape)},variance:()=>{let e=Te(Te(f,h),p);return 1===o.rank&&(e=it(e,l)),Qe(e,o.shape)},scale:()=>{const t=Te(h,d);let n=Te(e,t);return 1===o.rank&&(n=it(n,l)),Qe(n,o.shape)},offset:()=>{let t=e;return 1===o.rank&&(t=it(t,l)),Qe(t,o.shape)}}}};const wn=Fe({unsortedSegmentSum_:function(e,t,n){const r=Ne(e,"x","unsortedSegmentSum"),s=Ne(t,"segmentIds","unsortedSegmentSum","int32");m(v(n),()=>"numSegments must be of dtype int");const o={x:r,segmentIds:s},a={numSegments:n};return ke.runKernelFunc((e,t)=>{const o=e.unsortedSegmentSum(r,s,n);return t([s]),o},o,null,"UnsortedSegmentSum",a)}}),kn={kernelName:"GatherV2",inputsToSave:["x","indices"],gradFunc:(e,t,n)=>{const[r,s]=t,{axis:o}=n,a=E(o,r.shape)[0];return{x:()=>{const t=r.shape,n=s.size,i=t.slice(0,a),u=i.length,l=t.slice(o,t.length).slice(1),c=l.length,h=vn(0,u),p=vn(u+1,u+1+c),d=xn([i,[n],l]),f=Qe(e,d),m=Qe(s,[n]),g=xn([[u],h,p]),b=en(f,g);let y=wn(b,m,r.shape[a]);const w=ot(g);return y=en(y,w),y},indices:()=>s}}};function vn(e,t){const n=[];for(let r=e;r<t;++r)n.push(r);return n}function xn(e){const t=[];for(let n=0;n<e.length;++n)for(let r=0;r<e[n].length;++r)t.push(e[n][r]);return t}const Sn={kernelName:"GreaterEqual",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t;return{a:()=>He(n),b:()=>He(r)}}},En={kernelName:"Identity",gradFunc:e=>({x:()=>e.toFloat()})},Dn={kernelName:"IsFinite",gradFunc:e=>({x:()=>He(e)})},Nn={kernelName:"IsInf",gradFunc:e=>({x:()=>He(e)})},In={kernelName:"IsNan",gradFunc:e=>({x:()=>He(e)})},Fn={kernelName:"Log1p",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,Ze(n,1))}}},An={kernelName:"Log",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,Ae(n,"float32"))}}},Tn={kernelName:"LogSoftmax",inputsToSave:[],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r]=t,{axis:s}=n;return{logits:()=>{const t=r.exp();return e.sub(e.sum(s,!0).mul(t))}}}};const Mn=Fe({localResponseNormalizationBackprop_:function(e,t,n,r=5,s=1,o=1,a=.5){const i={x:e,y:t,dy:n},u={depthRadius:r,bias:s,alpha:o,beta:a};return ke.runKernelFunc(i=>i.LRNGrad(n,e,t,r,s,o,a),i,null,"LRNBackprop",u)}}),$n={kernelName:"LRN",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r,s]=t,{depthRadius:o,bias:a,alpha:i,beta:u}=n;return{x:()=>Mn(r,s,e,o,a,i,u)}}};const _n=Fe({equal_:function(e,t){let n=Ne(e,"a","equal"),r=Ne(t,"b","equal");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc(e=>e.equal(n,r),s,null,"Equal")}});function Bn(e,t,n,r,s){return t.rank<n.rank&&(t=Qe(t,rt(t.shape,r))),e.rank<n.rank&&(e=Qe(e,rt(e.shape,r))),{x:()=>{const r=Te(e,Ae(_n(n,t),e.dtype));return null==s?r:en(r,s)}}}const Rn={kernelName:"Max",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const r=n,{reductionIndices:s}=r,[o,a]=t,i=E(s,o.shape),u=st(i,o.rank),l=Bn(e,a,o,i,u);return{x:()=>{let e=l.x();return null!=u&&(e=en(e)),e}}}};const Cn=Fe({less_:function(e,t){let n=Ne(e,"a","less"),r=Ne(t,"b","less");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc(e=>e.less(n,r),s,null,"Less")}}),Pn={kernelName:"Maximum",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t;return{a:()=>Te(e,Ae(Bt(n,r),"float32")),b:()=>Te(e,Ae(Cn(n,r),"float32"))}}};const zn=Fe({maxPool3dBackprop_:function(e,t,n,r,s,o=[1,1,1],a,i){const u=Ne(e,"dy","maxPool3dBackprop"),l=Ne(t,"input","maxPool3dBackprop"),c=Ne(n,"output","maxPool3dBackprop");let h=u,p=l,d=c,f=!1;4===l.rank&&(f=!0,h=Qe(u,[1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]]),p=Qe(l,[1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]]),d=Qe(c,[1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]])),m(5===h.rank,()=>"Error in maxPool3dBackprop: dy must be rank 5 but got rank "+h.rank+"."),m(5===p.rank,()=>"Error in maxPool3dBackprop: input must be rank 5 but got rank "+p.rank+"."),m(5===d.rank,()=>"Error in maxPool3dBackprop: output must be rank 5 but got rank "+d.rank+"."),m(vt(s,o),()=>`Error in maxPool3dBackprop: Either strides or dilations must be 1. Got strides ${s} and dilations '${o}'`),null!=i&&m(v(a),()=>`Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode ${i} but got pad ${a}.`);const g={dy:h,input:p,output:d},b={filterSize:r,strides:s,dilations:o,pad:a,dimRoundingMode:i},y=ke.runKernelFunc(e=>{const t=pt(p.shape,r,s,o,a,i);return e.maxPool3dBackprop(h,p,d,t)},g,null,"MaxPool3DBackprop",b);return f?Qe(y,[y.shape[1],y.shape[2],y.shape[3],y.shape[4]]):y}}),qn={kernelName:"MaxPool3D",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r,s]=t,{filterSize:o,strides:a,dilations:i,pad:u,dimRoundingMode:l}=n,c=null==i?[1,1,1]:i;return{x:()=>zn(e,r,s,o,a,c,u,l)}}};const Ln=Fe({maxPoolBackprop_:function(e,t,n,r,s,o,a){const i=Ne(e,"dy","maxPoolBackprop"),u=Ne(t,"input","maxPoolBackprop"),l=Ne(n,"output","maxPoolBackprop");m(u.rank===i.rank,()=>`Rank of input (${u.rank}) does not match rank of dy (${i.rank})`),m(4===i.rank,()=>"Error in maxPoolBackprop: dy must be rank 4 but got rank "+i.rank+"."),m(4===u.rank,()=>"Error in maxPoolBackprop: input must be rank 4 but got rank "+u.rank+"."),null!=a&&m(v(o),()=>`Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode ${a} but got pad ${o}.`);const c={dy:i,input:u,output:l},h={filterSize:r,strides:s,pad:o,dimRoundingMode:a};return ke.runKernelFunc(e=>{const t=ht(u.shape,r,s,1,o,a);return e.maxPoolBackprop(i,u,l,t)},c,null,"MaxPoolBackprop",h)}}),On={kernelName:"MaxPool",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r,s]=t,{filterSize:o,strides:a,pad:i}=n;return{x:()=>Ln(e,r,s,o,a,i)}}},Wn={kernelName:"Min",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(e,t,n)=>{const r=n,{axis:s}=r,[o,a]=t,i=E(s,o.shape),u=st(i,o.rank),l=Bn(e,a,o,i,u);return{x:()=>{let e=l.x();return null!=u&&(e=en(e)),e}}}};const Kn=Fe({greater_:function(e,t){let n=Ne(e,"a","greater"),r=Ne(t,"b","greater");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc(e=>e.greater(n,r),s,null,"Greater")}}),Gn={kernelName:"Minimum",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t;return{a:()=>Te(e,Ae(Rt(n,r),"float32")),b:()=>Te(e,Ae(Kn(n,r),"float32"))}}};const Un=Fe({floor_:function(e){const t=Ne(e,"x","floor"),n={x:t};return ke.runKernelFunc(e=>e.floor(t),n,null,"Floor")}}),Vn={kernelName:"Mod",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{const t=Ke(n.shape,s);return t.length>0?Qe(it(e,t),n.shape):e},b:()=>{const t=Te(e,Re(Un(Be(n,r)))),o=Ke(r.shape,s);return o.length>0?Qe(it(t,o),r.shape):t}}}},Hn={kernelName:"Multiply",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{const t=Te(e,Ae(r,"float32")),o=Ke(n.shape,s);return o.length>0?Qe(it(t,o),n.shape):t},b:()=>{const t=Te(e,Ae(n,"float32")),o=Ke(r.shape,s);return o.length>0?Qe(it(t,o),r.shape):t}}}},jn={kernelName:"Negate",gradFunc:e=>({x:()=>Re(e)})};const Jn=Fe({complex_:function(e,t){const n=Ne(e,"real","complex"),r=Ne(t,"imag","complex");g(n.shape,r.shape,`real and imag shapes, ${n.shape} and ${r.shape}, must match in call to tf.complex().`);const s={real:n,imag:r};return ke.runKernelFunc(e=>e.complex(n,r),s,null,"Complex")}});function Yn(e,t="float32"){if("complex64"===t){const t=Yn(e,"float32"),n=Yn(e,"float32");return Jn(t,n)}const n=G(w(e),t);return ke.makeTensor(n,e,t)}const Zn={kernelName:"OneHot",inputsToSave:["indices"],gradFunc:(e,t)=>{const n=t[0];return{indices:()=>Yn(n.shape,"float32")}}},Xn={kernelName:"OnesLike",gradFunc:e=>({x:()=>He(e)})},Qn={kernelName:"PadV2",inputsToSave:["x"],gradFunc:(e,t,n)=>{const r=t[0],{paddings:s}=n,o=s.map(e=>e[0]);return{x:()=>e.slice(o,r.shape)}}};const er=Fe({log_:function(e){const t=Ne(e,"x","log"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.log(t);return n([t]),r},n,null,"Log")}});const tr=Fe({pow_:function(e,t){let n=Ne(e,"base","pow"),r=Ne(t,"exp","pow");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.pow(n,r);return t([n,r,s]),s},s,null,"Pow")}}),nr={kernelName:"Pow",inputsToSave:["a","b"],outputsToSave:[!0],gradFunc:(e,t)=>{const[n,r,s]=t,o=n,a=r,i=Ge(o.shape,a.shape);return{a:()=>{const t=Ae(a,"float32");let n=Te(e,Te(t,tr(o,Le(t,Pe(1)))));const r=Ke(o.shape,i);return r.length>0&&(n=it(n,r)),Qe(n,o.shape)},b:()=>{const t=Kn(o,0),n=Pt(t,er(o),He(o));let r=Te(e,Te(s,n));const u=Ke(a.shape,i);return u.length>0&&(r=it(r,u)),Qe(r,a.shape)}}}},rr={kernelName:"Prelu",inputsToSave:["x","alpha"],gradFunc:(e,t)=>{const[n,r]=t,s=Kn(n,0);return{x:()=>Pt(s,e,Te(e,r)),alpha:()=>{let t=Pt(s,He(e),Te(e,n));const o=Ke(r.shape,e.shape);return o.length>0&&(t=it(t,o)),Qe(t,r.shape)}}}},sr={kernelName:"Reciprocal",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,Re(qe(n)))}}},or={kernelName:"Relu6",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t,r=Te(Rt(n,6),Me(n));return{x:()=>Te(e,Ae(r,"float32"))}}},ar={kernelName:"Relu",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,Ae(Me(n),"float32"))}}},ir={kernelName:"Reshape",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Qe(e,n.shape)}}},ur={kernelName:"ResizeBilinear",inputsToSave:["images"],gradFunc:(e,t,n)=>{const[r]=t,s=t=>{const{alignCorners:s}=n;return t.resizeBilinearBackprop(e,r,s)},o={images:r};return{images:()=>ke.runKernelFunc(s,o,null,"ResizeBilinearGrad",n)}}},lr={kernelName:"ResizeNearestNeighbor",inputsToSave:["images"],gradFunc:(e,t,n)=>{const[r]=t,s=t=>{const{alignCorners:s}=n;return t.resizeNearestNeighborBackprop(e,r,s)},o={images:r};return{images:()=>ke.runKernelFunc(s,o,null,"ResizeNearestNeighborGrad",n)}}};const cr=Fe({clone_:function(e){const t=Ne(e,"x","clone",null),n={x:t};return ke.runKernelFunc(()=>ke.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n,null,"Identity")}});const hr=Fe({reverse_:function(e,t){const n=Ne(e,"x","reverse"),r={x:n},s={dims:t};return ke.runKernelFunc(e=>{const r=E(t,n.shape);if(0===n.rank)return cr(n);const s=e.reverse(n,r);return Qe(s,n.shape)},r,null,"Reverse",s)}}),pr={kernelName:"Reverse",gradFunc:(e,t,n)=>{const{dims:r}=n,s=E(r,e.shape);return{x:()=>hr(e,s)}}},dr={kernelName:"Round",gradFunc:e=>({x:()=>He(e)})},fr={kernelName:"Rsqrt",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Re(Be(e,Te(tr(n,1.5),2)))}}};const mr=Fe({logicalNot_:function(e){const t=Ne(e,"x","logicalNot","bool"),n={x:t};return ke.runKernelFunc(e=>e.logicalNot(t),n,null,"LogicalNot")}}),gr={kernelName:"SelectV2",inputsToSave:["condition"],gradFunc:(e,t)=>{const[n]=t;return{condition:()=>Ae(He(n),"float32"),t:()=>Te(e,Ae(n,e.dtype)),e:()=>Te(e,Ae(mr(n),e.dtype))}}},br={kernelName:"Selu",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>{const t=Kn(n,Pe(0)),r=Pe(1.7580993408473768),s=Pe(1.0507009873554805),o=Te(e,s),a=Te(Te(e,r),cn(Ae(n,"float32")));return Pt(t,o,a)}}}},yr={kernelName:"Sigmoid",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,Te(n,Le(Pe(1),n)))}}},wr={kernelName:"Sign",gradFunc:e=>({x:()=>He(e)})};const kr=Fe({cos_:function(e){const t=Ne(e,"x","cos"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.cos(t);return n([t]),r},n,null,"Cos")}}),vr={kernelName:"Sin",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(kr(Ae(n,"float32")),e)}}};const xr=Fe({cosh_:function(e){const t=Ne(e,"x","cosh"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.cosh(t);return n([t]),r},n,null,"Cosh")}}),Sr={kernelName:"Sinh",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(xr(Ae(n,"float32")),e)}}};const Er=Fe({pad_:function(e,t,n=0){const r=Ne(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const s={paddings:t,constantValue:n},o={x:r};return ke.runKernelFunc((e,s)=>(s([r]),e.pad(r,t,n)),o,null,"PadV2",s)}});function Dr(e,t,n){m(e.rank===t.length,()=>`Error in slice${e.rank}D: Length of begin ${t} must match the rank of the array (${e.rank}).`),m(e.rank===n.length,()=>`Error in slice${e.rank}D: Length of size ${n} must match the rank of the array (${e.rank}).`);for(let r=0;r<e.rank;++r)m(t[r]+n[r]<=e.shape[r],()=>`Error in slice${e.rank}D: begin[${r}] + size[${r}] (${t[r]+n[r]}) would overflow input.shape[${r}] (${e.shape[r]})`)}function Nr(e){const t=[];let n=0;for(;e>0;)1&e&&t.push(n),e/=2,n++;return t}function Ir(e,t,n){const r=[];for(let s=0;s<e.length;s++)r[s]=Math.ceil((t[s]-e[s])/n[s]);return r}function Fr(e,t,n,r){const s=[...e];for(let e=s.length;e<r.length;e++)s.push(1);for(let e=0;e<n;e++)0===e?s[t]=1:(s.splice(t,0,1),s.pop());return s}function Ar(e,t,n){return n<=e?n:n-(t-1)}function Tr(e,t){const n=[];for(let r=0;r<e;r++)n.push(t+r);return n}function Mr(e,t,n,r,s){const o=[...s],a=Tr(n,t);for(let s=0;s<o.length;s++)if(a.indexOf(s)>-1)o[s]=0;else{const a=Ar(t,n,s);let i=r[a];e&1<<a&&(i=0),o[s]=i}return o}function $r(e,t,n,r,s){const o=[...s],a=Tr(n,t);for(let s=0;s<o.length;s++)if(a.indexOf(s)>-1)o[s]=Number.MAX_SAFE_INTEGER;else{const a=Ar(t,n,s);let i=r[a];e&1<<a&&(i=Number.MAX_SAFE_INTEGER),o[s]=i}for(let e=0;e<o.length;e++){const t=s[e];o[e]<0&&(o[e]+=t),o[e]=f(0,o[e],s[e])}return o}function _r(e,t,n){let r=e[t];return(n&1<<t||null==r)&&(r=1),r}function Br(e,t,n,r,s,o){let a=t[s];const i=n[s]||1;(e&1<<s||o&1<<s||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);const u=r[s];return a<0&&(a+=u),a=f(0,a,u-1),a}function Rr(e,t,n,r,s,o){let a=t[s];const i=n[s]||1;(e&1<<s||o&1<<s||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);const u=r[s];return a<0&&(a+=u),a=i>0?f(0,a,u):f(-1,a,u-1),a}function Cr(e,t,n){let r,s;return r="number"==typeof t?[t,...new Array(e.rank-1).fill(0)]:t.length<e.rank?t.concat(new Array(e.rank-t.length).fill(0)):t.slice(),r.forEach(e=>{m(-1!==e,()=>"slice() does not support negative begin indexing.")}),s=null==n?new Array(e.rank).fill(-1):"number"==typeof n?[n,...new Array(e.rank-1).fill(-1)]:n.length<e.rank?n.concat(new Array(e.rank-n.length).fill(-1)):n,s=s.map((t,n)=>t>=0?t:(m(-1===t,()=>`Negative size values should be exactly -1 but got ${t} for the slice() size at index ${n}.`),e.shape[n]-r[n])),[r,s]}var Pr=Object.freeze({__proto__:null,assertParamsValid:Dr,maskToAxes:Nr,computeOutShape:Ir,stridesWithElidedDims:Fr,startIndicesWithElidedDims:Mr,stopIndicesWithElidedDims:$r,stridesForAxis:_r,startForAxis:Br,stopForAxis:Rr,isSliceContinous:function(e,t,n){let r=n.length;for(let e=0;e<n.length;e++)if(n[e]>1){r=e;break}for(let s=r+1;s<n.length;s++)if(t[s]>0||n[s]!==e[s])return!1;return!0},computeFlatOffset:function(e,t){let n=e.length>0?e[e.length-1]:1;for(let r=0;r<e.length-1;r++)n+=e[r]*t[r];return n},parseSliceParams:Cr});const zr={kernelName:"Slice",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{begin:s,size:o}=n,a=r.shape,[i,u]=Cr(r,s,o),l=[];for(let t=0;t<e.rank;t++)l.push([i[t],a[t]-i[t]-u[t]]);return{x:()=>Er(e,l)}}},qr={kernelName:"Softmax",outputsToSave:[!0],gradFunc:(e,t,n)=>{const[r]=t,{dim:s}=n,o=Te(e,r);return{logits:()=>Le(o,Te(it(o,[s],!0),r))}}};const Lr=Fe({sigmoid_:function(e){const t=Ne(e,"x","sigmoid"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.sigmoid(t);return n([r]),r},n,null,"Sigmoid")}}),Or={kernelName:"Softplus",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,Lr(n))}}};const Wr=Fe({batchToSpaceND_:function(e,t,n){const r=Ne(e,"x","batchToSpaceND"),s=t.reduce((e,t)=>e*t);m(r.rank>=1+t.length,()=>`input rank is ${r.rank} but should be > than blockShape.length ${t.length}`),m(n.length===t.length,()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${t.length}`),m(r.shape[0]%s==0,()=>`input tensor batch is ${r.shape[0]} but is not divisible by the product of the elements of blockShape ${t.join(" * ")} === ${s}`);const o={x:r},a={blockShape:t,crops:n};return ke.runKernelFunc(e=>e.batchToSpaceND(r,t,n),o,null,"BatchToSpaceND",a)}}),Kr={kernelName:"SpaceToBatchND",gradFunc:(e,t,n)=>{const{blockShape:r,paddings:s}=n;return{x:()=>Wr(e,r,s)}}};function Gr(e,t){const n=e[0].length;e.forEach((e,t)=>{m(e.length===n,()=>`Error in concat${n}D: rank of tensors[${t}] must be the same as the rank of the rest (${n})`)}),m(t>=0&&t<n,()=>`Error in concat${n}D: axis must be between 0 and ${n-1}.`);const r=e[0];e.forEach((e,s)=>{for(let o=0;o<n;o++)m(o===t||e[o]===r[o],()=>`Error in concat${n}D: Shape of tensors[${s}] (${e}) does not match the shape of the rest (${r}) along the non-concatenated axis ${s}.`)})}function Ur(e,t){const n=e[0].slice();for(let r=1;r<e.length;r++)n[t]+=e[r][t];return n}function Vr(e,t,n){return Ce(e,t,Ee(e,n),n)}const Hr=Fe({concat_:function(e,t=0){m(e.length>=1,()=>"Pass at least one tensor to concat");let n=Ie(e,"tensors","concat");"complex64"===n[0].dtype&&n.forEach(e=>{if("complex64"!==e.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${e.dtype}. `)});const r=E(t,n[0].shape)[0],s=Ur(n.map(e=>e.shape),r);if(0===w(s))return Vr([],s);if(n=n.filter(e=>e.size>0),1===n.length)return n[0];Gr(n.map(e=>e.shape),r);const o=n,a={axis:t};return ke.runKernelFunc((e,t)=>{const s=e.concat(n,r);return t(n),s},o,null,"Concat",a)}}),jr={kernelName:"SplitV",gradFunc:(e,t,n)=>{const{axis:r}=n;return{x:()=>Hr(e,r)}}},Jr={kernelName:"Sqrt",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,Te(ze(Ae(n,"float32")),2))}}},Yr={kernelName:"Square",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(e,Te(n.toFloat(),2))}}},Zr={kernelName:"SquaredDifference",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Pe(2);return{a:()=>Te(e,Te(s,Le(n,r))),b:()=>Te(e,Te(s,Le(r,n)))}}},Xr={kernelName:"Step",gradFunc:e=>({x:()=>He(e)})},Qr={kernelName:"Sub",inputsToSave:["a","b"],gradFunc:(e,t)=>{const[n,r]=t,s=Ge(n.shape,r.shape);return{a:()=>{let t=e;const r=Ke(n.shape,s);return r.length>0&&(t=it(t,r)),Qe(t,n.shape)},b:()=>{let t=e;const n=Ke(r.shape,s);return n.length>0&&(t=it(t,n)),Qe(Re(t),r.shape)}}}};function es(e,t="float32"){if("complex64"===t){const t=es(e,"float32"),n=Yn(e,"float32");return Jn(t,n)}const n=K(w(e),t);return ke.makeTensor(n,e,t)}const ts={kernelName:"Sum",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,s=r.shape.slice(),{axis:o}=n;E(o,r.shape).forEach(e=>{s[e]=1});const a=Qe(e,s),i=Te(a,es(r.shape,"float32"));return{x:()=>i}}},ns={kernelName:"Tan",inputsToSave:["x"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Be(e,qe(kr(n)))}}},rs={kernelName:"Tanh",outputsToSave:[!0],gradFunc:(e,t)=>{const[n]=t;return{x:()=>Te(Le(Pe(1),qe(n)),e)}}};const ss=Fe({slice_:function(e,t,n){const r=Ne(e,"x","slice");if(0===r.rank)throw new Error("Slicing scalar is not possible");const[s,o]=Cr(r,t,n);Dr(r,s,o);const a={x:r},i={begin:t,size:n};return ke.runKernelFunc((e,t)=>(t([r]),e.slice(r,s,o)),a,null,"Slice",i)}}),os={kernelName:"Tile",inputsToSave:["x"],gradFunc:(e,t,n)=>{const[r]=t,{reps:s}=n;return{x:()=>{let t=He(r);if(1===r.rank)for(let n=0;n<s[0];++n)t=Ze(t,ss(e,[n*r.shape[0]],[r.shape[0]]));else if(2===r.rank)for(let n=0;n<s[0];++n)for(let o=0;o<s[1];++o)t=Ze(t,ss(e,[n*r.shape[0],o*r.shape[1]],[r.shape[0],r.shape[1]]));else if(3===r.rank)for(let n=0;n<s[0];++n)for(let o=0;o<s[1];++o)for(let a=0;a<s[2];++a)t=Ze(t,ss(e,[n*r.shape[0],o*r.shape[1],a*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));else{if(4!==r.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+r.rank+" tensors yet.");for(let n=0;n<s[0];++n)for(let o=0;o<s[1];++o)for(let a=0;a<s[2];++a)for(let i=0;i<s[3];++i)t=Ze(t,ss(e,[n*r.shape[0],o*r.shape[1],a*r.shape[2],i*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]))}return t}}}},as={kernelName:"Transpose",gradFunc:(e,t,n)=>{const r=n,{perm:s}=r,o=ot(s);return{x:()=>en(e,o)}}};const is=Fe({expandDims_:function(e,t=0){const n=Ne(e,"x","expandDims",null);m(t<=n.rank,()=>"Axis must be <= rank of the tensor");const r=n.shape.slice();return t<0&&(m(-(n.rank+1)<=t,()=>`Axis must be in the interval [${-(n.rank+1)}, ${n.rank}]`),t=n.rank+t+1),r.splice(t,0,1),Qe(n,r)}});const us=Fe({stack_:function(e,t=0){const n=Ie(e,"tensors","stack");if(m(n.length>=1,()=>"Pass at least one tensor to tf.stack"),1===n.length)return is(n[0],t);const r=n[0].rank,s=n[0].shape,o=n[0].dtype;m(t<=r,()=>"Axis must be <= rank of the tensor"),n.forEach(e=>{g(s,e.shape,"All tensors passed to stack must have matching shapes"),m(o===e.dtype,()=>"All tensors passed to stack must have matching dtypes")});const a=n.map(e=>is(e,t));return Hr(a,t)}}),ls={kernelName:"Unpack",gradFunc:(e,t,n)=>{const r=n,{axis:s}=r;return{value:()=>us(e,s)}}};function cs(e,t,n){const r=e.shape[n],s=[];let o=1,a=1;for(let t=0;t<n;t++)s.push(e.shape[t]),o*=e.shape[t];for(let e=0;e<t.rank;e++)s.push(t.shape[e]);for(let t=n+1;t<e.rank;t++)s.push(e.shape[t]),a*=e.shape[t];return{batchSize:o,sliceSize:a,dimSize:r,outputShape:s}}var hs=Object.freeze({__proto__:null,segOpComputeOptimalWindowSize:function(e,t){let n,r=!1;for(e<=30?(n=e,r=!0):n=q(e,Math.floor(Math.sqrt(e)));!r;)n>t||n===e?r=!0:n=q(e,n+1);return n},computeOutShape:function(e,t,n){const r=[],s=e.length;for(let o=0;o<s;o++)o!==t?r.push(e[o]):r.push(n);return r},collectGatherOpShapeInfo:cs});const ps=Fe({gather_:function(e,t,n=0){const r=Ne(e,"x","gather"),s=Ne(t,"indices","gather","int32"),o={x:r,indices:s},a={axis:n};return ke.runKernelFunc((e,t)=>{const o=E(n,r.shape)[0],a=cs(r,s,o),i=e.gather(r,s.flatten(),o);return t([r,s]),i.reshape(a.outputShape)},o,null,"GatherV2",a)}});const ds=Fe({maximum_:function(e,t){let n=Ne(e,"a","maximum"),r=Ne(t,"b","maximum");[n,r]=fe(n,r),"bool"===n.dtype&&(n=Ae(n,"int32"),r=Ae(r,"int32")),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.maximum(n,r);return t([n,r]),s},s,null,"Maximum")}});const fs=[$e,Oe,We,Ue,Ve,je,Je,Ye,Xe,ut,lt,ct,Et,Nt,Ft,Tt,Mt,$t,_t,zt,Ot,Vt,Gt,Jt,Zt,Qt,nn,on,an,un,ln,hn,pn,dn,mn,fn,yn,kn,Sn,En,Dn,Nn,In,Fn,An,Tn,$n,Rn,Rn,Pn,qn,On,Wn,Gn,Vn,Hn,jn,Zn,Xn,Qn,Qn,nr,rr,sr,or,ar,ir,ur,lr,pr,dr,fr,gr,br,yr,wr,vr,Sr,zr,qr,Or,Kr,Kr,jr,jr,Jr,Zr,Yr,Xr,Qr,ts,ns,rs,os,as,ls,{kernelName:"UnsortedSegmentSum",inputsToSave:["segmentIds"],gradFunc:(e,t)=>{const[n]=t;return{x:()=>function(e,t){const n=ds(t,He(t)),r=ps(e,n);let s=Bt(t,Pe(0,"int32"));const o=r.rank-s.rank;for(let e=0;e<o;++e)s=is(s,e+1);s=Ct(s,es(r.shape,"bool"));const a=He(r);return Pt(s,r,a)}(e,n)}}},{kernelName:"ZerosLike",gradFunc:e=>({x:()=>He(e)})}];for(const e of fs)h(e);class ms{fetch(e,t){return fetch(e,t)}now(){return performance.now()}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Browser's encoder only supports utf-8, but got "+t);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(e)}decode(e,t){return new TextDecoder(t).decode(e)}}n().get("IS_BROWSER")&&n().setPlatform("browser",new ms);const gs=()=>require("node-fetch");let bs;class ys{constructor(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}fetch(e,t){return null!=n().global.fetch?n().global.fetch(e,t):(null==bs&&(bs=gs()),bs(e,t))}now(){const e=process.hrtime();return 1e3*e[0]+e[1]/1e6}encode(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Node built-in encoder only supports utf-8, but got "+t);return this.textEncoder.encode(e)}decode(e,t){return 0===e.length?"":new this.util.TextDecoder(t).decode(e)}}n().get("IS_NODE")&&n().setPlatform("node",new ys);const ws={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};function ks(e,t){const n={};let r,s=0;for(const o of t){const t=o.name,a=o.dtype,i=o.shape,u=w(i);let l;if("quantization"in o){const n=o.quantization;if("uint8"===n.dtype||"uint16"===n.dtype){if(!("min"in n)||!("scale"in n))throw new Error(`Weight ${o.name} with quantization ${n.dtype} doesn't have corresponding metadata min and scale.`)}else{if("float16"!==n.dtype)throw new Error(`Weight ${o.name} has unknown quantization dtype ${n.dtype}. Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.`);if("float32"!==a)throw new Error(`Weight ${o.name} is quantized with ${n.dtype} which only supports weights of type float32 not ${a}.`)}const i=ws[n.dtype],c=e.slice(s,s+u*i),h="uint8"===n.dtype?new Uint8Array(c):new Uint16Array(c);if("float32"===a)if("uint8"===n.dtype||"uint16"===n.dtype){l=new Float32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];l[e]=t*n.scale+n.min}}else{if("float16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type float32.`);void 0===r&&(r=Is()),l=r(h)}else{if("int32"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);if("uint8"!==n.dtype&&"uint16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type int32.`);l=new Int32Array(h.length);for(let e=0;e<h.length;e++){const t=h[e];l[e]=Math.round(t*n.scale+n.min)}}s+=u*i}else if("string"===a){const t=w(o.shape);l=[];for(let n=0;n<t;n++){const t=new Uint32Array(e.slice(s,s+4))[0];s+=4;const n=new Uint8Array(e.slice(s,s+t));l.push(n),s+=t}}else{const r=ws[a],o=e.slice(s,s+u*r);if("float32"===a)l=new Float32Array(o);else if("int32"===a)l=new Int32Array(o);else if("bool"===a)l=new Uint8Array(o);else{if("complex64"!==a)throw new Error(`Unsupported dtype in weight '${t}': ${a}`);{l=new Float32Array(o);const e=new Float32Array(l.length/2),r=new Float32Array(l.length/2);for(let t=0;t<e.length;t++)e[t]=l[2*t],r[t]=l[2*t+1];const s=Vr(e,i,"float32"),a=Vr(r,i,"float32");n[t]=Jn(s,a)}}s+=u*r}"complex64"!==a&&(n[t]=Vr(l,i,a))}return n}function vs(e){if(null===e)throw new Error("Invalid input value: "+JSON.stringify(e));let t=0;const n=[];e.forEach(e=>{if(t+=e.byteLength,n.push(e.byteLength===e.buffer.byteLength?e:new e.constructor(e)),!(e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+e.constructor.name)});const r=new Uint8Array(t);let s=0;return n.forEach(e=>{r.set(new Uint8Array(e.buffer),s),s+=e.byteLength}),r.buffer}const xs="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function Ss(e){return xs?Buffer.byteLength(e):new Blob([e]).size}function Es(e){if(1===e.length)return e[0];let t=0;e.forEach(e=>{t+=e.byteLength});const n=new Uint8Array(t);let r=0;return e.forEach(e=>{n.set(new Uint8Array(e),r),r+=e.byteLength}),n.buffer}function Ds(e){for(e=e.trim();e.endsWith("/");)e=e.slice(0,e.length-1);const t=e.split("/");return t[t.length-1]}function Ns(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==e.modelTopology?0:Ss(JSON.stringify(e.modelTopology)),weightSpecsBytes:null==e.weightSpecs?0:Ss(JSON.stringify(e.weightSpecs)),weightDataBytes:null==e.weightData?0:e.weightData.byteLength}}function Is(){const e=function(){const e=e=>{let t=e<<13,n=0;for(;0==(8388608&t);)n-=8388608,t<<=1;return t&=-8388609,n+=947912704,t|n},t=new Uint32Array(2048);t[0]=0;for(let n=1;n<1024;n++)t[n]=e(n);for(let e=1024;e<2048;e++)t[e]=939524096+(e-1024<<13);return t}(),t=function(){const e=new Uint32Array(64);e[0]=0,e[31]=1199570944,e[32]=2147483648,e[63]=3347054592;for(let t=1;t<31;t++)e[t]=t<<23;for(let t=33;t<63;t++)e[t]=2147483648+(t-32<<23);return e}(),n=function(){const e=new Uint32Array(64);for(let t=0;t<64;t++)e[t]=1024;return e[0]=e[32]=0,e}();return r=>{const s=new ArrayBuffer(4*r.length),o=new Uint32Array(s);for(let s=0;s<r.length;s++){const a=r[s],i=e[n[a>>10]+(1023&a)]+t[a>>10];o[s]=i}return new Float32Array(s)}}class Fs{constructor(){this.saveRouters=[],this.loadRouters=[]}static getInstance(){return null==Fs.instance&&(Fs.instance=new Fs),Fs.instance}static registerSaveRouter(e){Fs.getInstance().saveRouters.push(e)}static registerLoadRouter(e){Fs.getInstance().loadRouters.push(e)}static getSaveHandlers(e){return Fs.getHandlers(e,"save")}static getLoadHandlers(e,t){return Fs.getHandlers(e,"load",t)}static getHandlers(e,t,n){const r=[];return("load"===t?Fs.getInstance().loadRouters:Fs.getInstance().saveRouters).forEach(t=>{const s=t(e,n);null!==s&&r.push(s)}),r}}class As{constructor(){this.managers={}}static getInstance(){return null==As.instance&&(As.instance=new As),As.instance}static registerManager(e,t){m(null!=e,()=>"scheme must not be undefined or null."),e.endsWith("://")&&(e=e.slice(0,e.indexOf("://"))),m(e.length>0,()=>"scheme must not be an empty string.");const n=As.getInstance();m(null==n.managers[e],()=>`A model store manager is already registered for scheme '${e}'.`),n.managers[e]=t}static getManager(e){const t=this.getInstance().managers[e];if(null==t)throw new Error(`Cannot find model manager for scheme '${e}'`);return t}static getSchemes(){return Object.keys(this.getInstance().managers)}}function Ts(e){if(-1===e.indexOf("://"))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+As.getSchemes().join(","));return{scheme:e.split("://")[0],path:e.split("://")[1]}}async function Ms(e,t,n=!1){m(e!==t,()=>`Old path and new path are the same: '${e}'`);const r=Fs.getLoadHandlers(e);m(r.length>0,()=>`Copying failed because no load handler is found for source URL ${e}.`),m(r.length<2,()=>`Copying failed because more than one (${r.length}) load handlers for source URL ${e}.`);const s=r[0],o=Fs.getSaveHandlers(t);m(o.length>0,()=>`Copying failed because no save handler is found for destination URL ${t}.`),m(o.length<2,()=>`Copying failed because more than one (${r.length}) save handlers for destination URL ${t}.`);const a=o[0],i=Ts(e).scheme,u=Ts(e).path,l=i===Ts(e).scheme,c=await s.load();n&&l&&await As.getManager(i).removeModel(u);const h=await a.save(c);return n&&!l&&await As.getManager(i).removeModel(u),h.modelArtifactsInfo}function $s(){if(!n().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");const e="undefined"==typeof window?self:window,t=e.indexedDB||e.mozIndexedDB||e.webkitIndexedDB||e.msIndexedDB||e.shimIndexedDB;if(null==t)throw new Error("The current browser does not appear to support IndexedDB.");return t}function _s(e){const t=e.result;t.createObjectStore("models_store",{keyPath:"modelPath"}),t.createObjectStore("model_info_store",{keyPath:"modelPath"})}class Bs{constructor(e){if(this.indexedDB=$s(),null==e||!e)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=e}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return this.databaseAction(this.modelPath,e)}async load(){return this.databaseAction(this.modelPath)}databaseAction(e,t){return new Promise((e,n)=>{const r=this.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=()=>_s(r),r.onsuccess=()=>{const s=r.result;if(null==t){const t=s.transaction("models_store","readonly"),r=t.objectStore("models_store").get(this.modelPath);r.onsuccess=()=>{if(null==r.result)return s.close(),n(new Error(`Cannot find model with path '${this.modelPath}' in IndexedDB.`));e(r.result.modelArtifacts)},r.onerror=e=>(s.close(),n(r.error)),t.oncomplete=()=>s.close()}else{const r=Ns(t),o=s.transaction("model_info_store","readwrite");let a=o.objectStore("model_info_store");const i=a.put({modelPath:this.modelPath,modelArtifactsInfo:r});let u;i.onsuccess=()=>{u=s.transaction("models_store","readwrite");const i=u.objectStore("models_store").put({modelPath:this.modelPath,modelArtifacts:t,modelArtifactsInfo:r});i.onsuccess=()=>e({modelArtifactsInfo:r}),i.onerror=e=>{a=o.objectStore("model_info_store");const t=a.delete(this.modelPath);t.onsuccess=()=>(s.close(),n(i.error)),t.onerror=e=>(s.close(),n(i.error))}},i.onerror=e=>(s.close(),n(i.error)),o.oncomplete=()=>{null==u?s.close():u.oncomplete=()=>s.close()}}},r.onerror=e=>n(r.error)})}}Bs.URL_SCHEME="indexeddb://";const Rs=e=>{return n().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Bs.URL_SCHEME)?(t=e.slice(Bs.URL_SCHEME.length),new Bs(t)):null;var t};Fs.registerSaveRouter(Rs),Fs.registerLoadRouter(Rs);class Cs{constructor(){this.indexedDB=$s()}async listModels(){return new Promise((e,t)=>{const n=this.indexedDB.open("tensorflowjs",1);n.onupgradeneeded=()=>_s(n),n.onsuccess=()=>{const r=n.result,s=r.transaction("model_info_store","readonly"),o=s.objectStore("model_info_store").getAll();o.onsuccess=()=>{const t={};for(const e of o.result)t[e.modelPath]=e.modelArtifactsInfo;e(t)},o.onerror=e=>(r.close(),t(o.error)),s.oncomplete=()=>r.close()},n.onerror=e=>t(n.error)})}async removeModel(e){var t;return e=(t=e).startsWith(Bs.URL_SCHEME)?t.slice(Bs.URL_SCHEME.length):t,new Promise((t,n)=>{const r=this.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=()=>_s(r),r.onsuccess=()=>{const s=r.result,o=s.transaction("model_info_store","readwrite"),a=o.objectStore("model_info_store"),i=a.get(e);let u;i.onsuccess=()=>{if(null==i.result)return s.close(),n(new Error(`Cannot find model with path '${e}' in IndexedDB.`));{const r=a.delete(e),o=()=>{u=s.transaction("models_store","readwrite");const r=u.objectStore("models_store").delete(e);r.onsuccess=()=>t(i.result.modelArtifactsInfo),r.onerror=e=>n(i.error)};r.onsuccess=o,r.onerror=e=>(o(),s.close(),n(i.error))}},i.onerror=e=>(s.close(),n(i.error)),o.oncomplete=()=>{null==u?s.close():u.oncomplete=()=>s.close()}},r.onerror=e=>n(r.error)})}}if(n().getBool("IS_BROWSER"))try{As.registerManager(Bs.URL_SCHEME,new Cs)}catch(e){}const Ps="tensorflowjs_models",zs="info",qs="model_topology",Ls="weight_specs",Os="weight_data",Ws="model_metadata";function Ks(e){return{info:[Ps,e,zs].join("/"),topology:[Ps,e,qs].join("/"),weightSpecs:[Ps,e,Ls].join("/"),weightData:[Ps,e,Os].join("/"),modelMetadata:[Ps,e,Ws].join("/")}}function Gs(e){const t=e.split("/");if(t.length<3)throw new Error("Invalid key format: "+e);return t.slice(1,t.length-1).join("/")}class Us{constructor(e){if(!n().getBool("IS_BROWSER")||"undefined"==typeof window||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==e||!e)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=e,this.keys=Ks(this.modelPath)}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");{const t=JSON.stringify(e.modelTopology),n=JSON.stringify(e.weightSpecs),r=Ns(e);try{return this.LS.setItem(this.keys.info,JSON.stringify(r)),this.LS.setItem(this.keys.topology,t),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(e){if(xs)return Buffer.from(e).toString("base64");const t=new Uint8Array(e);let n="";for(let e=0,r=t.length;e<r;e++)n+=String.fromCharCode(t[e]);return btoa(n)}(e.weightData)),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,userDefinedMetadata:e.userDefinedMetadata})),{modelArtifactsInfo:r}}catch(e){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(`Failed to save model '${this.modelPath}' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=${r.modelTopologyBytes}, weightSpecsBytes=${r.weightSpecsBytes}, weightDataBytes=${r.weightDataBytes}.`)}}}async load(){const e=JSON.parse(this.LS.getItem(this.keys.info));if(null==e)throw new Error(`In local storage, there is no model with name '${this.modelPath}'`);if("JSON"!==e.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");const t={},n=JSON.parse(this.LS.getItem(this.keys.topology));if(null==n)throw new Error(`In local storage, the topology of model '${this.modelPath}' is missing.`);t.modelTopology=n;const r=JSON.parse(this.LS.getItem(this.keys.weightSpecs));if(null==r)throw new Error(`In local storage, the weight specs of model '${this.modelPath}' are missing.`);t.weightSpecs=r;const s=this.LS.getItem(this.keys.modelMetadata);if(null!=s){const e=JSON.parse(s);t.format=e.format,t.generatedBy=e.generatedBy,t.convertedBy=e.convertedBy,t.userDefinedMetadata=e.userDefinedMetadata}const o=this.LS.getItem(this.keys.weightData);if(null==o)throw new Error(`In local storage, the binary weight values of model '${this.modelPath}' are missing.`);return t.weightData=function(e){if(xs){const t=Buffer.from(e,"base64");return t.buffer.slice(t.byteOffset,t.byteOffset+t.byteLength)}const t=atob(e),n=new Uint8Array(t.length);for(let e=0;e<t.length;++e)n.set([t.charCodeAt(e)],e);return n.buffer}(o),t}}Us.URL_SCHEME="localstorage://";const Vs=e=>{return n().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Us.URL_SCHEME)?(t=e.slice(Us.URL_SCHEME.length),new Us(t)):null;var t};Fs.registerSaveRouter(Vs),Fs.registerLoadRouter(Vs);class Hs{constructor(){m(n().getBool("IS_BROWSER"),()=>"Current environment is not a web browser"),m("undefined"==typeof window||void 0!==window.localStorage,()=>"Current browser does not appear to support localStorage"),this.LS=window.localStorage}async listModels(){const e={},t=Ps+"/",n="/"+zs;for(let r=0;r<this.LS.length;++r){const s=this.LS.key(r);if(s.startsWith(t)&&s.endsWith(n)){e[Gs(s)]=JSON.parse(this.LS.getItem(s))}}return e}async removeModel(e){var t;const n=Ks(e=(t=e).startsWith(Us.URL_SCHEME)?t.slice(Us.URL_SCHEME.length):t);if(null==this.LS.getItem(n.info))throw new Error(`Cannot find model at path '${e}'`);const r=JSON.parse(this.LS.getItem(n.info));return this.LS.removeItem(n.info),this.LS.removeItem(n.topology),this.LS.removeItem(n.weightSpecs),this.LS.removeItem(n.weightData),r}}if(n().getBool("IS_BROWSER"))try{As.registerManager(Us.URL_SCHEME,new Hs)}catch(e){}function js(e){return new Promise(e=>setTimeout(e)).then(e)}class Js{constructor(e){if(!n().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(Js.URL_SCHEME)&&(e=e.slice(Js.URL_SCHEME.length)),null!=e&&0!==e.length||(e="model"),this.modelTopologyFileName=e+".json",this.weightDataFileName=e+".weights.bin"}async save(e){if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");const t=window.URL.createObjectURL(new Blob([e.weightData],{type:"application/octet-stream"}));if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");{const n=[{paths:["./"+this.weightDataFileName],weights:e.weightSpecs}],r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,weightsManifest:n},s=window.URL.createObjectURL(new Blob([JSON.stringify(r)],{type:"application/json"})),o=null==this.jsonAnchor?document.createElement("a"):this.jsonAnchor;if(o.download=this.modelTopologyFileName,o.href=s,await js(()=>o.dispatchEvent(new MouseEvent("click"))),null!=e.weightData){const e=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor;e.download=this.weightDataFileName,e.href=t,await js(()=>e.dispatchEvent(new MouseEvent("click")))}return{modelArtifactsInfo:Ns(e)}}}}Js.URL_SCHEME="downloads://";class Ys{constructor(e){if(null==e||e.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+e);this.files=e}async load(){const e=this.files[0],t=this.files.slice(1);return new Promise((n,r)=>{const s=new FileReader;s.onload=s=>{const o=JSON.parse(s.target.result),a=o.modelTopology;if(null==a)return void r(new Error("modelTopology field is missing from file "+e.name));0===t.length&&n({modelTopology:a});const i=o.weightsManifest;if(null==i)return void r(new Error("weightManifest field is missing from file "+e.name));let u;try{u=this.checkManifestAndWeightFiles(i,t)}catch(e){return void r(e)}const l=[],c=[],h=[];i.forEach(e=>{e.paths.forEach(e=>{c.push(e),h.push(null)}),l.push(...e.weights)}),i.forEach(e=>{e.paths.forEach(e=>{const t=new FileReader;t.onload=t=>{const r=t.target.result,s=c.indexOf(e);h[s]=r,-1===h.indexOf(null)&&n({modelTopology:a,weightSpecs:l,weightData:Es(h),format:o.format,generatedBy:o.generatedBy,convertedBy:o.convertedBy,userDefinedMetadata:o.userDefinedMetadata})},t.onerror=t=>r(`Failed to weights data from file of path '${e}'.`),t.readAsArrayBuffer(u[e])})})},s.onerror=t=>r(`Failed to read model topology and weights manifest JSON from file '${e.name}'. BrowserFiles supports loading Keras-style tf.Model artifacts only.`),s.readAsText(e)})}checkManifestAndWeightFiles(e,t){const n=[],r=t.map(e=>Ds(e.name)),s={};for(const o of e)o.paths.forEach(e=>{const o=Ds(e);if(-1!==n.indexOf(o))throw new Error(`Duplicate file basename found in weights manifest: '${o}'`);if(n.push(o),-1===r.indexOf(o))throw new Error(`Weight file with basename '${o}' is not provided.`);s[e]=t[r.indexOf(o)]});if(n.length!==t.length)throw new Error(`Mismatch in the number of files in weights manifest (${n.length}) and the number of weight files provided (${t.length}).`);return s}}function Zs(e,t,n,r){!function(e){m(null!=e&&Array.isArray(e)&&e.length>0,()=>"promises must be a none empty array")}(e),function(e,t){m(e>=0&&e<=1,()=>"Progress fraction must be in range [0, 1], but got startFraction "+e),m(t>=0&&t<=1,()=>"Progress fraction must be in range [0, 1], but got endFraction "+t),m(t>=e,()=>`startFraction must be no more than endFraction, but got startFraction ${e} and endFraction `+t)}(n=null==n?0:n,r=null==r?1:r);let s=0;return Promise.all(e.map(o=>(o.then(o=>{const a=n+ ++s/e.length*(r-n);return t(a),o}),o)))}async function Xs(e,t){null==t&&(t={});const r=null==t.fetchFunc?n().platform.fetch:t.fetchFunc,s=e.map(e=>r(e,t.requestInit,{isBinary:!0})),o=(null==t.onProgress?await Promise.all(s):await Zs(s,t.onProgress,0,.5)).map(e=>e.arrayBuffer());return null==t.onProgress?await Promise.all(o):await Zs(o,t.onProgress,.5,1)}function Qs(e){return async(t,n="",r)=>{const s=t.map(()=>!1),o={},a=null!=r?r.map(()=>!1):[],i=[];if(t.forEach((e,t)=>{let n=0;e.weights.forEach(e=>{const u="quantization"in e?e.quantization.dtype:e.dtype,l=ws[u]*w(e.shape),c=()=>{s[t]=!0,null==o[t]&&(o[t]=[]),o[t].push({manifestEntry:e,groupOffset:n,sizeBytes:l})};null!=r?r.forEach((t,n)=>{t===e.name&&(c(),a[n]=!0)}):c(),i.push(e.name),n+=l})}),!a.every(e=>e)){const e=r.filter((e,t)=>!a[t]);throw new Error("Could not find weights in manifest with names: "+e.join(", ")+". \nManifest JSON has weights with names: "+i.join(", ")+".")}const u=s.reduce((e,t,n)=>(t&&e.push(n),e),[]),l=[];u.forEach(e=>{t[e].paths.forEach(e=>{const t=n+(n.endsWith("/")?"":"/")+e;l.push(t)})});const c=await e(l),h={};let p=0;return u.forEach(e=>{const n=t[e].paths.length;let r=0;for(let e=0;e<n;e++)r+=c[p+e].byteLength;const s=new ArrayBuffer(r),a=new Uint8Array(s);let i=0;for(let e=0;e<n;e++){const t=new Uint8Array(c[p+e]);a.set(t,i),i+=t.byteLength}o[e].forEach(e=>{const t=ks(s.slice(e.groupOffset,e.groupOffset+e.sizeBytes),[e.manifestEntry]);for(const e in t)h[e]=t[e]}),p+=n}),h}}Fs.registerSaveRouter(e=>n().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Js.URL_SCHEME)?function(e="model"){return new Js(e)}(e.slice(Js.URL_SCHEME.length)):null);class eo{constructor(e,t){if(this.DEFAULT_METHOD="POST",null==t&&(t={}),this.weightPathPrefix=t.weightPathPrefix,this.onProgress=t.onProgress,null!=t.fetchFunc?(m("function"==typeof t.fetchFunc,()=>"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"),this.fetch=t.fetchFunc):this.fetch=n().platform.fetch,m(null!=e&&e.length>0,()=>"URL path for http must not be null, undefined or empty."),Array.isArray(e)&&m(2===e.length,()=>`URL paths for http must have a length of 2, (actual length is ${e.length}).`),this.path=e,null!=t.requestInit&&null!=t.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=t.requestInit||{}}async save(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");const t=Object.assign({method:this.DEFAULT_METHOD},this.requestInit);t.body=new FormData;const n=[{paths:["./model.weights.bin"],weights:e.weightSpecs}],r={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,userDefinedMetadata:e.userDefinedMetadata,weightsManifest:n};t.body.append("model.json",new Blob([JSON.stringify(r)],{type:"application/json"}),"model.json"),null!=e.weightData&&t.body.append("model.weights.bin",new Blob([e.weightData],{type:"application/octet-stream"}),"model.weights.bin");const s=await this.fetch(this.path,t);if(s.ok)return{modelArtifactsInfo:Ns(e),responses:[s]};throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+s.status+".")}async load(){const e=await this.fetch(this.path,this.requestInit);if(!e.ok)throw new Error(`Request to ${this.path} failed with status code `+e.status+". Please verify this URL points to the model JSON of the model to load.");let t;try{t=await e.json()}catch(e){let t=`Failed to parse model JSON of response from ${this.path}.`;throw this.path.endsWith(".pb")?t+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":t+=" Please make sure the server is serving valid JSON for this request.",new Error(t)}const n=t.modelTopology,r=t.weightsManifest,s=t.generatedBy,o=t.convertedBy,a=t.format,i=t.userDefinedMetadata;if(null==n&&null==r)throw new Error(`The JSON from HTTP path ${this.path} contains neither model topology or manifest for weights.`);let u,l;if(null!=r){const e=await this.loadWeights(r);[u,l]=e}return{modelTopology:n,weightSpecs:u,weightData:l,userDefinedMetadata:i,generatedBy:s,convertedBy:o,format:a}}async loadWeights(e){const t=Array.isArray(this.path)?this.path[1]:this.path,[n,r]=function(e){const t=e.lastIndexOf("/"),n=e.lastIndexOf("?"),r=e.substring(0,t),s=n>t?e.substring(n):"";return[r+"/",s]}(t),s=this.weightPathPrefix||n,o=[];for(const t of e)o.push(...t.weights);const a=[];return e.forEach(e=>{e.paths.forEach(e=>{a.push(s+e+r)})}),[o,Es(await Xs(a,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress}))]}}function to(e){return null!=e.match(eo.URL_SCHEME_REGEX)}eo.URL_SCHEME_REGEX=/^https?:\/\//;const no=(e,t)=>{if("undefined"==typeof fetch&&(null==t||null==t.fetchFunc))return null;{let n=!0;if(n=Array.isArray(e)?e.every(e=>to(e)):to(e),n)return ro(e,t)}return null};function ro(e,t){return new eo(e,t)}Fs.registerSaveRouter(no),Fs.registerLoadRouter(no);class so{constructor(e){this.modelArtifacts=e}async load(){return this.modelArtifacts}}class oo{constructor(e){this.saveHandler=e}async save(e){return this.saveHandler(e)}}var ao=Object.freeze({__proto__:null,browserFiles:function(e){return new Ys(e)},browserHTTPRequest:function(e,t){return ro(e,t)},concatenateArrayBuffers:Es,decodeWeights:ks,encodeWeights:async function(e,t){const n=[],r=[],s=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);for(let o=0;o<s.length;++o){const a=s[o],i=Array.isArray(e)?e[o].tensor:e[a];if("float32"!==i.dtype&&"int32"!==i.dtype&&"bool"!==i.dtype&&"string"!==i.dtype&&"complex64"!==i.dtype)throw new Error(`Unsupported dtype in weight '${a}': ${i.dtype}`);const u={name:a,shape:i.shape,dtype:i.dtype};if("string"===i.dtype){const e=new Promise(async e=>{const t=await i.bytes(),n=t.reduce((e,t)=>e+t.length,0)+4*t.length,r=new Uint8Array(n);let s=0;for(let e=0;e<t.length;e++){const n=t[e],o=new Uint8Array(new Uint32Array([n.length]).buffer);r.set(o,s),s+=4,r.set(n,s),s+=n.length}e(r)});r.push(e)}else r.push(i.data());null!=t&&(u.group=t),n.push(u)}return{data:vs(await Promise.all(r)),specs:n}},fromMemory:function(e,t,n,r){if(1===arguments.length){return null!=e.modelTopology||null!=e.weightSpecs?new so(e):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new so({modelTopology:e}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new so({modelTopology:e,weightSpecs:t,weightData:n,trainingConfig:r})},getLoadHandlers:(e,t)=>Fs.getLoadHandlers(e,t),getModelArtifactsInfoForJSON:Ns,getSaveHandlers:e=>Fs.getSaveHandlers(e),http:ro,isHTTPScheme:to,loadWeights:async function(e,t="",n,r){return Qs(e=>Xs(e,{requestInit:r}))(e,t,n)},registerLoadRouter:e=>Fs.registerLoadRouter(e),registerSaveRouter:e=>Fs.registerSaveRouter(e),weightsLoaderFactory:Qs,withSaveHandler:function(e){return new oo(e)},copyModel:async function(e,t){return Ms(e,t,!1)},listModels:async function(){const e=As.getSchemes(),t={};for(const n of e){const e=await As.getManager(n).listModels();for(const r in e){t[n+"://"+r]=e[r]}}return t},moveModel:async function(e,t){return Ms(e,t,!0)},removeModel:async function(e){const t=Ts(e);return As.getManager(t.scheme).removeModel(t.path)}});const io=Fe({oneHot_:function(e,t,n=1,r=0){if(t<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+t);const s=Ne(e,"indices","oneHot","int32"),o=[...s.shape,t],a={indices:s},i={depth:t,onValue:n,offValue:r};return ke.runKernelFunc((e,a)=>(a([s]),Qe(e.oneHot(s.flatten(),t,n,r),o)),a,null,"OneHot",i)}});const uo=Fe({confusionMatrix_:function(e,t,n){const r=Ne(e,"labels","confusionMatrix"),s=Ne(t,"predictions","confusionMatrix");m(null==n||n>0&&Number.isInteger(n),()=>"If provided, numClasses must be a positive integer, but got "+n),m(1===r.rank,()=>"Expected the rank of labels to be 1, but got "+r.rank),m(1===s.rank,()=>"Expected the rank of predictions to be 1, but got "+s.rank),m(r.shape[0]===s.shape[0],()=>`Mismatch in the number of examples: ${r.shape[0]} vs. ${s.shape[0]}. Labels and predictions should have the same number of elements.`),m(n>0&&Number.isInteger(n),()=>"numClasses is required to be a positive integer, but got "+n);const o=io(r.asType("int32"),n),a=io(s.asType("int32"),n);return o.transpose().matMul(a).asType("int32")}});var lo=Object.freeze({__proto__:null,confusionMatrix:uo});function co(e,t,n){if(b(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");const r=Ee(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return Ce(e,t,r,n)}let ho;const po=Fe({fromPixels_:function(e,t=3){if(t>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==e)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");let n=!1,r=!1,s=!1,o=!1,a=!1;if(e.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&e instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&e instanceof HTMLVideoElement)s=!0;else if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement)o=!0;else{if(null==e.getContext)throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+e.constructor.name);a=!0}if(s){const t=2;if(s&&e.readyState<t)throw new Error("The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.")}if(null!=u("FromPixels",ke.backendName)){const n={pixels:e},r={numChannels:t};return ke.runKernel("FromPixels",n,r)}const[i,l]=s?[e.videoWidth,e.videoHeight]:[e.width,e.height];let c,h;if(a?c=e.getContext("2d").getImageData(0,0,i,l).data:r||n?c=e.data:(o||s)&&(null==ho&&(ho=document.createElement("canvas").getContext("2d")),ho.canvas.width=i,ho.canvas.height=l,ho.drawImage(e,0,0,i,l),c=ho.getImageData(0,0,i,l).data),4===t)h=new Int32Array(c);else{const e=i*l;h=new Int32Array(e*t);for(let n=0;n<e;n++)for(let e=0;e<t;++e)h[n*t+e]=c[4*n+e]}return co(h,[l,i,t],"int32")}});var fo=Object.freeze({__proto__:null,toPixels:async function(e,t){let n=Ne(e,"img","toPixels");if(!(e instanceof oe)){const e=n;n=e.toInt(),e.dispose()}if(2!==n.rank&&3!==n.rank)throw new Error(`toPixels only supports rank 2 or 3 tensors, got rank ${n.rank}.`);const[r,s]=n.shape.slice(0,2),o=2===n.rank?1:n.shape[2];if(o>4||2===o)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+o);const a=await n.data(),i=n.min(),u=n.max(),l=await Promise.all([i.data(),u.data()]),c=l[0],h=l[1],p=c[0],d=h[0];if(i.dispose(),u.dispose(),"float32"===n.dtype){if(p<0||d>1)throw new Error(`Tensor values for a float32 Tensor must be in the range [0 - 1] but got range [${p} - ${d}].`)}else{if("int32"!==n.dtype)throw new Error(`Unsupported type for toPixels: ${n.dtype}. Please use float32 or int32 tensors.`);if(p<0||d>255)throw new Error(`Tensor values for a int32 Tensor must be in the range [0 - 255] but got range [${p} - ${d}].`)}const f="float32"===n.dtype?255:1,m=new Uint8ClampedArray(s*r*4);for(let e=0;e<r*s;++e){let t,n,r,s;1===o?(t=a[e]*f,n=a[e]*f,r=a[e]*f,s=255):3===o?(t=a[3*e]*f,n=a[3*e+1]*f,r=a[3*e+2]*f,s=255):4===o&&(t=a[4*e]*f,n=a[4*e+1]*f,r=a[4*e+2]*f,s=a[4*e+3]*f);const i=4*e;m[i+0]=Math.round(t),m[i+1]=Math.round(n),m[i+2]=Math.round(r),m[i+3]=Math.round(s)}if(null!=t){t.width=s,t.height=r;const e=t.getContext("2d"),n=new ImageData(m,s,r);e.putImageData(n,0,0)}return n!==e&&n.dispose(),m},fromPixels:po});function mo(e,t){if(e.rank<1)throw new Error(`tf.gatherND() expects the input to be rank 1 or higher, but the rank was ${e.rank}.`);if(t.rank<1)throw new Error(`tf.gatherND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if("int32"!==t.dtype)throw new Error(`tf.gatherND() expects the indices to be int32 type, but the dtype was ${t.dtype}.`);if(t.shape[t.rank-1]>e.rank)throw new Error(`index innermost dimension length must be <= tensor rank; saw: ${t.shape[t.rank-1]} vs. ${e.rank}`);if(0===e.size)throw new Error(`Requested more than 0 entries, but input is empty. Input shape: ${e.shape}.`);const n=t.shape,r=n[n.length-1];let s=1;for(let e=0;e<n.length-1;++e)s*=n[e];const o=e.shape,a=n.slice();a.pop();let i=1;for(let t=r;t<e.rank;++t)i*=o[t],a.push(o[t]);const u=[...L(e.shape).map(e=>e/i),1].slice(0,r);return[a,s,i,u]}var go=Object.freeze({__proto__:null,prepareAndValidate:mo});function bo(e,t,n){const r=t.rank>1?t.shape[t.rank-1]:1,s=t.rank>1?t.rank-1:1,o="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+`, indices.shape: ${t.shape}, shape: ${e}`+`, sliceDim: ${r}, and batchDim: ${s}.`;if(n.rank<s)throw new Error(o+` update.rank < ${s}. `);if(e.length<r+(n.rank-s))throw new Error(o+" Output shape length < "+(r+(n.rank-s)));if(n.rank!==s+e.length-r)throw new Error(o+" update.rank != "+(s+e.length-r));for(let e=0;e<s;++e)if(n.shape[e]!==t.shape[e])throw new Error(o+` updates.shape[${e}] (${n.shape[e]}) != indices.shape[${e}] (${t.shape[e]}).`);for(let t=0;t<n.rank-s;++t)if(n.shape[t+s]!==e[t+r])throw new Error(o+` updates.shape[${t+s}] (${n.shape[t+s]}) != shape[${t+s}] (${e[t+s]})`)}function yo(e,t,n){if(t.rank<1)throw new Error(`tf.scatterND() expects the indices to be rank 1 or higher, but the rank was ${t.rank}.`);if(e.rank<1)throw new Error(`tf.scatterND() expects the updates to be rank 1 or higher, but the rank was ${e.rank}.`);if("int32"!==t.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+t.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===t.size)throw new Error("Indices specified for empty output. indices shape: "+t.shape);if(0===e.size)throw new Error("Updates specified for empty output. updates shape: "+e.shape)}bo(n,t,e)}function wo(e,t,n){const r=t.shape.length,s=r>1?t.shape[r-1]:1,o=n.length;let a=1;for(let e=s;e<o;++e)a*=n[e];const i=s<1?1:s;return{sliceRank:s,numUpdates:w(t.shape)/i,sliceSize:a,strides:[...L(n.slice(0,s)),1],outputSize:w(n)}}var ko=Object.freeze({__proto__:null,validateUpdateShape:bo,validateInput:yo,calculateShapes:wo});class vo{getClassName(){return this.constructor.className}static fromConfig(e,t){return new e(t)}}class xo{constructor(){this.classNameMap={}}static getMap(){return null==xo.instance&&(xo.instance=new xo),xo.instance}static register(e){xo.getMap().classNameMap[e.className]=[e,e.fromConfig]}}function So(e){m(null!=e.className,()=>"Class being registered does not have the static className property defined."),m("string"==typeof e.className,()=>"className is required to be a string, but got type "+typeof e.className),m(e.className.length>0,()=>"Class being registered has an empty-string as its className, which is disallowed."),xo.register(e)}var Eo=Object.freeze({__proto__:null,Serializable:vo,SerializationMap:xo,registerClass:So});function Do(){return 32===ke.backend.floatPrecision()?.001:.1}function No(e,t,n){let r=!0;if((M(e)||M(t))&&(r=!1),M(e)&&M(t)&&(r=!0),r){const n=e.constructor.name,r=t.constructor.name;if(n!==r)throw new Error(`Arrays are of different type. Actual: ${n}. Expected: `+r)}if(Array.isArray(e)&&Array.isArray(t)){const n=Ee(e),r=Ee(t);if(!k(n,r))throw new Error(`Arrays have different shapes. Actual: [${n}]. Expected: [${r}]`)}const s=M(e)?e:y(e),o=M(t)?t:y(t);if(s.length!==o.length)throw new Error(`Arrays have different lengths actual: ${s.length} vs expected: ${o.length}.\nActual:   ${s}.\nExpected: ${o}.`);for(let e=0;e<o.length;++e){const t=s[e],r=o[e];if(!n(t,r))throw new Error(`Arrays differ: actual[${e}] = ${t}, expected[${e}] = ${r}.\nActual:   ${s}.\nExpected: ${o}.`)}}function Io(e,t,n){return!isFinite(e)&&!isFinite(t)||!(isNaN(e)||isNaN(t)||Math.abs(e-t)>n)}var Fo=Object.freeze({__proto__:null,TEST_EPSILON_FLOAT16:.1,expectArraysClose:function(e,t,n){return null==n&&(n=Do()),No(e,t,(e,t)=>Io(e,t,n))},testEpsilon:Do,expectPromiseToFail:function(e,t){e().then(()=>t.fail(),()=>t())},expectArraysEqual:function(e,t){const n="string"==typeof t||"number"==typeof t||"boolean"==typeof t?[t]:t;return B(e)||B(e[0])||B(t)||B(t[0])?No(e,n,(e,t)=>e==t):No(e,t,(e,t)=>Io(e,t,0))},expectNumbersClose:function(e,t,n){if(null==n&&(n=Do()),!Io(e,t,n))throw new Error(`Numbers differ: actual === ${e}, expected === ${t}`)},expectValuesInRange:function(e,t,n){for(let r=0;r<e.length;r++)if(e[r]<t||e[r]>n)throw new Error(`Value out of range:${e[r]} low: ${t}, high: ${n}`)},expectArrayBuffersEqual:function(e,t){expect(new Float32Array(e)).toEqual(new Float32Array(t))}});function Ao(e){n().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(e+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")}function To(e,t){return ke.tidy(e,t)}function Mo(e){ge(e).forEach(e=>e.dispose())}function $o(e){return ke.keep(e)}const _o=Fe({abs_:function(e){const t=Ne(e,"x","abs"),n={x:t};return ke.runKernelFunc((e,n)=>(n([t]),"complex64"===t.dtype?e.complexAbs(t):e.abs(t)),n,null,"Abs")}});const Bo=Fe({acos_:function(e){const t=Ne(e,"x","acos"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.acos(t);return n([t]),r},n,null,"Acos")}});const Ro=Fe({acosh_:function(e){const t=Ne(e,"x","acosh"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.acosh(t);return n([t]),r},n,null,"Acosh")}});const Co=Fe({addN_:function(e){m(Array.isArray(e),()=>"The argument passed to tf.addN() must be a list of tensors"),m(e.length>=1,()=>"Must pass at least one tensor to tf.addN(), but got "+e.length);const t=e.map((e,t)=>Ne(e,"tensors"+t,"addN")),n=t[0];t.forEach(e=>{if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")}),t.forEach(e=>{if(!k(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")});const r=t;return ke.runKernelFunc((e,n)=>{const r=e.addN(t);return n(t),r},r,null,"AddN")}});const Po=Fe({all_:function(e,t=null,n=!1){let r=Ne(e,"x","all","bool");const s={x:r},o={axis:t,keepDims:n};return ke.runKernelFunc(e=>{const s=E(t,r.shape);let o=s;const a=st(o,r.rank);null!=a&&(r=r.transpose(a),o=at(o.length,r.rank));const i=e.all(r,o);if(n){const e=rt(i.shape,s);return i.reshape(e)}return i},s,null,"All",o)}});const zo=Fe({any_:function(e,t=null,n=!1){let r=Ne(e,"x","any","bool");const s={x:r},o={axis:t,keepDims:n};return ke.runKernelFunc(e=>{const s=E(t,r.shape);let o=s;const a=st(o,r.rank);null!=a&&(r=r.transpose(a),o=at(o.length,r.rank));const i=e.any(r,o);if(n){const e=rt(i.shape,s);return i.reshape(e)}return i},s,null,"Any",o)}});const qo=Fe({argMax_:function(e,t=0){let n=Ne(e,"x","argMax");const r={x:n},s={axis:t};return ke.runKernelFunc((e,r)=>{r([n]);let s=E(t,n.shape);const o=st(s,n.rank);return null!=o&&(n=n.transpose(o),s=at(s.length,n.rank)),e.argMax(n,s[0])},r,null,"ArgMax",s)}});const Lo=Fe({argMin_:function(e,t=0){let n=Ne(e,"x","argMin");const r={x:n},s={axis:t};return ke.runKernelFunc((e,r)=>{r([n]),null==t&&(t=0);let s=E(t,n.shape);const o=st(s,n.rank);return null!=o&&(n=n.transpose(o),s=at(s.length,n.rank)),e.argMin(n,s[0])},r,null,"ArgMin",s)}});const Oo=Fe({asin_:function(e){const t=Ne(e,"x","asin"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.asin(t);return n([t]),r},n,null,"Asin")}});const Wo=Fe({asinh_:function(e){const t=Ne(e,"x","asinh"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.asinh(t);return n([t]),r},n,null,"Asinh")}});const Ko=Fe({atan_:function(e){const t=Ne(e,"x","atan"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.atan(t);return n([t]),r},n,null,"Atan")}});const Go=Fe({atan2_:function(e,t){let n=Ne(e,"a","atan2"),r=Ne(t,"b","atan2");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.atan2(n,r);return t([n,r]),s},s,null,"Atan2")}});const Uo=Fe({atanh_:function(e){const t=Ne(e,"x","atanh"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.atanh(t);return n([t]),r},n,null,"Atanh")}});const Vo=Fe({avgPool_:function(e,t,n,r,s){const o=Ne(e,"x","avgPool","float32");m(vt(n,1),()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`);let a=o,i=!1;3===o.rank&&(i=!0,a=Qe(o,[1,o.shape[0],o.shape[1],o.shape[2]])),m(4===a.rank,()=>`Error in avgPool: x must be rank 4 but got rank ${a.rank}.`),null!=s&&m(v(r),()=>`Error in avgPool: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const u={x:a},l={filterSize:t,strides:n,pad:r,dimRoundingMode:s};let c=ke.runKernelFunc((e,o)=>{const i=ht(a.shape,t,n,1,r,s);return o([a]),1===i.filterWidth&&1===i.filterHeight&&k(i.inShape,i.outShape)?a.clone():e.avgPool(a,i)},u,null,"AvgPool",l);return c=Ae(c,o.dtype),i?c.as3D(c.shape[1],c.shape[2],c.shape[3]):c}});const Ho=Fe({avgPool3d_:function(e,t,n,r,s,o="NDHWC",a){null==a?a=[1,1,1]:Ao("dilations is deprecated, this field will be gone in v3.0.0.");const i=Ne(e,"x","avgPool3d","float32");let u=i,l=!1;4===i.rank&&(l=!0,u=Qe(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),m(5===u.rank,()=>`Error in avgPool3d: x must be rank 5 but got rank ${u.rank}.`),m("NDHWC"===o,()=>"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+o),m(vt(n,a),()=>`Error in avgPool3d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),null!=s&&m(v(r),()=>`Error in avgPool3d: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const c={x:u},h={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:o,dilations:a};let p=ke.runKernelFunc((e,i)=>{null==a&&(a=[1,1,1]);const l=pt(u.shape,t,n,a,r,s,o);return i([u]),e.avgPool3d(u,l)},c,null,"AvgPool3D",h);return p=Ae(p,u.dtype),l?p.as4D(p.shape[1],p.shape[2],p.shape[3],p.shape[4]):p}});const jo=Fe({tanh_:function(e){const t=Ne(e,"x","tanh"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.tanh(t);return n([r]),r},n,null,"Tanh")}});const Jo=Fe({basicLSTMCell_:function(e,t,n,r,s,o){const a=Ne(e,"forgetBias","basicLSTMCell"),i=Ne(t,"lstmKernel","basicLSTMCell"),u=Ne(n,"lstmBias","basicLSTMCell"),l=Ne(r,"data","basicLSTMCell"),c=Ne(s,"c","basicLSTMCell"),h=Ne(o,"h","basicLSTMCell"),p=Hr([l,h],1),d=It(p,i),f=Ze(d,u),m=f.shape[0],g=f.shape[1]/4,b=[m,g],y=ss(f,[0,0],b),w=ss(f,[0,g],b),k=ss(f,[0,2*g],b),v=ss(f,[0,3*g],b),x=Ze(Te(Lr(y),jo(w)),Te(c,Lr(Ze(a,k))));return[x,Te(jo(x),Lr(v))]}});function Yo(e){return null==e?null:0===e.rank?e.as1D():1===e.rank?e:2===e.rank?e.as4D(1,1,e.shape[0],e.shape[1]):3===e.rank?e.as4D(1,e.shape[0],e.shape[1],e.shape[2]):e}const Zo=Fe({batchNorm_:function(e,t,n,r,s,o){null==o&&(o=.001);const a=Ne(e,"x","batchNorm"),i=Ne(t,"mean","batchNorm"),u=Ne(n,"variance","batchNorm");let l,c;null!=s&&(l=Ne(s,"scale","batchNorm")),null!=r&&(c=Ne(r,"offset","batchNorm")),m(i.rank===u.rank,()=>"Batch normalization gradient requires mean and variance to have equal ranks."),m(null==c||i.rank===c.rank,()=>"Batch normalization gradient requires mean and offset to have equal ranks."),m(null==l||i.rank===l.rank,()=>"Batch normalization gradient requires mean and scale to have equal ranks.");const h=function(e){let t;return t=0===e.rank||1===e.rank?e.as4D(1,1,1,e.size):2===e.rank?e.as4D(1,1,e.shape[0],e.shape[1]):3===e.rank?e.as4D(1,e.shape[0],e.shape[1],e.shape[2]):e,t}(a),p={x:h,scale:l,offset:c,mean:i,variance:u},d={varianceEpsilon:o},f=ke.runKernelFunc((e,t)=>(t([h,i,u,l]),e.batchNorm(h,Yo(i),Yo(u),Yo(c),Yo(l),o)),p,null,"FusedBatchNorm",d);return Qe(f,a.shape)}});const Xo=Fe({batchNorm2d_:function(e,t,n,r,s,o){const a=Ne(e,"x","batchNorm"),i=Ne(t,"mean","batchNorm"),u=Ne(n,"variance","batchNorm");let l,c;return null!=s&&(l=Ne(s,"scale","batchNorm")),null!=r&&(c=Ne(r,"offset","batchNorm")),m(2===a.rank,()=>"Error in batchNorm3D: x must be rank 3 but got rank "+a.rank+"."),m(2===i.rank||1===i.rank,()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${i.rank}.`),m(2===u.rank||1===u.rank,()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`),null!=l&&m(2===l.rank||1===l.rank,()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${l.rank}.`),null!=c&&m(2===c.rank||1===c.rank,()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${c.rank}.`),Zo(a,i,u,c,l,o)}});const Qo=Fe({batchNorm3d_:function(e,t,n,r,s,o){const a=Ne(e,"x","batchNorm"),i=Ne(t,"mean","batchNorm"),u=Ne(n,"variance","batchNorm");let l,c;return null!=s&&(l=Ne(s,"scale","batchNorm")),null!=r&&(c=Ne(r,"offset","batchNorm")),m(3===a.rank,()=>"Error in batchNorm3D: x must be rank 3 but got rank "+a.rank+"."),m(3===i.rank||1===i.rank,()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${i.rank}.`),m(3===u.rank||1===u.rank,()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`),null!=l&&m(3===l.rank||1===l.rank,()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${l.rank}.`),null!=c&&m(3===c.rank||1===c.rank,()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${c.rank}.`),Zo(a,i,u,c,l,o)}});const ea=Fe({batchNorm4d_:function(e,t,n,r,s,o){const a=Ne(e,"x","batchNorm"),i=Ne(t,"mean","batchNorm"),u=Ne(n,"variance","batchNorm");let l,c;return null!=s&&(l=Ne(s,"scale","batchNorm")),null!=r&&(c=Ne(r,"offset","batchNorm")),m(4===a.rank,()=>"Error in batchNorm4D: x must be rank 4 but got rank "+a.rank+"."),m(4===i.rank||1===i.rank,()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${i.rank}.`),m(4===u.rank||1===u.rank,()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`),null!=l&&m(4===l.rank||1===l.rank,()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${l.rank}.`),null!=c&&m(4===c.rank||1===c.rank,()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${c.rank}.`),Zo(a,i,u,c,l,o)}});const ta=Fe({broadcastTo_:function(e,t){let n=Ne(e,"broadcastTo","x");const r=n.shape;if(t.some(e=>!(e>0)||e%1!=0))throw new Error(`broadcastTo(): Invalid broadcast shape [${t}].`);if(t.length<n.rank)throw new Error(`broadcastTo(): shape.length=${t.length} < input.rank=${n.rank}.`);if(t.length>n.rank){const e=n.shape.slice();for(;e.length<t.length;)e.unshift(1);n=Qe(n,e)}const s=n.shape,o=Array.from(t);for(let e=t.length-1;e>=0;e--)if(s[e]===t[e])o[e]=1;else if(1!==n.shape[e])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${t}].`);if(0===o.map((e,t)=>e>1?t:-1).filter(e=>e>=0).length)return cr(n);const a={x:n},i={shape:t,inputShape:s};return ke.runKernelFunc(e=>e.tile(n,o),a,null,"BroadcastTo",i)}});function na(e,t="float32",n){return t=t||"float32",V(e),new ne(e,t,n)}const ra=Fe({ceil_:function(e){const t=Ne(e,"x","ceil"),n={x:t};return ke.runKernelFunc(e=>e.ceil(t),n,null,"Ceil")}});const sa=Fe({clipByValue_:function(e,t,n){const r=Ne(e,"x","clipByValue");m(t<=n,()=>`Error in clip: min (${t}) must be less than or equal to max (${n}).`);const s={x:r},o={clipValueMin:t,clipValueMax:n};return ke.runKernelFunc((e,s)=>{const o=e.clip(r,t,n);return s([r]),o},s,null,"ClipByValue",o)}});const oa=Fe({concat1d_:function(e){return Hr(e,0)}});const aa=Fe({concat2d_:function(e,t){return Hr(e,t)}});const ia=Fe({concat3d_:function(e,t){return Hr(e,t)}});const ua=Fe({concat4d_:function(e,t){return Hr(e,t)}});const la=Fe({conv1d_:function(e,t,n,r,s="NWC",o=1,a){const i=Ne(e,"x","conv1d"),u=Ne(t,"filter","conv1d");let l=i,c=!1;2===i.rank&&(c=!0,l=Qe(i,[1,i.shape[0],i.shape[1]])),m(3===l.rank,()=>`Error in conv1d: input must be rank 3, but got rank ${l.rank}.`),m(3===u.rank,()=>"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."),null!=a&&m(v(r),()=>`Error in conv1d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`),m(l.shape[2]===u.shape[1],()=>`Error in conv1d: depth of input (${l.shape[2]}) must match input depth for filter ${u.shape[1]}.`),m(vt(n,o),()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${o}'`),m("NWC"===s,()=>`Error in conv1d: got dataFormat of ${s} but only NWC is currently supported.`);const h=Qe(u,[1,u.shape[0],u.shape[1],u.shape[2]]),p=Qe(l,[l.shape[0],1,l.shape[1],l.shape[2]]),d=Ut(p,h,[1,n],r,"NHWC",[1,o],a);return Qe(d,c?[d.shape[2],d.shape[3]]:[d.shape[0],d.shape[2],d.shape[3]])}});const ca=Fe({conv2dTranspose_:function(e,t,n,r,s,o){const a=Ne(e,"x","conv2dTranspose"),i=Ne(t,"filter","conv2dTranspose");return Kt(n,a,i,r,s,"NHWC",o)}});const ha=Fe({conv3d_:function(e,t,n,r,s="NDHWC",o=[1,1,1]){const a=Ne(e,"x","conv3d"),i=Ne(t,"filter","conv3d");let u=a,l=!1;4===a.rank&&(l=!0,u=Qe(a,[1,a.shape[0],a.shape[1],a.shape[2],a.shape[3]])),m(5===u.rank,()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`),m(5===i.rank,()=>"Error in conv3d: filter must be rank 5, but got rank "+i.rank+"."),m(u.shape[4]===i.shape[3],()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${i.shape[3]}.`),m(vt(n,o),()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`),m("NDHWC"===s,()=>`Error in conv3d: got dataFormat of ${s} but only NDHWC is currently supported.`);const c={x:u,filter:i},h={strides:n,pad:r,dataFormat:s,dilations:o},p=ke.runKernelFunc((e,t)=>{const s=ft(u.shape,i.shape,n,o,r),a=e.conv3d(u,i,s);return t([u,i]),a},c,null,"Conv3D",h);return l?p.as4D(p.shape[1],p.shape[2],p.shape[3],p.shape[4]):p}});const pa=Fe({conv3dTranspose_:function(e,t,n,r,s){const o=Ne(e,"x","conv3dTranspose"),a=Ne(t,"filter","conv3dTranspose");return jt(n,o,a,r,s)}});const da=Fe({depthToSpace_:function(e,t,n="NHWC"){const r=Ne(e,"x","depthToSpace"),s="NHWC"===n?r.shape[1]:r.shape[2],o="NHWC"===n?r.shape[2]:r.shape[3],a="NHWC"===n?r.shape[3]:r.shape[1];m(s*t>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${s} and ${t}  for depthToSpace with input shape\n    ${r.shape}`),m(o*t>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${o} and ${t} for depthToSpace with input shape\n        ${r.shape}`),m(a%(t*t)==0,()=>`Dimension size must be evenly divisible by ${t*t} but is ${a} for depthToSpace with input shape ${r.shape}`);const i={x:r},u={blockSize:t,dataFormat:n};return ke.runKernelFunc(e=>e.depthToSpace(r,t,n),i,null,"DepthToSpace",u)}});const fa=Fe({depthwiseConv2d_:function(e,t,n,r,s="NHWC",o=[1,1],a){const i=Ne(e,"x","depthwiseConv2d"),u=Ne(t,"filter","depthwiseConv2d");let l=i,c=!1;3===i.rank&&(c=!0,l=Qe(i,[1,i.shape[0],i.shape[1],i.shape[2]])),m(4===l.rank,()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${l.rank}.`),m(4===u.rank,()=>"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."),m(l.shape[3]===u.shape[2],()=>`Error in depthwiseConv2d: number of input channels (${l.shape[3]}) must match the inChannels dimension in filter ${u.shape[2]}.`),null!=a&&m(v(r),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`);const h={x:l,filter:u},p={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a},d=ke.runKernelFunc((e,t)=>{null==o&&(o=[1,1]),m(vt(n,o),()=>`Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`);const s=dt(l.shape,u.shape,n,o,r,a,!0),i=e.depthwiseConv2D(l,u,s);return t([l,u]),i},h,null,"DepthwiseConv2dNative",p);return c?Qe(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});const ma=Fe({diag_:function(e){const t=Ne(e,"x","diag").flatten(),n={x:t};return ke.runKernelFunc(n=>{const r=n.diag(t),s=[...e.shape,...e.shape];return Qe(r,s)},n,null,"Diag")}});const ga=Fe({dilation2d_:function(e,t,n,r,s=[1,1],o="NHWC"){const a=Ne(e,"x","dilation2d"),i=Ne(t,"filter","dilation2d");m(3===a.rank||4===a.rank,()=>"Error in dilation2d: input must be rank 3 or 4, but got rank "+a.rank+"."),m(3===i.rank,()=>"Error in dilation2d: filter must be rank 3, but got rank "+i.rank+"."),m("NHWC"===o,()=>"Error in dilation2d: Only NHWC is currently supported, but got dataFormat of "+o);let u=a,l=!1;3===a.rank&&(u=Qe(a,[1,a.shape[0],a.shape[1],a.shape[2]]),l=!0);const c={x:u,filter:i},h={strides:n,pad:r,dilations:s},p=ke.runKernel("Dilation2D",c,h);return l?Qe(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const ba=Fe({divNoNan_:function(e,t){let n=Ne(e,"a","div"),r=Ne(t,"b","div");[n,r]=fe(n,r);const s=Be(n,r),o=He(s),a=r.equal(o);return Pt(a,o,s)}});const ya=Fe({dot_:function(e,t){const n=Ne(e,"t1","dot"),r=Ne(t,"t2","dot");m(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${r.rank}.`);const s=1===n.rank?n.size:n.shape[1],o=1===r.rank?r.size:r.shape[0];if(m(s===o,()=>`Error in dot: inner dimensions of inputs must match, but got ${s} and ${o}.`),1===n.rank&&1===r.rank){const e=Qe(n,[1,-1]),t=Qe(r,[-1,1]),s=It(e,t);return Qe(s,[])}if(1===n.rank&&2===r.rank){const e=Qe(n,[1,-1]),t=Qe(r,[r.shape[0],r.shape[1]]),s=It(e,t);return Qe(s,[s.size])}if(2===n.rank&&1===r.rank){const e=Qe(r,[-1,1]),t=It(n,e);return Qe(t,[t.size])}{const e=Qe(r,[r.shape[0],r.shape[1]]);return It(n,e)}}});const wa=Fe({elu_:function(e){const t=Ne(e,"x","elu"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.elu(t);return n([r]),r},n,null,"Elu")}});const ka=Fe({erf_:function(e){let t=Ne(e,"x","erf");m("int32"===t.dtype||"float32"===t.dtype,()=>"Input dtype must be `int32` or `float32`."),"int32"===t.dtype&&(t=t.toFloat());const n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.erf(t);return n([t]),r},n,null,"Erf")}});const va=Fe({expm1_:function(e){const t=Ne(e,"x","expm1"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.expm1(t);return n([t]),r},n,null,"Expm1")}});const xa=Fe({eye_:function(e,t,n,r="float32"){null==t&&(t=e);const s=na([e,t],r),o=e<=t?e:t;for(let e=0;e<o;++e)s.set(1,e,e);const a=s.toTensor().as2D(e,t);if(null==n)return a;if(1===n.length)return bn(is(a,0),[n[0],1,1]);if(2===n.length)return bn(is(is(a,0),0),[n[0],n[1],1,1]);if(3===n.length)return bn(is(is(is(a,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});const Sa=Fe({fft_:function(e){m("complex64"===e.dtype,()=>`The dtype for tf.spectral.fft() must be complex64 but got ${e.dtype}.`);const t={input:e};return ke.runKernelFunc(t=>{const n=e.shape[e.shape.length-1],r=e.size/n,s=e.as2D(r,n);return t.fft(s).reshape(e.shape)},t,null,"FFT")}});function Ea(e,t,n){const r={shape:e,value:t,dtype:n};return ke.runKernelFunc(r=>r.fill(e,t,n),{},null,"Fill",r)}const Da=Fe({ifft_:function(e){m("complex64"===e.dtype,()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${e.dtype}.`);const t={input:e};return ke.runKernelFunc(t=>{const n=e.shape[e.shape.length-1],r=e.size/n,s=e.as2D(r,n);return t.ifft(s).reshape(e.shape)},t,null,"IFFT")}});const Na=Fe({imag_:function(e){const t=Ne(e,"input","imag"),n={input:t};return ke.runKernelFunc(e=>e.imag(t),n,null,"Imag")}});const Ia=Fe({real_:function(e){const t=Ne(e,"input","real"),n={input:t};return ke.runKernelFunc(e=>e.real(t),n,null,"Real")}});const Fa=Fe({irfft_:function(e){const t=e.shape[e.shape.length-1],n=e.size/t;let r;if(t<=2){const s=Qe(e,[n,t]);r=Da(s)}else{const s=[n,2*(t-1)],o=Qe(Ia(e),[n,t]),a=Qe(Na(e),[n,t]),i=hr(ss(o,[0,1],[n,t-2]),1),u=Te(hr(ss(a,[0,1],[n,t-2]),1),Pe(-1)),l=Hr([o,i],1),c=Hr([a,u],1),h=Qe(Jn(l,c),[s[0],s[1]]);r=Da(h)}if(r=Ia(r),3===e.rank&&0!==e.shape[0]){const t=r,n=e.shape[0];r=Qe(r,[n,r.shape[0]/n,r.shape[1]]),t.dispose()}return r}});const Aa=Fe({isFinite_:function(e){const t=Ne(e,"x","isFinite"),n={x:t};return ke.runKernelFunc(e=>e.isFinite(t),n,null,"IsFinite")}});const Ta=Fe({isInf_:function(e){const t=Ne(e,"x","isInf"),n={x:t};return ke.runKernelFunc(e=>e.isInf(t),n,null,"IsInf")}});const Ma=Fe({isNaN_:function(e){const t=Ne(e,"x","isNaN"),n={x:t};return ke.runKernelFunc(e=>e.isNaN(t),n,null,"IsNan")}});const $a=Fe({leakyRelu_:function(e,t=.2){const n=Ne(e,"x","leakyRelu");return ds(Te(Pe(t),n),n)}});function _a(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");const r={start:e,stop:t,num:n};return ke.runKernelFunc(r=>r.linspace(e,t,n),{},null,"LinSpace",r)}const Ba=Fe({localResponseNormalization_:function(e,t=5,n=1,r=1,s=.5){const o=Ne(e,"x","localResponseNormalization");m(4===o.rank||3===o.rank,()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${o.rank}.`),m(v(t),()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${t}.`);let a=o,i=!1;3===o.rank&&(i=!0,a=Qe(o,[1,o.shape[0],o.shape[1],o.shape[2]]));const u={x:a},l={depthRadius:t,bias:n,alpha:r,beta:s},c=ke.runKernelFunc((e,o)=>{const i=e.localResponseNormalization4D(a,t,n,r,s);return o([a,i]),i},u,null,"LRN",l);return i?c.as3D(c.shape[1],c.shape[2],c.shape[3]):c}});const Ra=Fe({log1p_:function(e){const t=Ne(e,"x","log1p"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.log1p(t);return n([t]),r},n,null,"Log1p")}});function Ca(e,t){m(z(e),()=>"The f passed in variableGrads(f) must be a function"),m(null==t||Array.isArray(t)&&t.every(e=>e instanceof ae),()=>"The varList passed in variableGrads(f, varList) must be an array of variables");const n=null!=t;if(!n){t=[];for(const e in ke.registeredVariables)t.push(ke.registeredVariables[e])}const r=n?t.filter(e=>!e.trainable):null,s=t.length;m((t=t.filter(e=>e.trainable)).length>0,()=>`variableGrads() expects at least one of the input variables to be trainable, but none of the ${s} variables is trainable.`);const{value:o,grads:a}=ke.gradients(e,t,null,!0);m(a.some(e=>null!=e),()=>"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."),m(0===o.rank,()=>`The f passed in variableGrads(f) must return a scalar, but it returned a rank-${o.rank} tensor`);const i={};return t.forEach((e,t)=>{null!=a[t]&&(i[e.name]=a[t])}),null!=r&&r.forEach(e=>i[e.name]=null),{value:o,grads:i}}function Pa(e){return ke.customGrad(e)}function za(e){if(e.filter(e=>null==e).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}const qa=Fe({logSigmoid_:function(e){const t=Ne(e,"x","logSigmoid");return Pa(e=>({value:Re(Re(e).softplus()),gradFunc:t=>Te(t,Lr(Re(e)))}))(t)}});const La=Fe({max_:function(e,t=null,n=!1){const r=Ne(e,"x","max"),s={x:r},o={reductionIndices:t,keepDims:n};return ke.runKernelFunc((e,s)=>{let o=E(t,r.shape);const a=st(o,r.rank);let i=r;null!=a&&(i=en(r,a),o=at(o.length,i.rank));const u=e.max(i,o);null!=a&&i.dispose();let l=u;if(n){const e=rt(l.shape,E(t,r.shape));l=Qe(l,e),u.dispose()}return s([r,l]),l},s,null,"Max",o)}});const Oa=Fe({logSoftmax_:function(e,t=-1){const n=Ne(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${t}`);const r={logits:n},s={axis:t};return ke.runKernelFunc((n,r)=>{const s=La(e,t,!0),o=Le(e,s),a=o.toFloat().sub(o.exp().sum(t,!0).log());return r([a]),a},r,null,"LogSoftmax",s)}});const Wa=Fe({logSumExp_:function(e,t=null,n=!1){const r=Ne(e,"x","logSumExp"),s=E(t,r.shape),o=La(r,s,!0),a=Le(r,o),i=cn(a),u=it(i,s),l=er(u),c=Ze(Qe(o,l.shape),l);if(n){const e=rt(c.shape,s);return Qe(c,e)}return c}});const Ka=Fe({logicalOr_:function(e,t){const n=Ne(e,"a","logicalOr","bool"),r=Ne(t,"b","logicalOr","bool");Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc(e=>e.logicalOr(n,r),s,null,"LogicalOr")}});const Ga=Fe({logicalXor_:function(e,t){const n=Ne(e,"a","logicalXor","bool"),r=Ne(t,"b","logicalXor","bool");return Ge(n.shape,r.shape),Ct(Ka(e,t),mr(Ct(e,t)))}});const Ua=Fe({maxPool_:function(e,t,n,r,s){const o=Ne(e,"x","maxPool");let a=o,i=!1;3===o.rank&&(i=!0,a=Qe(o,[1,o.shape[0],o.shape[1],o.shape[2]])),m(4===a.rank,()=>`Error in maxPool: input must be rank 4 but got rank ${a.rank}.`),m(vt(n,1),()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`),null!=s&&m(v(r),()=>`Error in maxPool: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const u={x:a},l={filterSize:t,strides:n,pad:r,dimRoundingMode:s},c=ke.runKernelFunc((e,o)=>{const i=ht(a.shape,t,n,1,r,s);let u;return u=1===i.filterWidth&&1===i.filterHeight&&k(i.inShape,i.outShape)?a.clone():e.maxPool(a,i),o([a,u]),u},u,null,"MaxPool",l);return i?Qe(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Va=Fe({maxPool3d_:function(e,t=[1,1,1],n,r,s,o="NDHWC",a){null==a?a=[1,1,1]:Ao("dilations is deprecated, this field will be gone in v3.0.0.");const i=Ne(e,"x","maxPool3d");let u=i,l=!1;4===i.rank&&(l=!0,u=i.as5D(1,i.shape[0],i.shape[1],i.shape[2],i.shape[3])),m(5===u.rank,()=>`Error in maxPool3d: x must be rank 5 but got rank ${u.rank}.`),m("NDHWC"===o,()=>"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+o),m(vt(n,a),()=>`Error in maxPool3d: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),null!=s&&m(v(r),()=>`Error in maxPool3d: pad must be an integer when using, dimRoundingMode ${s} but got pad ${r}.`);const c={x:u},h={filterSize:t,strides:n,pad:r,dimRoundingMode:s,dataFormat:o,dilations:a},p=ke.runKernelFunc((e,i)=>{null==a&&(a=[1,1,1]);const l=pt(u.shape,t,n,a,r,s,o),c=e.maxPool3d(u,l);return i([u,c]),c},c,null,"MaxPool3D",h);return l?Qe(p,[p.shape[1],p.shape[2],p.shape[3],p.shape[4]]):p}});const Ha=Fe({maxPoolWithArgmax_:function(e,t,n,r,s=!1){const o={x:Ne(e,"x","maxPoolWithArgmax")},a={filterSize:t,strides:n,pad:r,includeBatchInIndex:s},i=ke.runKernel("MaxPoolWithArgmax",o,a);return{result:i[0],indexes:i[1]}}});const ja=Fe({mean_:function(e,t=null,n=!1){const r=Ne(e,"x","mean"),s=E(t,r.shape),o=w(nt(r.shape,s)[1]);return Pa(e=>{const r=Pe(o),a=r.dtype===e.dtype?e:Ae(e,r.dtype),i=Be(a,r);return{value:it(i,t,n),gradFunc:t=>{const n=e.shape.slice();s.forEach(e=>{n[e]=1});const r=Qe(t,n);return Be(Te(r,es(e.shape,"float32")),o)}}})(r)}});const Ja=Fe({min_:function(e,t=null,n=!1){const r=Ne(e,"x","min"),s={x:r},o={axis:t,keepDims:n};return ke.runKernelFunc((e,s)=>{const o=E(t,r.shape);let a=o;const i=st(a,r.rank);let u=r;null!=i&&(u=en(r,i),a=at(a.length,r.rank));const l=e.min(u,a);null!=i&&u.dispose();let c=l;if(n){const e=rt(c.shape,o);c=Qe(l,e),l.dispose()}return s([r,c]),c},s,null,"Min",o)}});const Ya=Fe({minimum_:function(e,t){let n=Ne(e,"a","minimum"),r=Ne(t,"b","minimum");[n,r]=fe(n,r),"bool"===n.dtype&&(n=Ae(n,"int32"),r=Ae(r,"int32")),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.minimum(n,r);return t([n,r]),s},s,null,"Minimum")}});const Za=Fe({mod_:function(e,t){let n=Ne(e,"a","mod"),r=Ne(t,"b","mod");[n,r]=fe(n,r);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.mod(n,r);return t([n,r]),s},s,null,"Mod")}});const Xa=Fe({moments_:function(e,t=null,n=!1){const r=E(t,(e=Ne(e,"x","moments")).shape),s=ja(e,r,n);let o=s.shape;n||(o=rt(s.shape,r));const a=qe(Le(Ae(e,"float32"),Qe(s,o)));return{mean:s,variance:ja(a,r,n)}}});const Qa=Fe({multiRNNCell_:function(e,t,n,r){const s=Ne(t,"data","multiRNNCell"),o=Ie(n,"c","multiRNNCell"),a=Ie(r,"h","multiRNNCell");let i=s;const u=[];for(let t=0;t<e.length;t++){const n=e[t](i,o[t],a[t]);u.push(n[0]),u.push(n[1]),i=n[1]}const l=[],c=[];for(let e=0;e<u.length;e+=2)l.push(u[e]),c.push(u[e+1]);return[l,c]}});const ei=Fe({multinomial_:function(e,t,n,r=!1){const s=Ne(e,"logits","multinomial"),o=s.size,a=s.rank;if(o<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+o+".");if(a>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+a);n=n||Math.random();const i=1===a?s.as2D(1,-1):s,u=ke.runKernelFunc(e=>e.multinomial(i,r,t,n),{logits2D:i});return 1===a?u.as1D():u}});const ti=Fe({notEqual_:function(e,t){let n=Ne(e,"a","notEqual"),r=Ne(t,"b","notEqual");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc(e=>e.notEqual(n,r),s,null,"NotEqual")}});const ni=Fe({onesLike_:function(e){const t=Ne(e,"x","onesLike"),n={x:t};return ke.runKernelFunc((e,n)=>{if("complex64"===t.dtype){const e=ni(Ia(t)),n=He(Na(t));return Jn(e,n)}return e.onesLike(t)},n,null,"OnesLike")}});const ri=Fe({outerProduct_:function(e,t){const n=Ne(e,"v1","outerProduct"),r=Ne(t,"v2","outerProduct");m(1===n.rank&&1===r.rank,()=>`Error in outerProduct: inputs must be rank 1, but got ranks ${n.rank} and ${r.rank}.`);const s=Qe(n,[-1,1]),o=Qe(r,[1,-1]);return It(s,o)}});const si=Fe({pad1d_:function(e,t,n=0){return m(2===t.length,()=>"Invalid number of paddings. Must be length of 2."),Er(e,[t],n)}});const oi=Fe({pad2d_:function(e,t,n=0){return m(2===t.length&&2===t[0].length&&2===t[1].length,()=>"Invalid number of paddings. Must be length of 2 each."),Er(e,t,n)}});const ai=Fe({pad3d_:function(e,t,n=0){return m(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,()=>"Invalid number of paddings. Must be length of 2 each."),Er(e,t,n)}});const ii=Fe({pad4d_:function(e,t,n=0){return m(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,()=>"Invalid number of paddings. Must be length of 2 each."),Er(e,t,n)}});const ui=Fe({pool_:function(e,t,n,r,s,o){null==s&&(s=[1,1]),null==o&&(o=1),0===r&&(r="valid");const a=Ne(e,"x","maxPool");let i=a,u=!1;3===a.rank&&(u=!0,i=Qe(a,[1,a.shape[0],a.shape[1],a.shape[2]])),m(vt(o,s),()=>`Error in pool: Either strides or dilations must be 1. Got strides ${o} and dilations '${s}'`);const l=ht(i.shape,t,o,s,r),c=[l.dilationHeight,l.dilationWidth];let h;h="same"===r?function(e,t){const n=e.map((e,n)=>e+(e-1)*(t[n]-1)).map(e=>e-1),r=n.map(e=>Math.floor(e/2)),s=n.map((e,t)=>e-r[t]);return n.map((e,t)=>[r[t],s[t]])}([l.filterHeight,l.filterWidth],c):[[0,0],[0,0]];const p=1===c[0]&&1===c[1],[d,f]=function(e,t,n){const r=n.map(e=>e[0]),s=n.map(e=>e[1]),o=e.concat(r,s),a=t.map((e,t)=>(e-o[t]%e)%e),i=s.map((e,t)=>e+a[t]),u=t.map((e,t)=>[r[t],i[t]]),l=t.map((e,t)=>[0,a[t]]);return[u,l]}([l.inHeight,l.inWidth],c,h),g=p?r:"valid",b=p?i:At(i,c,d),y=("avg"===n?()=>Vo(b,t,o,g):()=>Ua(b,t,o,g))(),w=p?y:Wr(y,c,f);return u?Qe(w,[w.shape[1],w.shape[2],w.shape[3]]):w}});const li=Fe({prelu_:function(e,t){const n=Ne(e,"x","prelu"),r=Ne(t,"alpha","prelu"),s={x:n,alpha:r};return ke.runKernelFunc((e,t)=>{const s=e.prelu(n,r);return t([n,r]),s},s,null,"Prelu")}});function ci(e,t=!1){console.log(e.toString(t))}const hi=Fe({prod_:function(e,t=null,n=!1){let r=Ne(e,"x","prod");const s={x:r},o={axis:t,keepDims:n};return ke.runKernelFunc(e=>{"bool"===r.dtype&&(r=r.toInt());const s=E(t,r.shape),o=st(s,r.rank);let a=s,i=r;null!=o&&(i=r.transpose(o),a=at(a.length,r.rank));let u=e.prod(i,a);if(n){const e=rt(u.shape,s);u=u.reshape(e)}return u},s,null,"Prod",o)}});const pi=Fe({rand_:function(e,t,n){const r=w(e);let s=null;if(null==n||"float32"===n)s=new Float32Array(r);else if("int32"===n)s=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);s=new Uint8Array(r)}for(let e=0;e<r;e++)s[e]=t();return ke.makeTensor(s,e,n)}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function di(e,t){return e(t={exports:{}},t.exports),t.exports}var fi=di((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=e.toString();for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function s(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function o(e,t){var n=new r(e),o=t&&t.state,a=n.next;return a.int32=function(){return 4294967296*n.next()|0},a.double=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.alea=o}(0,e,!1)})),mi=di((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor128=o}(0,e,!1)})),gi=di((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function s(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorwow=o}(0,e,!1)})),bi=di((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,s=t.i;return e=r[s],n=(e^=e>>>7)^e<<24,n^=(e=r[s+1&7])^e>>>10,n^=(e=r[s+3&7])^e>>>3,n^=(e=r[s+4&7])^e<<7,e=r[s+7&7],n^=(e^=e<<13)^e<<9,r[s]=n,t.i=s+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function s(e,t){return t.x=e.x.slice(),t.i=e.i,t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&(o.x&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorshift7=o}(0,e,!1)})),yi=di((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,s=t.X,o=t.i;return t.w=r=r+1640531527|0,n=s[o+34&127],e=s[o=o+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=s[o]=n^e,t.i=o,n+(r^r>>>16)|0},function(e,t){var n,r,s,o,a,i=[],u=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,u=Math.max(u,t.length)),s=0,o=-32;o<u;++o)t&&(r^=t.charCodeAt((o+32)%t.length)),0===o&&(a=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,o>=0&&(a=a+1640531527|0,s=0==(n=i[127&o]^=r+a)?s+1:0);for(s>=128&&(i[127&(t&&t.length||0)]=-1),s=127,o=512;o>0;--o)r=i[s+34&127],n=i[s=s+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,i[s]=r^n;e.w=a,e.X=i,e.i=s}(t,e)}function s(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&(o.X&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor4096=o}(0,e,!1)})),wi=di((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,s=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^s,s=s-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^s,t.a=s-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function s(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},a.int32=n.next,a.quick=a,o&&("object"==typeof o&&s(o,n),a.state=function(){return s(n,{})}),a}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.tychei=o}(0,e,!1)})),ki=di((function(e){!function(t,n){var r,s=this,o=n.pow(256,6),a=n.pow(2,52),i=2*a;function u(e,u,d){var f=[],m=h(function e(t,n){var r,s=[],o=typeof t;if(n&&"object"==o)for(r in t)try{s.push(e(t[r],n-1))}catch(e){}return s.length?s:"string"==o?t:t+"\0"}((u=1==u?{entropy:!0}:u||{}).entropy?[e,p(t)]:null==e?function(){try{var e;return r&&(e=r.randomBytes)?e=e(256):(e=new Uint8Array(256),(s.crypto||s.msCrypto).getRandomValues(e)),p(e)}catch(e){var n=s.navigator,o=n&&n.plugins;return[+new Date,s,o,s.screen,p(t)]}}():e,3),f),g=new l(f),b=function(){for(var e=g.g(6),t=o,n=0;e<a;)e=256*(e+n),t*=256,n=g.g(1);for(;e>=i;)e/=2,t/=2,n>>>=1;return(e+n)/t};return b.int32=function(){return 0|g.g(4)},b.quick=function(){return g.g(4)/4294967296},b.double=b,h(p(g.S),t),(u.pass||d||function(e,t,r,s){return s&&(s.S&&c(s,g),e.state=function(){return c(g,{})}),r?(n.random=e,t):e})(b,m,"global"in u?u.global:this==n,u.state)}function l(e){var t,n=e.length,r=this,s=0,o=r.i=r.j=0,a=r.S=[];for(n||(e=[n++]);s<256;)a[s]=s++;for(s=0;s<256;s++)a[s]=a[o=255&o+e[s%n]+(t=a[s])],a[o]=t;(r.g=function(e){for(var t,n=0,s=r.i,o=r.j,a=r.S;e--;)t=a[s=255&s+1],n=256*n+a[255&(a[s]=a[o=255&o+t])+(a[o]=t)];return r.i=s,r.j=o,n})(256)}function c(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function h(e,t){for(var n,r=e+"",s=0;s<r.length;)t[255&s]=255&(n^=19*t[255&s])+r.charCodeAt(s++);return p(t)}function p(e){return String.fromCharCode.apply(0,e)}if(n.seedrandom=u,h(n.random(),t),e.exports){e.exports=u;try{r=require("crypto")}catch(e){}}}([],Math)}));ki.alea=fi,ki.xor128=mi,ki.xorwow=gi,ki.xorshift7=bi,ki.xor4096=yi,ki.tychei=wi;var vi=ki.alea;class xi{constructor(e,t,n,r,s){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const o=s||Math.random();this.random=vi(o.toString())}nextValue(){if(!isNaN(this.nextVal)){const e=this.nextVal;return this.nextVal=NaN,e}let e,t,n=!1;for(;!n;){let r,s,o;do{r=2*this.random()-1,s=2*this.random()-1,o=r*r+s*s}while(o>=1||0===o);const a=Math.sqrt(-2*Math.log(o)/o);e=this.mean+this.stdDev*r*a,t=this.mean+this.stdDev*s*a,this.truncated&&!this.isValidTruncated(e)||(n=!0)}return this.truncated&&!this.isValidTruncated(t)||(this.nextVal=this.convertValue(t)),this.convertValue(e)}convertValue(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)}isValidTruncated(e){return e<=this.upper&&e>=this.lower}}class Si{constructor(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;const s=r||Math.random();this.randu=vi(s.toString()),this.randn=new xi(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}nextValue(){let e,t,n,r,s,o;for(;;){do{r=this.randn.nextValue(),o=1+this.c*r}while(o<=0);if(o*=o*o,e=r*r,t=1-.331*e*e,n=.5*e+this.d*(1-o+Math.log(o)),s=this.randu(),s<t||Math.log(s)<n)break}return o=1/this.beta*this.d*o,this.alpha<1&&(o*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(o)}convertValue(e){return"float32"===this.dtype?e:Math.round(e)}}class Ei{constructor(e=0,t=1,n,r){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${e} - ${t} <= 1 and dtype is not float`);this.random=vi(r)}convertValue(e){return this.canReturnFloat()?e:Math.round(e)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const Di=Fe({randomGamma_:function(e,t,n=1,r="float32",s){if(null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type "+r);const o=new Si(t,n,r,s),a=na(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const Ni=Fe({randomNormal_:function(e,t=0,n=1,r,s){if(null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);const o=new xi(t,n,r,!1,s),a=na(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const Ii=Fe({randomUniform_:function(e,t=0,n=1,r="float32",s){const o=na(e,r),a=new Ei(t,n,null,s);for(let e=0;e<o.values.length;e++)o.values[e]=a.nextValue();return o.toTensor()}});function Fi(e,t){b(e);const n=Ee(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return Ce(e,null,n,t)}function Ai(e,t,n=1,r="float32"){if(0===n)throw new Error("Cannot have a step of zero");const s={start:e,stop:t,step:n,dtype:r};return ke.runKernelFunc(()=>{if(e===t||e<t&&n<0||t<e&&n>1)return Yn([0],r);const s=G(Math.abs(Math.ceil((t-e)/n)),r);t<e&&1===n&&(n=-1),s[0]=e;for(let e=1;e<s.length;e++)s[e]=s[e-1]+n;return Fi(s,r)},{},null,"Range",s)}const Ti=Fe({reciprocal_:function(e){const t=Ne(e,"x","reciprocal"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.reciprocal(t);return n([t]),r},n,null,"Reciprocal")}});const Mi=Fe({relu_:function(e){const t=Ne(e,"x","relu"),n={x:t};return ke.runKernelFunc((e,n)=>(n([t]),"bool"===t.dtype?t.toInt():e.relu(t)),n,null,"Relu")}});const $i=Fe({relu6_:function(e){const t=Ne(e,"x","relu6"),n={x:t};return ke.runKernelFunc((e,n)=>(n([t]),"bool"===t.dtype?Ae(t,"int32"):e.relu6(t)),n,null,"Relu6")}});const _i=Fe({reverse1d_:function(e){const t=Ne(e,"x","reverse");return m(1===t.rank,()=>`Error in reverse1D: x must be rank 1 but got rank ${t.rank}.`),hr(t,0)}});const Bi=Fe({reverse2d_:function(e,t){const n=Ne(e,"x","reverse");return m(2===n.rank,()=>`Error in reverse2D: x must be rank 2 but got rank ${n.rank}.`),hr(n,t)}});const Ri=Fe({reverse3d_:function(e,t){const n=Ne(e,"x","reverse");return m(3===n.rank,()=>`Error in reverse3D: x must be rank 3 but got rank ${n.rank}.`),hr(n,t)}});const Ci=Fe({reverse4d_:function(e,t){const n=Ne(e,"x","reverse");return m(4===n.rank,()=>`Error in reverse4D: x must be rank 4 but got rank ${n.rank}.`),hr(n,t)}});const Pi=Fe({rfft_:function(e,t){m("float32"===e.dtype,()=>"The dtype for rfft() must be real value but got "+e.dtype);let n=e.shape[e.shape.length-1];const r=e.size/n;let s;if(null!=t&&t<n){const r=e.shape.map(e=>0),o=e.shape.map(e=>e);o[e.shape.length-1]=t,s=ss(e,r,o),n=t}else if(null!=t&&t>n){const r=e.shape.map(e=>e);r[e.shape.length-1]=t-n,s=Hr([e,Yn(r)],e.shape.length-1),n=t}else s=e;const o=He(s),a=Qe(Jn(s,o),[r,n]),i=Sa(a),u=Math.floor(n/2)+1,l=Ia(i),c=Na(i),h=Lt(l,[u,n-u],l.shape.length-1),p=Lt(c,[u,n-u],c.shape.length-1),d=s.shape.slice();return d[s.shape.length-1]=u,Qe(Jn(h[0],p[0]),d)}});const zi=Fe({round_:function(e){const t=Ne(e,"x","round"),n={x:t};return ke.runKernelFunc(e=>e.round(t),n,null,"Round")}});const qi=Fe({selu_:function(e){const t=Ne(e,"x","selu"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.selu(t);return n([t]),r},n,null,"Selu")}});const Li=Fe({separableConv2d_:function(e,t,n,r,s,o=[1,1],a="NHWC"){const i=Ne(e,"x","separableConv2d"),u=Ne(t,"depthwiseFilter","separableConv2d"),l=Ne(n,"pointwiseFilter","separableConv2d");let c=i,h=!1;if(3===i.rank&&(h=!0,c=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),"NCHW"===a)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");m(4===c.rank,()=>`Error in separableConv2d: input must be rank 4, but got rank ${c.rank}.`),m(4===u.rank,()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`),m(4===l.rank,()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`),m(1===l.shape[0],()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${l.shape[0]}.`),m(1===l.shape[1],()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${l.shape[1]}.`);const p=u.shape[2],d=u.shape[3];m(l.shape[2]===p*d,()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${p*d}, but got ${l.shape[2]}.`);const f=fa(c,u,r,s,a,o),g=Ut(f,l,1,"valid",a);return h?g.as3D(g.shape[1],g.shape[2],g.shape[3]):g}});const Oi=async function(e,t){const n=Ne(e,"x","setdiff1d"),r=Ne(t,"y","setdiff1d");m(n.dtype===r.dtype,()=>`x and y should have the same dtype, but got x (${n.dtype}) and y (${r.dtype}).`),m(1===n.rank,()=>`x should be 1D tensor, but got x (${n.shape}).`),m(1===r.rank,()=>`y should be 1D tensor, but got y (${r.shape}).`);const s=await n.data(),o=await r.data(),a=new Set(o);let i=0;for(let e=0;e<s.length;e++)a.has(s[e])||i++;const u=new ne([i],n.dtype),l=new ne([i],"int32");for(let e=0,t=0;e<s.length;e++)a.has(s[e])||(u.values[t]=s[e],l.values[t]=e,t++);return[u.toTensor(),l.toTensor()]};const Wi=Fe({sign_:function(e){const t=Ne(e,"x","sign"),n={x:t};return ke.runKernelFunc(e=>e.sign(t),n,null,"Sign")}});const Ki=Fe({slice1d_:function(e,t,n){const r=Ne(e,"x","slice1d");return m(1===r.rank,()=>`slice1d expects a rank-1 tensor, but got a rank-${r.rank} tensor`),ss(r,[t],[n])}});const Gi=Fe({slice2d_:function(e,t,n){const r=Ne(e,"x","slice2d");return m(2===r.rank,()=>`slice2d expects a rank-2 tensor, but got a rank-${r.rank} tensor`),ss(r,t,n)}});const Ui=Fe({slice3d_:function(e,t,n){const r=Ne(e,"x","slice3d");return m(3===r.rank,()=>`slice3d expects a rank-3 tensor, but got a rank-${r.rank} tensor`),ss(r,t,n)}});const Vi=Fe({slice4d_:function(e,t,n){const r=Ne(e,"x","slice4d");return m(4===r.rank,()=>`slice4d expects a rank-4 tensor, but got a rank-${r.rank} tensor`),ss(r,t,n)}});const Hi=Fe({softmax_:function(e,t=-1){const n=Ne(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${t}`);const r={logits:n},s={dim:t};return ke.runKernelFunc((e,r)=>{const s=e.softmax(n,t);return r([s]),s},r,null,"Softmax",s)}});const ji=Fe({softplus_:function(e){const t=Ne(e,"x","softplus"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.softplus(t);return n([t]),r},n,null,"Softplus")}});const Ji=Fe({squaredDifference_:function(e,t){let n=Ne(e,"a","squaredDifference"),r=Ne(t,"b","squaredDifference");[n,r]=fe(n,r),Ge(n.shape,r.shape);const s={a:n,b:r};return ke.runKernelFunc((e,t)=>{const s=e.squaredDifference(n,r);return t([n,r]),s},s,null,"SquaredDifference",{})}});const Yi=Fe({squeeze_:function(e,t){const n=Ne(e,"x","squeeze");return Qe(n,D(n.shape,t).newShape)}});const Zi=Fe({stridedSlice_:function(e,t,n,r,s=0,o=0,a=0,i=0,u=0){null==r&&(r=new Array(t.length));let l=Ne(e,"x","stridedSlice");const c={x:l},h={begin:t,end:n,strides:r,beginMask:s,endMask:o,ellipsisMask:a,newAxisMask:i,shrinkAxisMask:u};return ke.runKernelFunc(e=>{const c=Nr(a);if(c.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==a&&0!==i)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==a&&0!==u)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");const h=l.rank-t.length,p=Nr(i),d=l.shape.slice();if(p.forEach(e=>{t[e]=0,n[e]=1,d.splice(e,0,1)}),l=Qe(l,d),c.length&&h>0){const e=c[0],a=h+1;t=Mr(s,e,a,t,l.shape),n=$r(o,e,a,n,l.shape),r=Fr(r,e,a,l.shape)}else for(let e=0;e<l.rank;e++)t[e]=Br(s,t,r,l.shape,e,a),n[e]=Rr(o,n,r,l.shape,e,a),r[e]=_r(r,e,a);const f=Nr(u);f.forEach(e=>{n[e]=t[e]+1,r[e]=1});const m=Ir(t,n,r),g=m.filter((e,t)=>-1===f.indexOf(t));return r.every(e=>1===e)?Qe(ss(l,t,m),g):e.stridedSlice(l,t,n,r).reshape(g)},c,null,"StridedSlice",h)}});const Xi=Fe({tan_:function(e){const t=Ne(e,"x","tan"),n={x:t};return ke.runKernelFunc((e,n)=>{const r=e.tan(t);return n([t]),r},n,null,"Tan")}});function Qi(e,t,n){if(b(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");const r=Ee(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return Ce(e,t,r,n)}function eu(e,t,n){if(b(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");const r=Ee(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return Ce(e,t,r,n)}function tu(e,t,n){if(b(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");const r=Ee(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return Ce(e,t,r,n)}function nu(e,t,n){if(b(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");const r=Ee(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return Ce(e,t=t||r,r,n)}const ru=Fe({topk_:function(e,t=1,n=!0){const r=Ne(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const s=r.shape[r.shape.length-1];if(t>s)throw new Error(`'k' passed to topk() must be <= the last dimension (${s}) but got `+t);const o={x:r},a={k:t,sorted:n},[i,u]=ke.runKernelFunc(e=>e.topk(r,t,n),o,null,"TopK",a);return{values:i,indices:u}}});const su=Fe({truncatedNormal_:function(e,t=0,n=1,r,s){if(null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");const o=new xi(t,n,r,!0,s),a=na(e,r);for(let e=0;e<a.values.length;e++)a.values[e]=o.nextValue();return a.toTensor()}});const ou=Fe({unstack_:function(e,t=0){const n=Ne(e,"x","unstack");m(t>=-n.shape.length&&t<n.shape.length,()=>`Axis = ${t} is not in [-${n.shape.length}, ${n.shape.length})`),t<0&&(t+=n.shape.length);const r={value:n},s={axis:t};return ke.runKernelFunc(e=>e.unstack(n,t),r,null,"Unpack",s)}});function au(e,t=!0,n,r){return ke.makeVariable(e,t,n,r)}function iu(e,t){const n=[];for(let e=0;e<t.length;e++)t[e]&&n.push(e);const r=na(e,"int32"),s=na([n.length,e.length],"int32");for(let t=0;t<n.length;t++){const o=r.indexToLoc(n[t]),a=t*e.length;s.values.set(o,a)}return s.toTensor()}const uu=async function(e){const t=Ne(e,"condition","whereAsync","bool"),n=await t.data(),r=iu(t.shape,n);return e!==t&&t.dispose(),r};const lu=async function(e,t,n){const r=Ne(e,"tensor","boolMask"),s=Ne(t,"mask","boolMask","bool"),o=null==n?0:n,a=s.rank,i=r.shape;m(a>0,()=>"mask cannot be scalar"),g(i.slice(o,o+a),s.shape,"mask's shape must match the first K dimensions of tensor's shape,");let u=1;for(let e=o;e<o+a;e++)u*=i[e];const l=i.slice(0,o).concat([u],i.slice(o+a)),c=r.reshape(l),h=s.reshape([-1]),p=await uu(h),d=p.squeeze([1]),f=ps(c,d,o);return e!==r&&r.dispose(),t!==s&&s.dispose(),d.dispose(),c.dispose(),h.dispose(),p.dispose(),f};const cu=Fe({equalStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","equalStrict"),r=Ne(t,"b","equalStrict");return g(n.shape,r.shape,"Error in equalStrict: "),n.equal(r)}}),hu=Fe({greaterEqualStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","greaterEqualStrict"),r=Ne(t,"b","greaterEqualStrict");return g(n.shape,r.shape,"Error in greaterEqualStrict: "),n.greaterEqual(r)}}),pu=Fe({greaterStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","greaterStrict"),r=Ne(t,"b","greaterStrict");return g(n.shape,r.shape,"Error in greaterStrict: "),n.greater(r)}}),du=Fe({lessEqualStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","lessEqualStrict"),r=Ne(t,"b","lessEqualStrict");return g(n.shape,r.shape,"Error in lessEqualStrict: "),n.lessEqual(r)}}),fu=Fe({lessStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","lessStrict"),r=Ne(t,"b","lessStrict");return g(n.shape,r.shape,"Error in lessStrict: "),n.less(r)}}),mu=Fe({notEqualStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","notEqualStrict"),r=Ne(t,"b","notEqualStrict");return g(n.shape,r.shape,"Error in notEqualStrict: "),n.notEqual(r)}});const gu=Fe({addStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","addStrict"),r=Ne(t,"b","addStrict");return g(n.shape,r.shape,"Error in addStrict: "),n.add(r)}}),bu=Fe({divStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","div"),r=Ne(t,"b","div");return g(n.shape,r.shape,"Error in divideStrict: "),n.div(r)}}),yu=Fe({maximumStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","maximumStrict"),r=Ne(t,"b","maximumStrict");return g(n.shape,r.shape,"Error in maximumStrict: "),n.maximum(r)}}),wu=Fe({minimumStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","minimumStrict"),r=Ne(t,"b","minimumStrict");return g(n.shape,r.shape,"Error in minimumStrict: "),n.minimum(r)}}),ku=Fe({modStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","modStrict"),r=Ne(t,"b","modStrict");return g(n.shape,r.shape,"Error in modStrict: "),n.mod(r)}}),vu=Fe({mulStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","mul"),r=Ne(t,"b","mul");return g(n.shape,r.shape,"Error in multiplyStrict: "),n.mul(r)}}),xu=Fe({powStrict_:function(e,t){return Ao("strict variants of ops have been deprecated and will be removed in future"),g(e.shape,t.shape,"Error in powStrict: "),e.pow(t)}}),Su=Fe({squaredDifferenceStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","squaredDifferenceStrict"),r=Ne(t,"b","squaredDifferenceStrict");return g(n.shape,r.shape,"Error in squaredDifferenceStrict: "),n.squaredDifference(r)}}),Eu=Fe({subStrict_:function(e,t){Ao("strict variants of ops have been deprecated and will be removed in future");const n=Ne(e,"a","subStrict"),r=Ne(t,"b","subStrict");return g(n.shape,r.shape,"Error in subStrict: "),n.sub(r)}});const Du=Fe({norm_:function(e,t="euclidean",n=null,r=!1){const s=function e(t,n,r=null){if(0===t.rank)return _o(t);if(1!==t.rank&&null===r)return e(Qe(t,[-1]),n,r);if(1===t.rank||"number"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return it(_o(t),r);if(n===1/0)return La(_o(t),r);if(n===-1/0)return Ja(_o(t),r);if("euclidean"===n||2===n)return ze(it(tr(_o(t),Pe(2,"int32")),r));throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return La(it(_o(t),r[0]),r[1]-1);if(n===1/0)return La(it(_o(t),r[1]),r[0]);if(n===-1/0)return Ja(it(_o(t),r[1]),r[0]);if("fro"===n||"euclidean"===n)return ze(it(qe(t),r));throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+r)}(e=Ne(e,"x","norm"),t,n);let o=s.shape;if(r){const t=E(n,e.shape);o=rt(s.shape,t)}return s.reshape(o)}});const Nu=Fe({movingAverage_:function(e,t,n,r,s=!0){const o=Ne(e,"v","movingAverage"),a=Ne(t,"x","movingAverage"),i=Ne(n,"decay","movingAverage");me(o,a),m(k(o.shape,a.shape),()=>"Shape mismatch in v and x");const u=Pe(1),l=Le(u,i);let c=Te(Le(a,o),l);if(s){m(null!=r,()=>"When using zeroDebias: true, step is required.");const e=Ne(r,"step","movingAverage");c=Be(c,Le(u,tr(i,e)))}return Ze(o,c)}});const Iu=Fe({scatterND_:function(e,t,n){const r=Ne(e,"indices","scatterND","int32"),s=Ne(t,"updates","scatterND");yo(s,r,n);const o={indices:r,updates:s},a={shape:n};return ke.runKernelFunc(e=>e.scatterND(r,s,n),o,null,"ScatterNd",a)}});const Fu=Fe({sparseToDense_:function(e,t,n,r=0){const s=Ne(e,"sparseIndices","sparseToDense","int32"),o=Ne(t,"sparseValues","sparseToDense"),a=Ne(r,"defaultValue","sparseToDense",o.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error(`tf.sparseToDense() expects the indices to be int32 type, but the dtype was ${e.dtype}.`);if(e.rank>2)throw new Error(`sparseIndices should be a scalar, vector, or matrix, but got shape ${e.shape}.`);const s=e.rank>0?e.shape[0]:1,o=e.rank>1?e.shape[1]:1;if(n.length!==o)throw new Error(`outputShape has incorrect number of elements:, ${n.length}, should be: ${o}.`);const a=t.size;if(0!==t.rank&&(1!==t.rank||a!==s))throw new Error(`sparseValues has incorrect shape ${t.shape}, should be [] or [${s}]`);if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(s,o,n,a);const i={sparseIndices:s,sparseValues:o,defaultValue:a},u={outputShape:n};return ke.runKernelFunc(e=>e.sparseToDense(s,o,n,a),i,null,"SparseToDense",u)}});const Au=Fe({gatherND_:function(e,t){const n=Ne(t,"indices","gatherND","int32"),r=Ne(e,"x","gatherND"),s={params:r,indices:n};return ke.runKernelFunc(e=>e.gatherND(r,n),s,null,"GatherNd")}});const Tu=Fe({dropout_:function(e,t,n,r){const s=Ne(e,"x","dropout");if(m("float32"===s.dtype,()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${s.dtype} tensor instead.`),m(t>=0&&t<1,()=>`rate must be a float in the range [0, 1), but got ${t}.`),0===t)return e instanceof oe?s.clone():s;const o=function(e,t){if(null==t)return e.shape.slice();if(k(e.shape,t))return t;if(e.shape.length===t.length){const n=[];for(let r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(s,n),a=1-t,i=Ii(o,0,1,"float32",r).add(a).floor().div(a);return s.mul(i)}});function Mu(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function $u(e,t,n){const r=1-e%2,s=new Float32Array(e);for(let o=0;o<e;++o){const a=2*Math.PI*o/(e+r-1);s[o]=t-n*Math.cos(a)}return Fi(s,"float32")}const _u=async function(e,t,n=1){const r=Ne(e,"predictions","inTopK"),s=Ne(t,"targets","inTopK");m(r.rank>1,()=>"inTopK() expects the predictions to be of rank 2 or higher, but got "+r.rank),m(r.rank-1===s.rank,()=>`predictions rank should be 1 larger than targets rank, but got predictions rank ${r.rank} and targets rank ${s.rank}`),g(r.shape.slice(0,r.shape.length-1),s.shape,"predictions's shape should be align with the targets' shape, except the last dimension.");const o=r.shape[r.shape.length-1];m(n>0&&n<=o,()=>`'k' passed to inTopK() must be > 0 && <= the predictions last dimension (${o}), but got ${n}`);const a=await r.data(),i=await s.data(),[u,l]=[a.length/o,o],c=N("bool",u);for(let e=0;e<u;e++){const t=e*l,r=a.subarray(t,t+l),s=[];for(let e=0;e<r.length;e++)s.push({value:r[e],index:e});s.sort((e,t)=>t.value-e.value),c[e]=0;for(let t=0;t<n;t++)if(s[t].index===i[e]){c[e]=1;break}}return e!==r&&r.dispose(),t!==s&&s.dispose(),Vr(c,s.shape,"bool")};function Bu(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return e.mul(t.step());throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function Ru(e,t){let n=t;const r=Ke(e.shape,t.shape);return r.length>0&&(n=n.sum(r)),n.reshape(e.shape)}function Cu(e,t,n){if("linear"===t)return e;if("relu"===t)return Mi(e);if("elu"===t)return wa(e);if("relu6"===t)return $i(e);if("prelu"===t)return li(e,n);throw new Error(`Unknown fused activation ${t}.`)}const Pu=(e,t)=>!(e>0)||"linear"===t;const zu=Fe({fusedConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:o=[1,1],dimRoundingMode:a,bias:i,activation:u="linear",preluActivationWeights:l}){if(u=u||"linear",!1===Pu(ke.state.gradientDepth,u)){let c=Ut(e,t,n,r,s,o,a);return null!=i&&(c=Ze(c,i)),Cu(c,u,l)}const c=Ne(e,"x","conv2d"),h=Ne(t,"filter","conv2d");let p=c,d=!1;3===c.rank&&(d=!0,p=c.as4D(1,c.shape[0],c.shape[1],c.shape[2])),m(4===p.rank,()=>"Error in fused conv2d: input must be rank 4, but got rank "+p.rank+"."),m(4===h.rank,()=>"Error in fused conv2d: filter must be rank 4, but got rank "+h.rank+"."),null!=a&&m(v(r),()=>`Error in fused conv2d: pad must be an integer when using, dimRoundingMode ${a} but got pad ${r}.`),m(p.shape[3]===h.shape[2],()=>`Error in conv2d: depth of input (${p.shape[3]}) must match input depth for filter ${h.shape[2]}.`),m(vt(n,o),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`),m("NHWC"===s,()=>`Error in conv2d: got dataFormat of ${s} but only NHWC is currently supported.`);const f=dt(p.shape,h.shape,n,o,r,a);let g,b;null!=i&&(g=Ne(i,"bias","fused conv2d"),[g]=fe(g,c),Ge(f.outShape,g.shape)),null!=l&&(b=Ne(l,"prelu weights","fused conv2d"));const y=(e,t)=>{const[s,a,i,l]=t,c=Bu(e,i,u);m(kt(o),()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${o}'`);const h=[Kt(a.shape,c,s,n,r),Wt(a,c,s.shape,n,r)];if(null!=l){const e=Ru(l,c);h.push(e)}return h},w=e=>e.fusedConv2d({input:p,filter:h,convInfo:f,bias:g,activation:u,preluActivationWeights:b}),k={x:p,filter:h,bias:g,preluActivationWeights:b},x={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a,activation:u};if(null==i){return Pa((e,t,n)=>{let r=ke.runKernelFunc(w,k,null,"FusedConv2D",x);return n([t,e,r]),d&&(r=r.as3D(r.shape[1],r.shape[2],r.shape[3])),{value:r,gradFunc:y}})(p,h)}return Pa((e,t,n,r)=>{let s=ke.runKernelFunc(w,k,null,"FusedConv2D",x);return r([t,e,s,n]),d&&(s=s.as3D(s.shape[1],s.shape[2],s.shape[3])),{value:s,gradFunc:y}})(p,h,g)}});const qu=Fe({fusedDepthwiseConv2d_:function({x:e,filter:t,strides:n,pad:r,dataFormat:s="NHWC",dilations:o=[1,1],dimRoundingMode:a,bias:i,activation:u="linear",preluActivationWeights:l}){if(!1===Pu(ke.state.gradientDepth,u)){let c=fa(e,t,n,r,s,o,a);return null!=i&&(c=Ze(c,i)),Cu(c,u,l)}const c=Ne(e,"x","depthwiseConv2d"),h=Ne(t,"filter","depthwiseConv2d");let p=c,d=!1;3===c.rank&&(d=!0,p=c.as4D(1,c.shape[0],c.shape[1],c.shape[2])),m(4===p.rank,()=>`Error in fused depthwiseConv2d: input must be rank 4, but got rank ${p.rank}.`),m(4===h.rank,()=>`Error in fused depthwiseConv2d: filter must be rank 4, but got rank ${h.rank}.`),m(p.shape[3]===h.shape[2],()=>`Error in fused depthwiseConv2d: number of input channels (${p.shape[3]}) must match the inChannels dimension in filter ${h.shape[2]}.`),null==o&&(o=[1,1]),m(vt(n,o),()=>`Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides ${n} and dilations '${o}'`),null!=a&&m(v(r),()=>`Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode ${a} but got pad ${r}.`);const f=dt(p.shape,h.shape,n,o,r,a,!0);let g,b;null!=i&&(g=Ne(i,"bias","fused conv2d"),[g]=fe(g,c),Ge(f.outShape,g.shape)),null!=l&&(b=Ne(l,"prelu weights","fused depthwiseConv2d"));const y=(e,t)=>{m(kt(o),()=>`Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '${o}'`);const[n,r,s,a]=t,i=Bu(e,s,u),l=sn(r.shape,i,n,f),c=rn(r,i,n.shape,f);if(null!=a){return[l,c,Ru(g,i)]}return[l,c]},w=e=>e.fusedDepthwiseConv2D({input:p,filter:h,convInfo:f,bias:g,activation:u,preluActivationWeights:b}),k={x:p,filter:h,bias:g,preluActivationWeights:b},x={strides:n,pad:r,dataFormat:s,dilations:o,dimRoundingMode:a,activation:u};if(null==i){return Pa((e,t,n)=>{let r=ke.runKernelFunc(w,k,null,"FusedDepthwiseConv2D",x);return n([t,e,r]),d&&(r=r.as3D(r.shape[1],r.shape[2],r.shape[3])),{value:r,gradFunc:y}})(p,h)}return Pa((e,t,n,r)=>{let s=ke.runKernelFunc(w,k,null,"FusedDepthwiseConv2D",x);return r([t,e,s,n]),d&&(s=s.as3D(s.shape[1],s.shape[2],s.shape[3])),{value:s,gradFunc:y}})(p,h,g)}});const Lu=Fe({fusedMatMul_:function({a:e,b:t,transposeA:n=!1,transposeB:r=!1,bias:s,activation:o="linear",preluActivationWeights:a}){if(!1===Pu(ke.state.gradientDepth,o)){let i=It(e,t,n,r);return null!=s&&(i=Ze(i,s)),Cu(i,o,a)}let i=Ne(e,"a","fused matMul"),u=Ne(t,"b","fused matMul");[i,u]=fe(i,u);const l=n?i.shape[i.rank-2]:i.shape[i.rank-1],c=r?u.shape[u.rank-1]:u.shape[u.rank-2],h=n?i.shape[i.rank-1]:i.shape[i.rank-2],p=r?u.shape[u.rank-2]:u.shape[u.rank-1],d=i.shape.slice(0,-2),f=u.shape.slice(0,-2),g=w(d),b=w(f);m(i.rank>=2&&u.rank>=2&&i.rank===u.rank,()=>`Error in fused matMul: inputs must have the same rank of at least 2, got ranks ${i.rank} and ${u.rank}.`),m(k(d,f),()=>`Error in fused matMul: outer dimensions (${d}) and (${f}) of Tensors with shapes ${i.shape} and `+u.shape+" must match."),m(l===c,()=>`Error in fused matMul: inner shapes (${l}) and (${c}) of Tensors with shapes ${i.shape} and ${u.shape} and transposeA=${n} and transposeB=${r} must match.`);const y=i.shape.slice(0,-2).concat([h,p]),v=n?i.as3D(g,l,h):i.as3D(g,h,l),x=r?u.as3D(b,p,c):u.as3D(b,c,p);let S,E;null!=s&&(S=Ne(s,"bias","fused matMul"),[S]=fe(S,i),Ge(y,S.shape)),null!=a&&(E=Ne(a,"prelu weights","fused matMul"));const D=(e,t)=>{const[a,i,u,l]=t,c=Bu(Qe(e,u.shape),u,o);let h,p;if(n||r?!n&&r?(h=It(c,i,!1,!1),p=It(c,a,!0,!1)):n&&!r?(h=It(i,c,!1,!0),p=It(a,c,!1,!1)):(h=It(i,c,!0,!0),p=It(c,a,!0,!0)):(h=It(c,i,!1,!0),p=It(a,c,!0,!1)),null!=s){return[h,p,Ru(l,c)]}return[h,p]},N=e=>e.fusedBatchMatMul({a:v,b:x,transposeA:n,transposeB:r,bias:S,activation:o,preluActivationWeights:E}),I={a:v,b:x,bias:S,preluActivationWeights:E},F={transposeA:n,transposeB:r,activation:o};if(null==s){return Pa((e,t,n)=>{const r=ke.runKernelFunc(N,I,null,"_FusedMatMul",F);return n([e,t,r]),{value:Qe(r,y),gradFunc:D}})(v,x)}return Pa((e,t,n,r)=>{const s=ke.runKernelFunc(N,I,null,"_FusedMatMul",F);return r([e,t,s,n]),{value:Qe(s,y),gradFunc:D}})(v,x,S)}});var Ou=Object.freeze({__proto__:null,conv2d:zu,depthwiseConv2d:qu,matMul:Lu});const Wu=Fe({hammingWindow_:function(e){return $u(e,.54,.46)}});const Ku=Fe({hannWindow_:function(e){return $u(e,.5,.5)}});const Gu=Fe({frame_:function(e,t,n,r=!1,s=0){let o=0;const a=[];for(;o+t<=e.size;)a.push(ss(e,o,t)),o+=n;if(r)for(;o<e.size;){const r=o+t-e.size,i=Hr([ss(e,o,t-r),Ea([r],s)]);a.push(i),o+=n}return 0===a.length?Qi([],[0,t]):Qe(Hr(a),[a.length,t])}});const Uu=Fe({stft_:function(e,t,n,r,s=Ku){null==r&&(r=Mu(t));const o=Gu(e,t,n),a=Te(o,s(t)),i=[];for(let e=0;e<o.shape[0];e++)i.push(Pi(ss(a,[e,0],[1,t]),r));return Hr(i)}});const Vu=Fe({cropAndResize_:function(e,t,n,r,s,o){const a=Ne(e,"image","cropAndResize"),i=Ne(t,"boxes","cropAndResize","float32"),u=Ne(n,"boxInd","cropAndResize","int32");s=s||"bilinear",o=o||0;const l=i.shape[0];m(4===a.rank,()=>`Error in cropAndResize: image must be rank 4,but got rank ${a.rank}.`),m(2===i.rank&&4===i.shape[1],()=>`Error in cropAndResize: boxes must be have size [${l},4] but had shape ${i.shape}.`),m(1===u.rank&&u.shape[0]===l,()=>`Error in cropAndResize: boxInd must be have size [${l}] but had shape ${i.shape}.`),m(2===r.length,()=>`Error in cropAndResize: cropSize must be of length 2, but got length ${r.length}.`),m(r[0]>=1&&r[1]>=1,()=>"cropSize must be atleast [1,1], but was "+r),m("bilinear"===s||"nearest"===s,()=>"method must be bilinear or nearest, but was "+s);const c={image:a,boxes:i,boxInd:u},h={method:s,extrapolationValue:o,cropSize:r};return ke.runKernelFunc(e=>e.cropAndResize(a,i,u,r,s,o),c,null,"CropAndResize",h)}});const Hu=Fe({rotateWithOffset_:function(e,t,n=0,r=.5){const s=Ne(e,"image","rotateWithOffset","float32");m(4===s.rank,()=>`Error in rotateWithOffset: image must be rank 4,but got rank ${s.rank}.`);const o={image:s},a={radians:t,fillValue:n,center:r};return ke.runKernel("RotateWithOffset",o,a)}});function ju(e,t,n,r,s,o){null==r&&(r=.5),null==s&&(s=Number.NEGATIVE_INFINITY),null==o&&(o=0);const a=e.shape[0];return n=Math.min(n,a),m(0<=r&&r<=1,()=>`iouThreshold must be in [0, 1], but was '${r}'`),m(2===e.rank,()=>`boxes must be a 2D tensor, but was of rank '${e.rank}'`),m(4===e.shape[1],()=>"boxes must have 4 columns, but 2nd dimension was "+e.shape[1]),m(1===t.rank,()=>"scores must be a 1D tensor"),m(t.shape[0]===a,()=>`scores has incompatible shape with boxes. Expected ${a}, but was `+t.shape[0]),m(0<=o&&o<=1,()=>`softNmsSigma must be in [0, 1], but was '${o}'`),{maxOutputSize:n,iouThreshold:r,scoreThreshold:s,softNmsSigma:o}}const Ju=Fe({nonMaxSuppression_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const o=Ne(e,"boxes","nonMaxSuppression"),a=Ne(t,"scores","nonMaxSuppression"),i=ju(o,a,n,r,s);n=i.maxOutputSize,r=i.iouThreshold,s=i.scoreThreshold;const u={maxOutputSize:n,iouThreshold:r,scoreThreshold:s};return ke.runKernelFunc(e=>e.nonMaxSuppression(o,a,n,r,s),{boxes:o,scores:a},null,"NonMaxSuppressionV3",u)}});function Yu(e,t,n){const r=function(e,t,n){return function(e,t,n){let r=0,s=e.length,o=0,a=!1;for(;r<s;){o=r+(s-r>>>1);const i=n(t,e[o]);i>0?r=o+1:(s=o,a=!i)}return a?r:-r-1}(e,t,n||Zu)}(e,t,n),s=r<0?-(r+1):r;e.splice(s,0,t)}function Zu(e,t){return e>t?1:e<t?-1:0}function Xu(e,t,n,r,s){return tl(e,t,n,r,s,0).selectedIndices}function Qu(e,t,n,r,s,o){return tl(e,t,n,r,s,0,!1,o,!0)}function el(e,t,n,r,s,o){return tl(e,t,n,r,s,o,!0)}function tl(e,t,n,r,s,o,a=!1,i=!1,u=!1){const l=[];for(let e=0;e<t.length;e++)t[e]>s&&l.push({score:t[e],boxIndex:e,suppressBeginIndex:0});l.sort(sl);const c=o>0?-.5/o:0,h=[],p=[];for(;h.length<n&&l.length>0;){const t=l.pop(),{score:n,boxIndex:o,suppressBeginIndex:a}=t;if(n<s)break;let i=!1;for(let n=h.length-1;n>=a;--n){const a=nl(e,o,h[n]);if(a>=r){i=!0;break}if(t.score=t.score*rl(r,c,a),t.score<=s)break}t.suppressBeginIndex=h.length,i||(t.score===n?(h.push(o),p.push(t.score)):t.score>s&&Yu(l,t,sl))}const d=h.length,f=n-d;i&&f>0&&(h.push(...new Array(f).fill(0)),p.push(...new Array(f).fill(0)));const m={selectedIndices:Fi(h,"int32")};return a&&(m.selectedScores=Fi(p,"float32")),u&&(m.validOutputs=Pe(d,"int32")),m}function nl(e,t,n){const r=e.subarray(4*t,4*t+4),s=e.subarray(4*n,4*n+4),o=Math.min(r[0],r[2]),a=Math.min(r[1],r[3]),i=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),l=Math.min(s[0],s[2]),c=Math.min(s[1],s[3]),h=Math.max(s[0],s[2]),p=Math.max(s[1],s[3]),d=(i-o)*(u-a),f=(h-l)*(p-c);if(d<=0||f<=0)return 0;const m=Math.max(o,l),g=Math.max(a,c),b=Math.min(i,h),y=Math.min(u,p),w=Math.max(b-m,0)*Math.max(y-g,0);return w/(d+f-w)}function rl(e,t,n){const r=Math.exp(t*n*n);return n<=e?r:0}function sl(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}const ol=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY){const o=Ne(e,"boxes","nonMaxSuppressionAsync"),a=Ne(t,"scores","nonMaxSuppressionAsync"),i=ju(o,a,n,r,s);n=i.maxOutputSize,r=i.iouThreshold,s=i.scoreThreshold;const u=await Promise.all([o.data(),a.data()]),l=Xu(u[0],u[1],n,r,s);return o!==e&&o.dispose(),a!==t&&a.dispose(),l};const al=Fe({nonMaxSuppressionWithScore_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=0){const a=Ne(e,"boxes","nonMaxSuppression"),i=Ne(t,"scores","nonMaxSuppression"),u=ju(a,i,n,r,s,o),l={boxes:a,scores:i},c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:s=u.scoreThreshold,softNmsSigma:o=u.softNmsSigma},h=ke.runKernel("NonMaxSuppressionV5",l,c);return{selectedIndices:h[0],selectedScores:h[1]}}});const il=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=0){const a=Ne(e,"boxes","nonMaxSuppressionAsync"),i=Ne(t,"scores","nonMaxSuppressionAsync"),u=ju(a,i,n,r,s,o);n=u.maxOutputSize,r=u.iouThreshold,s=u.scoreThreshold,o=u.softNmsSigma;const l=await Promise.all([a.data(),i.data()]),c=el(l[0],l[1],n,r,s,o);return a!==e&&a.dispose(),i!==t&&i.dispose(),c};const ul=Fe({nonMaxSuppressionPadded_:function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=!1){const a=Ne(e,"boxes","nonMaxSuppression"),i=Ne(t,"scores","nonMaxSuppression"),u=ju(a,i,n,r,s,null),l={boxes:a,scores:i},c={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:o},h=ke.runKernel("NonMaxSuppressionV4",l,c);return{selectedIndices:h[0],validOutputs:h[1]}}});const ll=async function(e,t,n,r=.5,s=Number.NEGATIVE_INFINITY,o=!1){const a=Ne(e,"boxes","nonMaxSuppressionAsync"),i=Ne(t,"scores","nonMaxSuppressionAsync"),u=ju(a,i,n,r,s,null),l=u.maxOutputSize,c=u.iouThreshold,h=u.scoreThreshold,[p,d]=await Promise.all([a.data(),i.data()]),f=Qu(p,d,l,c,h,o);return a!==e&&a.dispose(),i!==t&&i.dispose(),f};const cl=Fe({resizeBilinear_:function(e,t,n=!1){const r=Ne(e,"images","resizeBilinear");m(3===r.rank||4===r.rank,()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${r.rank}.`),m(2===t.length,()=>"Error in resizeBilinear: new shape must 2D, but got shape "+t+".");let s=r,o=!1;3===r.rank&&(o=!0,s=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));const[a,i]=t,u={images:s},l={alignCorners:n,size:t},c=ke.runKernelFunc((e,t)=>(t([s]),e.resizeBilinear(s,a,i,n)),u,null,"ResizeBilinear",l);return o?c.as3D(c.shape[1],c.shape[2],c.shape[3]):c}});const hl=Fe({resizeNearestNeighbor_:function(e,t,n=!1){const r=Ne(e,"images","resizeNearestNeighbor");m(3===r.rank||4===r.rank,()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${r.rank}.`),m(2===t.length,()=>"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+t+"."),m("float32"===r.dtype||"int32"===r.dtype,()=>"`images` must have `int32` or `float32` as dtype");let s=r,o=!1;3===r.rank&&(o=!0,s=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));const[a,i]=t,u={images:s},l={alignCorners:n,size:t},c=ke.runKernelFunc((e,t)=>(t([s]),e.resizeNearestNeighbor(s,a,i,n)),u,null,"ResizeNearestNeighbor",l);return o?c.as3D(c.shape[1],c.shape[2],c.shape[3]):c}});const pl=Fe({bandPart_:function(e,t,n){m(t%1==0,()=>`bandPart(): numLower must be an integer, got ${t}.`),m(n%1==0,()=>`bandPart(): numUpper must be an integer, got ${n}.`);const r=Ne(e,"a","bandPart");m(r.rank>=2,()=>`bandPart(): Rank must be at least 2, got ${r.rank}.`);const s=r.shape,[o,a]=r.shape.slice(-2);if(!(t<=o))throw new Error(`bandPart(): numLower (${t}) must not be greater than the number of rows (${o}).`);if(!(n<=a))throw new Error(`bandPart(): numUpper (${n}) must not be greater than the number of columns (${a}).`);t<0&&(t=o),n<0&&(n=a);const i=Qe(Ai(0,o,1,"int32"),[-1,1]),u=Ai(0,a,1,"int32"),l=Le(i,u),c=Ct(Rt(l,Pe(+t,"int32")),Bt(l,Pe(-n,"int32"))),h=Yn([o,a],r.dtype);return Qe(us(ou(Qe(r,[-1,o,a])).map(e=>Pt(c,e,h))),s)}});const dl=Fe({gramSchmidt_:function(e){let t;if(Array.isArray(e)){t=!1,m(null!=e&&e.length>0,()=>"Gram-Schmidt process: input must not be null, undefined, or empty");const n=e[0].shape[0];for(let t=1;t<e.length;++t)m(e[t].shape[0]===n,()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${e[t].shape[0]} vs. ${n})`)}else t=!0,e=Lt(e,e.shape[0],0).map(e=>Yi(e,[0]));m(e.length<=e[0].shape[0],()=>`Gram-Schmidt: Number of vectors (${e.length}) exceeds number of dimensions (${e[0].shape[0]}).`);const n=[],r=e;for(let t=0;t<e.length;++t)n.push(ke.tidy(()=>{let e=r[t];if(t>0)for(let r=0;r<t;++r){const t=Te(it(Te(n[r],e)),n[r]);e=Le(e,t)}return Be(e,Du(e,"euclidean"))}));return t?us(n,0):n}});function fl(e,t=!1){return ke.tidy(()=>{m(2===e.shape.length,()=>`qr2d() requires a 2D Tensor, but got a ${e.shape.length}D Tensor.`);const n=e.shape[0],r=e.shape[1];let s=xa(n),o=cr(e);const a=Qi([[1]],[1,1]);let i=cr(a);const u=n>=r?r:n;for(let e=0;e<u;++e){const t=o,u=i,l=s;[i,o,s]=ke.tidy(()=>{const t=ss(o,[e,e],[n-e,1]),u=Du(t),l=ss(o,[e,e],[1,1]),c=Pt(Kn(l,0),Qi([[-1]]),Qi([[1]])),h=Le(l,Te(c,u)),p=Be(t,h);i=1===p.shape[0]?cr(a):Hr([a,ss(p,[1,0],[p.shape[0]-1,p.shape[1]])],0);const d=Re(Be(It(c,h),u)),f=ss(o,[e,0],[n-e,r]),m=Te(d,i),g=en(i);if(0===e)o=Le(f,It(m,It(g,f)));else{const t=Le(f,It(m,It(g,f)));o=Hr([ss(o,[0,0],[e,r]),t],0)}const b=en(m),y=ss(s,[0,e],[n,s.shape[1]-e]);if(0===e)s=Le(y,It(It(y,i),b));else{const t=Le(y,It(It(y,i),b));s=Hr([ss(s,[0,0],[n,e]),t],1)}return[i,o,s]}),Mo([t,u,l])}return!t&&n>r&&(s=ss(s,[0,0],[n,r]),o=ss(o,[0,0],[r,r])),[s,o]})}const ml=Fe({qr_:function(e,t=!1){if(m(e.rank>=2,()=>"qr() requires input tensor to have a rank >= 2, but got rank "+e.rank),2===e.rank)return fl(e,t);{const n=e.shape.slice(0,e.shape.length-2).reduce((e,t)=>e*t),r=ou(Qe(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),s=[],o=[];return r.forEach(e=>{const[n,r]=fl(e,t);s.push(n),o.push(r)}),[Qe(us(s,0),e.shape),Qe(us(o,0),e.shape)]}}});var gl;(gl=e.Reduction||(e.Reduction={}))[gl.NONE=0]="NONE",gl[gl.MEAN=1]="MEAN",gl[gl.SUM=2]="SUM",gl[gl.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS";const bl=Fe({computeWeightedLoss_:function(t,n,r=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const s=Ne(t,"losses","computeWeightedLoss");let o=null;null!=n&&(o=Ne(n,"weights","computeWeightedLoss"));const a=null==o?s:Te(s,o);if(r===e.Reduction.NONE)return a;if(r===e.Reduction.SUM)return it(a);if(r===e.Reduction.MEAN){if(null==o)return ja(a);{const e=s.size/o.size,t=Be(it(a),it(o));return e>1?Be(t,Pe(e)):t}}if(r===e.Reduction.SUM_BY_NONZERO_WEIGHTS){if(null==o)return Be(it(a),Pe(s.size));{const e=Te(o,es(s.shape)),t=Ae(it(ti(e,Pe(0))),"float32");return Be(it(a),t)}}throw Error("Unknown reduction: "+r)}});const yl=Fe({absoluteDifference_:function(t,n,r,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const o=Ne(t,"labels","absoluteDifference"),a=Ne(n,"predictions","absoluteDifference");let i=null;null!=r&&(i=Ne(r,"weights","absoluteDifference")),g(o.shape,a.shape,"Error in absoluteDifference: ");const u=_o(Le(o,a));return bl(u,i,s)}});const wl=Fe({cosineDistance_:function(t,n,r,s,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=Ne(t,"labels","cosineDistance"),i=Ne(n,"predictions","cosineDistance");let u=null;null!=s&&(u=Ne(s,"weights","cosineDistance")),g(a.shape,i.shape,"Error in cosineDistance: ");const l=Pe(1),c=Le(l,it(Te(a,i),r,!0));return bl(c,u,o)}});const kl=Fe({hingeLoss_:function(t,n,r,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let o=Ne(t,"labels","hingeLoss");const a=Ne(n,"predictions","hingeLoss");let i=null;null!=r&&(i=Ne(r,"weights","hingeLoss")),g(o.shape,a.shape,"Error in hingeLoss: ");const u=Pe(1);o=Le(Te(Pe(2),o),u);const l=Mi(Le(u,Te(o,a)));return bl(l,i,s)}});const vl=Fe({huberLoss_:function(t,n,r,s=1,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=Ne(t,"labels","huberLoss"),i=Ne(n,"predictions","huberLoss");let u=null;null!=r&&(u=Ne(r,"weights","huberLoss")),g(a.shape,i.shape,"Error in huberLoss: ");const l=Pe(s),c=_o(Le(i,a)),h=Ya(c,l),p=Le(c,h),d=Ze(Te(Pe(.5),qe(h)),Te(l,p));return bl(d,u,o)}});const xl=Fe({logLoss_:function(t,n,r,s=1e-7,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const a=Ne(t,"labels","logLoss"),i=Ne(n,"predictions","logLoss");let u=null;null!=r&&(u=Ne(r,"weights","logLoss")),g(a.shape,i.shape,"Error in logLoss: ");const l=Pe(1),c=Pe(s),h=Re(Te(a,er(Ze(i,c)))),p=Te(Le(l,a),er(Ze(Le(l,i),c))),d=Le(h,p);return bl(d,u,o)}});const Sl=Fe({meanSquaredError_:function(t,n,r,s=e.Reduction.SUM_BY_NONZERO_WEIGHTS){const o=Ne(t,"labels","meanSquaredError"),a=Ne(n,"predictions","meanSquaredError");let i=null;null!=r&&(i=Ne(r,"weights","meanSquaredError")),g(o.shape,a.shape,"Error in meanSquaredError: ");const u=Ji(o,a);return bl(u,i,s)}});const El=Fe({sigmoidCrossEntropy_:function(t,n,r,s=0,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let a=Ne(t,"multiClassLabels","sigmoidCrossEntropy");const i=Ne(n,"logits","sigmoidCrossEntropy");let u=null;if(null!=r&&(u=Ne(r,"weights","sigmoidCrossEntropy")),g(a.shape,i.shape,"Error in sigmoidCrossEntropy: "),s>0){const e=Pe(s),t=Pe(1),n=Pe(.5);a=Ze(Te(a,Le(t,e)),Te(n,e))}const l=function(e,t){const n=Ne(e,"labels","sigmoidCrossEntropyWithLogits"),r=Ne(t,"logits","sigmoidCrossEntropyWithLogits");g(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");const s=Mi(r),o=Te(r,n),a=Ra(cn(Re(_o(r))));return Ze(Le(s,o),a)}(a,i);return bl(l,u,o)}});const Dl=Fe({softmaxCrossEntropy_:function(t,n,r,s=0,o=e.Reduction.SUM_BY_NONZERO_WEIGHTS){let a=Ne(t,"onehotLabels","softmaxCrossEntropy");const i=Ne(n,"logits","softmaxCrossEntropy");let u=null;if(null!=r&&(u=Ne(r,"weights","softmaxCrossEntropy")),g(a.shape,i.shape,"Error in softmaxCrossEntropy: "),s>0){const e=Pe(s),t=Pe(1),n=Pe(a.shape[1]);a=Ze(Te(a,Le(t,e)),Be(e,n))}const l=function(e,t,n=-1){if(-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error(`Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank ${t.rank} and dim was `+n);return Pa((e,t,r)=>{const s=Wa(t,[n],!0),o=Le(Ae(t,"float32"),s);r([e,o]);const a=Re(Te(o,e));return{value:it(a,[n]),gradFunc:(e,t)=>{const[r,s]=t,o=rt(e.shape,[n]);return[Te(Qe(e,o),Le(Ae(r,"float32"),cn(s))),Te(Qe(e,o),Le(cn(s),Ae(r,"float32")))]}}})(e,t)}(a,i);return bl(l,u,o)}}),Nl={fft:Sa,ifft:Da,rfft:Pi,irfft:Fa},Il={hammingWindow:Wu,hannWindow:Ku,frame:Gu,stft:Uu},Fl={resizeNearestNeighbor:hl,resizeBilinear:cl,rotateWithOffset:Hu,cropAndResize:Vu,nonMaxSuppression:Ju,nonMaxSuppressionAsync:ol,nonMaxSuppressionWithScore:al,nonMaxSuppressionWithScoreAsync:il,nonMaxSuppressionPadded:ul,nonMaxSuppressionPaddedAsync:ll},Al={bandPart:pl,gramSchmidt:dl,qr:ml},Tl={absoluteDifference:yl,computeWeightedLoss:bl,cosineDistance:wl,hingeLoss:kl,huberLoss:vl,logLoss:xl,meanSquaredError:Sl,sigmoidCrossEntropy:El,softmaxCrossEntropy:Dl};var Ml=Object.freeze({__proto__:null,image:Fl,linalg:Al,losses:Tl,spectral:Nl,fused:Ou,signal:Il,abs:_o,acos:Bo,acosh:Ro,add:Ze,addN:Co,all:Po,any:zo,argMax:qo,argMin:Lo,asin:Oo,asinh:Wo,atan:Ko,atan2:Go,atanh:Uo,avgPool:Vo,avgPool3d:Ho,basicLSTMCell:Jo,batchToSpaceND:Wr,batchNorm:Zo,batchNorm2d:Xo,batchNorm3d:Qo,batchNorm4d:ea,broadcastTo:ta,buffer:na,cast:Ae,ceil:ra,clipByValue:sa,clone:cr,complex:Jn,concat:Hr,concat1d:oa,concat2d:aa,concat3d:ia,concat4d:ua,conv1d:la,conv2d:Ut,conv2dTranspose:ca,conv3d:ha,conv3dTranspose:pa,cos:kr,cosh:xr,cumsum:tn,depthToSpace:da,depthwiseConv2d:fa,diag:ma,dilation2d:ga,div:Be,divNoNan:ba,dot:ya,elu:wa,equal:_n,erf:ka,exp:cn,expandDims:is,expm1:va,eye:xa,fft:Sa,fill:Ea,floor:Un,floorDiv:_e,gather:ps,greater:Kn,greaterEqual:Bt,ifft:Da,imag:Na,irfft:Fa,isFinite:Aa,isInf:Ta,isNaN:Ma,leakyRelu:$a,less:Cn,lessEqual:Rt,linspace:_a,localResponseNormalization:Ba,log:er,log1p:Ra,logSigmoid:qa,logSoftmax:Oa,logSumExp:Wa,logicalAnd:Ct,logicalNot:mr,logicalOr:Ka,logicalXor:Ga,matMul:It,max:La,maxPool:Ua,maxPool3d:Va,maxPoolWithArgmax:Ha,maximum:ds,mean:ja,min:Ja,minimum:Ya,mod:Za,moments:Xa,mul:Te,multiRNNCell:Qa,multinomial:ei,neg:Re,notEqual:ti,oneHot:io,ones:es,onesLike:ni,outerProduct:ri,pad:Er,pad1d:si,pad2d:oi,pad3d:ai,pad4d:ii,pool:ui,pow:tr,prelu:li,print:ci,prod:hi,rand:pi,randomGamma:Di,randomNormal:Ni,randomUniform:Ii,range:Ai,real:Ia,reciprocal:Ti,relu:Mi,relu6:$i,reshape:Qe,reverse:hr,reverse1d:_i,reverse2d:Bi,reverse3d:Ri,reverse4d:Ci,rfft:Pi,round:zi,rsqrt:gn,scalar:Pe,selu:qi,separableConv2d:Li,setdiff1dAsync:Oi,sigmoid:Lr,sign:Wi,sin:Yt,sinh:Xt,slice:ss,slice1d:Ki,slice2d:Gi,slice3d:Ui,slice4d:Vi,softmax:Hi,softplus:ji,spaceToBatchND:At,split:Lt,sqrt:ze,square:qe,squaredDifference:Ji,squeeze:Yi,stack:us,step:Me,stridedSlice:Zi,sub:Le,sum:it,tan:Xi,tanh:jo,tensor:Vr,tensor1d:Fi,tensor2d:Qi,tensor3d:co,tensor4d:eu,tensor5d:tu,tensor6d:nu,tile:bn,topk:ru,truncatedNormal:su,unsortedSegmentSum:wn,unstack:ou,variable:au,where:Pt,whereAsync:uu,zeros:Yn,zerosLike:He,op:Fe,booleanMaskAsync:lu,equalStrict:cu,greaterEqualStrict:hu,greaterStrict:pu,lessEqualStrict:du,lessStrict:fu,notEqualStrict:mu,addStrict:gu,divStrict:bu,maximumStrict:yu,minimumStrict:wu,modStrict:ku,mulStrict:vu,powStrict:xu,squaredDifferenceStrict:Su,subStrict:Eu,transpose:en,norm:Du,movingAverage:Nu,scatterND:Iu,sparseToDense:Fu,gatherND:Au,dropout:Tu,enclosingPowerOfTwo:Mu,cosineWindow:$u,inTopKAsync:_u});class $l extends vo{minimize(e,t=!1,n){const{value:r,grads:s}=this.computeGradients(e,n);if(null!=n){const e=n.map(e=>({name:e.name,tensor:s[e.name]}));this.applyGradients(e)}else this.applyGradients(s);return Mo(s),t?r:(r.dispose(),null)}get iterations(){return null==this.iterations_&&(this.iterations_=0),this.iterations_}incrementIterations(){this.iterations_=this.iterations+1}computeGradients(e,t){return Ca(e,t)}dispose(){null!=this.iterations_&&Mo(this.iterations_)}async saveIterations(){return null==this.iterations_&&(this.iterations_=0),{name:"iter",tensor:Pe(this.iterations_,"int32")}}async getWeights(){throw new Error("getWeights() is not implemented for this optimizer yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}async extractIterations(e){return this.iterations_=(await e[0].tensor.data())[0],e.slice(1)}}Object.defineProperty($l,Symbol.hasInstance,{value:e=>null!=e.minimize&&null!=e.computeGradients&&null!=e.applyGradients});class _l extends $l{constructor(e,t,n=null){super(),this.learningRate=e,this.rho=t,this.epsilon=n,this.accumulatedGrads=[],this.accumulatedUpdates=[],null==n&&(this.epsilon=ke.backend.epsilon())}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=ke.registeredVariables[t];null==this.accumulatedGrads[n]&&(this.accumulatedGrads[n]={originalName:t+"/accum_grad",variable:To(()=>He(r).variable(!1))}),null==this.accumulatedUpdates[n]&&(this.accumulatedUpdates[n]={originalName:t+"/accum_var",variable:To(()=>He(r).variable(!1))});const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedGrads[n].variable,a=this.accumulatedUpdates[n].variable;To(()=>{const e=o.mul(this.rho).add(s.square().mul(1-this.rho)),t=a.add(this.epsilon).sqrt().div(o.add(this.epsilon).sqrt()).mul(s),n=a.mul(this.rho).add(t.square().mul(1-this.rho));o.assign(e),a.assign(n);const i=t.mul(-this.learningRate).add(r);r.assign(i)})}),this.incrementIterations()}dispose(){null!=this.accumulatedUpdates&&(Mo(this.accumulatedGrads.map(e=>e.variable)),Mo(this.accumulatedUpdates.map(e=>e.variable)))}async getWeights(){const e=[...this.accumulatedGrads,...this.accumulatedUpdates];return[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){const t=(e=await this.extractIterations(e)).length/2;this.accumulatedGrads=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedUpdates=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.rho,t.epsilon)}}_l.className="Adadelta",So(_l);class Bl extends $l{constructor(e,t=.1){super(),this.learningRate=e,this.initialAccumulatorValue=t,this.accumulatedGrads=[]}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=ke.registeredVariables[t];if(null==this.accumulatedGrads[n]){const e=!1;this.accumulatedGrads[n]={originalName:t+"/accumulator",variable:To(()=>Ea(r.shape,this.initialAccumulatorValue).variable(e))}}const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedGrads[n].variable;To(()=>{const e=o.add(s.square());o.assign(e);const t=s.div(e.add(ke.backend.epsilon()).sqrt()).mul(-this.learningRate).add(r);r.assign(t)})}),this.incrementIterations()}dispose(){null!=this.accumulatedGrads&&Mo(this.accumulatedGrads.map(e=>e.variable))}async getWeights(){return[await this.saveIterations()].concat(this.accumulatedGrads.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);this.accumulatedGrads=e.map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}}static fromConfig(e,t){return new e(t.learningRate,t.initialAccumulatorValue)}}Bl.className="Adagrad",So(Bl);class Rl extends $l{constructor(e,t,n,r=null){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.accumulatedFirstMoment=[],this.accumulatedSecondMoment=[],To(()=>{this.accBeta1=Pe(t).variable(),this.accBeta2=Pe(n).variable()}),null==r&&(this.epsilon=ke.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);To(()=>{const n=Le(1,this.accBeta1),r=Le(1,this.accBeta2);t.forEach((t,s)=>{const o=ke.registeredVariables[t];null==this.accumulatedFirstMoment[s]&&(this.accumulatedFirstMoment[s]={originalName:t+"/m",variable:To(()=>He(o).variable(!1))}),null==this.accumulatedSecondMoment[s]&&(this.accumulatedSecondMoment[s]={originalName:t+"/v",variable:To(()=>He(o).variable(!1))});const a=Array.isArray(e)?e[s].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[s].variable,u=this.accumulatedSecondMoment[s].variable,l=i.mul(this.beta1).add(a.mul(1-this.beta1)),c=u.mul(this.beta2).add(a.square().mul(1-this.beta2)),h=l.div(n),p=c.div(r);i.assign(l),u.assign(c);const d=h.div(p.sqrt().add(this.epsilon)).mul(-this.learningRate).add(o);o.assign(d)}),this.accBeta1.assign(this.accBeta1.mul(this.beta1)),this.accBeta2.assign(this.accBeta2.mul(this.beta2))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&Mo(this.accumulatedFirstMoment.map(e=>e.variable)),null!=this.accumulatedSecondMoment&&Mo(this.accumulatedSecondMoment.map(e=>e.variable))}async getWeights(){const e=[...this.accumulatedFirstMoment,...this.accumulatedSecondMoment];return[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e),To(()=>{this.accBeta1.assign(tr(this.beta1,this.iterations_+1)),this.accBeta2.assign(tr(this.beta2,this.iterations_+1))});const t=e.length/2;this.accumulatedFirstMoment=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedSecondMoment=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon)}}Rl.className="Adam",So(Rl);class Cl extends $l{constructor(e,t,n,r=null,s=0){super(),this.learningRate=e,this.beta1=t,this.beta2=n,this.epsilon=r,this.decay=s,this.accumulatedFirstMoment=[],this.accumulatedWeightedInfNorm=[],To(()=>{this.iteration=Pe(0).variable(),this.accBeta1=Pe(t).variable()}),null==r&&(this.epsilon=ke.backend.epsilon())}applyGradients(e){const t=Array.isArray(e)?e.map(e=>e.name):Object.keys(e);To(()=>{const n=Le(1,this.accBeta1),r=Be(-this.learningRate,this.iteration.mul(this.decay).add(1));t.forEach((t,s)=>{const o=ke.registeredVariables[t];null==this.accumulatedFirstMoment[s]&&(this.accumulatedFirstMoment[s]={originalName:t+"/m",variable:He(o).variable(!1)}),null==this.accumulatedWeightedInfNorm[s]&&(this.accumulatedWeightedInfNorm[s]={originalName:t+"/v",variable:He(o).variable(!1)});const a=Array.isArray(e)?e[s].tensor:e[t];if(null==a)return;const i=this.accumulatedFirstMoment[s].variable,u=this.accumulatedWeightedInfNorm[s].variable,l=i.mul(this.beta1).add(a.mul(1-this.beta1)),c=u.mul(this.beta2),h=a.abs(),p=c.maximum(h);i.assign(l),u.assign(p);const d=r.div(n).mul(l.div(p.add(this.epsilon))).add(o);o.assign(d)}),this.iteration.assign(this.iteration.add(1)),this.accBeta1.assign(this.accBeta1.mul(this.beta1))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&Mo(this.accumulatedFirstMoment.map(e=>e.variable)),null!=this.accumulatedWeightedInfNorm&&Mo(this.accumulatedWeightedInfNorm.map(e=>e.variable))}async getWeights(){throw new Error("getWeights() is not implemented for Adamax yet.")}async setWeights(e){throw new Error("setWeights() is not implemented for Adamax yet.")}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}}static fromConfig(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon,t.decay)}}Cl.className="Adamax",So(Cl);class Pl extends $l{constructor(e){super(),this.learningRate=e,this.setLearningRate(e)}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=Array.isArray(e)?e[n].tensor:e[t];if(null==r)return;const s=ke.registeredVariables[t];To(()=>{const e=this.c.mul(r).add(s);s.assign(e)})}),this.incrementIterations()}setLearningRate(e){this.learningRate=e,null!=this.c&&this.c.dispose(),this.c=$o(Pe(-e))}dispose(){this.c.dispose()}async getWeights(){return[await this.saveIterations()]}async setWeights(e){if(0!==(e=await this.extractIterations(e)).length)throw new Error("SGD optimizer does not have settable weights.")}getConfig(){return{learningRate:this.learningRate}}static fromConfig(e,t){return new e(t.learningRate)}}Pl.className="SGD",So(Pl);class zl extends Pl{constructor(e,t,n=!1){super(e),this.learningRate=e,this.momentum=t,this.useNesterov=n,this.accumulations=[],this.m=Pe(this.momentum)}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=ke.registeredVariables[t];if(null==this.accumulations[n]){const e=!1;this.accumulations[n]={originalName:t+"/momentum",variable:To(()=>He(r).variable(e))}}const s=this.accumulations[n].variable,o=Array.isArray(e)?e[n].tensor:e[t];null!=o&&To(()=>{let e;const t=this.m.mul(s).add(o);e=this.useNesterov?this.c.mul(o.add(t.mul(this.m))).add(r):this.c.mul(t).add(r),s.assign(t),r.assign(e)})}),this.incrementIterations()}dispose(){this.m.dispose(),null!=this.accumulations&&Mo(this.accumulations.map(e=>e.variable))}setMomentum(e){this.momentum=e}async getWeights(){return[await this.saveIterations()].concat(this.accumulations.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);this.accumulations=e.map(e=>({originalName:e.name,variable:e.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}}static fromConfig(e,t){return new e(t.learningRate,t.momentum,t.useNesterov)}}zl.className="Momentum",So(zl);class ql extends $l{constructor(e,t=.9,n=0,r=null,s=!1){if(super(),this.learningRate=e,this.decay=t,this.momentum=n,this.epsilon=r,this.accumulatedMeanSquares=[],this.accumulatedMoments=[],this.accumulatedMeanGrads=[],this.centered=s,null==r&&(this.epsilon=ke.backend.epsilon()),null==e)throw new Error("learningRate for RMSPropOptimizer must be defined.")}applyGradients(e){(Array.isArray(e)?e.map(e=>e.name):Object.keys(e)).forEach((t,n)=>{const r=ke.registeredVariables[t];null==this.accumulatedMeanSquares[n]&&(this.accumulatedMeanSquares[n]={originalName:t+"/rms",variable:To(()=>He(r).variable(!1))}),null==this.accumulatedMoments[n]&&(this.accumulatedMoments[n]={originalName:t+"/momentum",variable:To(()=>He(r).variable(!1))}),null==this.accumulatedMeanGrads[n]&&this.centered&&(this.accumulatedMeanGrads[n]={originalName:t+"/mg",variable:To(()=>He(r).variable(!1))});const s=Array.isArray(e)?e[n].tensor:e[t];if(null==s)return;const o=this.accumulatedMeanSquares[n].variable,a=this.accumulatedMoments[n].variable;To(()=>{const e=o.mul(this.decay).add(s.square().mul(1-this.decay));if(this.centered){const t=this.accumulatedMeanGrads[n].variable,i=t.mul(this.decay).add(s.mul(1-this.decay)),u=a.mul(this.momentum).add(s.mul(this.learningRate).div(e.sub(i.square().add(this.epsilon)).sqrt()));o.assign(e),t.assign(i),a.assign(u);const l=r.sub(u);r.assign(l)}else{const e=o.mul(this.decay).add(s.square().mul(1-this.decay)),t=a.mul(this.momentum).add(s.mul(this.learningRate).div(e.add(this.epsilon).sqrt()));o.assign(e),a.assign(t);const n=r.sub(t);r.assign(n)}})}),this.incrementIterations()}dispose(){null!=this.accumulatedMeanSquares&&Mo(this.accumulatedMeanSquares.map(e=>e.variable)),null!=this.accumulatedMeanGrads&&this.centered&&Mo(this.accumulatedMeanGrads.map(e=>e.variable)),null!=this.accumulatedMoments&&Mo(this.accumulatedMoments.map(e=>e.variable))}async getWeights(){const e=[...this.accumulatedMeanSquares,...this.accumulatedMoments];return this.centered&&e.push(...this.accumulatedMeanGrads),[await this.saveIterations()].concat(e.map(e=>({name:e.originalName,tensor:e.variable})))}async setWeights(e){e=await this.extractIterations(e);const t=this.centered?e.length/3:e.length/2;this.accumulatedMeanSquares=e.slice(0,t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.accumulatedMoments=e.slice(t,2*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})),this.centered&&(this.accumulatedMeanGrads=e.slice(2*t,3*t).map(e=>({originalName:e.name,variable:e.tensor.variable(!1)})))}getConfig(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}}static fromConfig(e,t){return new e(t.learningRate,t.decay,t.momentum,t.epsilon,t.centered)}}ql.className="RMSProp",So(ql);class Ll{static sgd(e){return new Pl(e)}static momentum(e,t,n=!1){return new zl(e,t,n)}static rmsprop(e,t=.9,n=0,r=null,s=!1){return new ql(e,t,n,r,s)}static adam(e=.001,t=.9,n=.999,r=null){return new Rl(e,t,n,r)}static adadelta(e=.001,t=.95,n=null){return new _l(e,t,n)}static adamax(e=.002,t=.9,n=.999,r=null,s=0){return new Cl(e,t,n,r,s)}static adagrad(e,t=.1){return new Bl(e,t)}}const Ol={sgd:Ll.sgd,momentum:Ll.momentum,adadelta:Ll.adadelta,adagrad:Ll.adagrad,rmsprop:Ll.rmsprop,adamax:Ll.adamax,adam:Ll.adam},Wl="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:e=>e();var Kl=Object.freeze({__proto__:null,segment_util:hs,castTensor:function(e,t,n){if("complex64"===t){if("complex64"===e.dtype)return e.clone();const t=Yn(e.shape),r=e.toFloat(),s=n.complex(r,t);return t.dispose(),r.dispose(),s}if(!T(e.dtype,t))return ke.makeTensorFromDataId(e.dataId,e.shape,t);if("complex64"===e.dtype){const r=n.real(e),s=r.cast(t);return r.dispose(),s}if("int32"===t)return n.int(e);if("bool"===t){const t=Pe(0,e.dtype),r=n.notEqual(e,t);return t.dispose(),r}throw new Error(`Error in Cast: failed to cast ${e.dtype} to ${t}`)},reshapeTensor:function(e,t){return ke.makeTensorFromDataId(e.dataId,t,e.dtype)},linspaceImpl:function(e,t,n){const r=(t-e)/(n-1),s=G(n,"float32");s[0]=e;for(let e=1;e<s.length;e++)s[e]=s[e-1]+r;return Fi(s,"float32")},upcastType:de,axesAreInnerMostDims:et,combineLocations:tt,computeOutAndReduceShapes:nt,expandShapeToKeepDim:rt,assertAxesAreInnerMostDims:function(e,t,n){m(et(t,n),()=>e+" supports only inner-most axes for now. "+`Got axes ${t} and rank-${n} input.`)},getAxesPermutation:st,getUndoAxesPermutation:ot,getInnerMostAxes:at,getBroadcastDims:function(e,t){const n=e.length,r=[];for(let s=0;s<n;s++){const o=n-1-s,a=e[o]||1;(t[t.length-1-s]||1)>1&&1===a&&r.unshift(o)}return r},getReductionAxes:Ke,assertAndGetBroadcastShape:Ge,assertParamsConsistent:Gr,computeOutShape:Ur,computeDilation2DInfo:function(e,t,n,r,s="NHWC",o){return dt(e,[...t,e[3]],n,o,r,null,null,xt(s))},computePool2DInfo:ht,computePool3DInfo:pt,computeConv2DInfo:dt,computeConv3DInfo:ft,computeDefaultPad:mt,tupleValuesAreOne:kt,eitherStridesOrDilationsAreOne:vt,convertConv2DDataFormat:xt,getFusedDyActivation:Bu,getFusedBiasGradient:Ru,applyActivation:Cu,shouldFuse:Pu,PARALLELIZE_THRESHOLD:30,computeOptimalWindowSize:function(e){return e<=30?e:q(e,Math.floor(Math.sqrt(e)))},getImageCenter:function(e,t,n){return[n*("number"==typeof e?e:e[0]),t*("number"==typeof e?e:e[1])]},getReshaped:function(e,t,n,r=!0){let s=[];if(r)s=s.concat(t.slice(0)),s.push(e[0]/n),s=s.concat(e.slice(1));else{s=s.concat(e[0]);const n=t.length;for(let r=0;r<n;++r)s=s.concat([e[r+1]/t[r],t[r]]);s=s.concat(e.slice(n+1))}return s},getPermuted:function(e,t,n=!0){const r=[];if(n){r.push(t);for(let n=t+1;n<e;++n)n<=2*t?(r.push(n),r.push(n-(t+1))):r.push(n)}else{const n=[],s=[];for(let r=1;r<e;++r)r>=2*t+1||r%2==1?s.push(r):n.push(r);r.push(...n),r.push(0),r.push(...s)}return r},getReshapedPermuted:function(e,t,n,r=!0){const s=[];r?s.push(e[0]/n):s.push(e[0]*n);for(let n=1;n<e.length;++n)n<=t.length?r?s.push(t[n-1]*e[n]):s.push(e[n]/t[n-1]):s.push(e[n]);return s},getSliceBeginCoords:function(e,t){const n=[0];for(let r=0;r<t;++r)n.push(e[r][0]);return n},getSliceSize:function(e,t,n){const r=e.slice(0,1);for(let s=0;s<n;++s)r.push(e[s+1]-t[s][0]-t[s][1]);return r},prepareAndValidate:mo,validateUpdateShape:bo,validateInput:yo,calculateShapes:wo,SELU_SCALEALPHA:1.7580993408473768,SELU_SCALE:1.0507009873554805,ERF_P:.3275911,ERF_A1:.254829592,ERF_A2:-.284496736,ERF_A3:1.421413741,ERF_A4:-1.453152027,ERF_A5:1.061405429,warn:function(...e){n().getBool("IS_TEST")||console.warn(...e)},log:function(...e){n().getBool("IS_TEST")||console.log(...e)},mergeRealAndImagArrays:function(e,t){if(e.length!==t.length)throw new Error(`Cannot merge real and imag arrays of different lengths. real:${e.length}, imag: ${t.length}.`);const n=new Float32Array(2*e.length);for(let r=0;r<n.length;r+=2)n[r]=e[r/2],n[r+1]=t[r/2];return n},splitRealAndImagArrays:function(e){const t=new Float32Array(e.length/2),n=new Float32Array(e.length/2);for(let r=0;r<e.length;r+=2)t[r/2]=e[r],n[r/2]=e[r+1];return{real:t,imag:n}},complexWithEvenIndex:function(e){const t=Math.ceil(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=0;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},complexWithOddIndex:function(e){const t=Math.floor(e.length/4),n=new Float32Array(t),r=new Float32Array(t);for(let t=2;t<e.length;t+=4)n[Math.floor(t/4)]=e[t],r[Math.floor(t/4)]=e[t+1];return{real:n,imag:r}},getComplexWithIndex:function(e,t){return{real:e[2*t],imag:e[2*t+1]}},assignToTypedArray:function(e,t,n,r){e[2*r]=t,e[2*r+1]=n},exponents:function(e,t){const n=new Float32Array(e/2),r=new Float32Array(e/2);for(let s=0;s<Math.ceil(e/2);s++){const o=(t?2:-2)*Math.PI*(s/e);n[s]=Math.cos(o),r[s]=Math.sin(o)}return{real:n,imag:r}},exponent:function(e,t,n){const r=(n?2:-2)*Math.PI*(e/t);return{real:Math.cos(r),imag:Math.sin(r)}},prepareSplitSize:qt});var Gl=Object.freeze({__proto__:null,nonMaxSuppressionV3Impl:Xu,nonMaxSuppressionV4Impl:Qu,nonMaxSuppressionV5Impl:el,split:function(e,t,n){const r=new Array(e.rank).fill(0),s=e.shape.slice();return t.map(t=>{const o=[...s];o[n]=t;const a=e.slice(r,o);return r[n]+=t,a})},tile:function(e,t){const n=new Array(e.rank);for(let r=0;r<n.length;r++)n[r]=e.shape[r]*t[r];const r=na(n,e.dtype);for(let t=0;t<r.values.length;++t){const n=r.indexToLoc(t),s=new Array(e.rank);for(let t=0;t<s.length;t++)s[t]=n[t]%e.shape[t];const o=e.locToIndex(s);r.values[t]=e.values[o]}return r.toTensor()},topkImpl:function(e,t,n,r,s){const o=t[t.length-1],[a,i]=[e.length/o,o],u=N(n,a*r),l=N("int32",a*r);for(let t=0;t<a;t++){const n=t*i,s=e.subarray(n,n+i),o=[];for(let e=0;e<s.length;e++)o.push({value:s[e],index:e});o.sort((e,t)=>t.value-e.value);const a=t*r,c=u.subarray(a,a+r),h=l.subarray(a,a+r);for(let e=0;e<r;e++)c[e]=o[e].value,h[e]=o[e].index}const c=t.slice();return c[c.length-1]=r,[Vr(u,c,n),Vr(l,c,"int32")]},whereImpl:iu});function Ul(e){throw new Error(`'${e}' not yet implemented or not found in the registry. Did you forget to import the kernel?`)}oe.prototype.abs=function(){return this.throwIfDisposed(),_o(this)},oe.prototype.acos=function(){return this.throwIfDisposed(),Bo(this)},oe.prototype.acosh=function(){return this.throwIfDisposed(),Ro(this)},oe.prototype.addStrict=function(e){return this.throwIfDisposed(),gu(this,e)},oe.prototype.add=function(e){return this.throwIfDisposed(),Ze(this,e)},oe.prototype.all=function(e,t){return this.throwIfDisposed(),Po(this,e,t)},oe.prototype.any=function(e,t){return this.throwIfDisposed(),zo(this,e,t)},oe.prototype.argMax=function(e){return this.throwIfDisposed(),qo(this,e)},oe.prototype.argMin=function(e){return this.throwIfDisposed(),Lo(this,e)},oe.prototype.asScalar=function(){return this.throwIfDisposed(),m(1===this.size,()=>"The array must have only 1 element."),Qe(this,[])},oe.prototype.asType=function(e){return this.throwIfDisposed(),Ae(this,e)},oe.prototype.as1D=function(){return this.throwIfDisposed(),Qe(this,[this.size])},oe.prototype.as2D=function(e,t){return this.throwIfDisposed(),Qe(this,[e,t])},oe.prototype.as3D=function(e,t,n){return this.throwIfDisposed(),Qe(this,[e,t,n])},oe.prototype.as4D=function(e,t,n,r){return this.throwIfDisposed(),Qe(this,[e,t,n,r])},oe.prototype.as5D=function(e,t,n,r,s){return this.throwIfDisposed(),Qe(this,[e,t,n,r,s])},oe.prototype.asin=function(){return this.throwIfDisposed(),Oo(this)},oe.prototype.asinh=function(){return this.throwIfDisposed(),Wo(this)},oe.prototype.atan=function(){return this.throwIfDisposed(),Ko(this)},oe.prototype.atan2=function(e){return this.throwIfDisposed(),Go(this,e)},oe.prototype.atanh=function(){return this.throwIfDisposed(),Uo(this)},oe.prototype.avgPool=function(e,t,n,r){return this.throwIfDisposed(),Vo(this,e,t,n,r)},oe.prototype.batchToSpaceND=function(e,t){return this.throwIfDisposed(),Wr(this,e,t)},oe.prototype.batchNorm=function(e,t,n,r,s){return this.throwIfDisposed(),Zo(this,e,t,n,r,s)},oe.prototype.broadcastTo=function(e){return this.throwIfDisposed(),ta(this,e)},oe.prototype.cast=function(e){return this.throwIfDisposed(),Ae(this,e)},oe.prototype.ceil=function(){return this.throwIfDisposed(),ra(this)},oe.prototype.clipByValue=function(e,t){return this.throwIfDisposed(),sa(this,e,t)},oe.prototype.concat=function(e,t){return this.throwIfDisposed(),e instanceof oe&&(e=[e]),Hr([this,...e],t)},oe.prototype.conv1d=function(e,t,n,r,s,o){return this.throwIfDisposed(),la(this,e,t,n,r,s,o)},oe.prototype.conv2dTranspose=function(e,t,n,r,s){return this.throwIfDisposed(),ca(this,e,t,n,r,s)},oe.prototype.conv2d=function(e,t,n,r,s,o){return this.throwIfDisposed(),Ut(this,e,t,n,r,s,o)},oe.prototype.cos=function(){return this.throwIfDisposed(),kr(this)},oe.prototype.cosh=function(){return this.throwIfDisposed(),xr(this)},oe.prototype.cumsum=function(e,t,n){return this.throwIfDisposed(),tn(this,e,t,n)},oe.prototype.depthToSpace=function(e,t){return this.throwIfDisposed(),da(this,e,t)},oe.prototype.depthwiseConv2D=function(e,t,n,r,s,o){return Ao("depthwiseConv2D is deprecated, use depthwiseConv2d instead"),this.throwIfDisposed(),fa(this,e,t,n,r,s,o)},oe.prototype.depthwiseConv2d=function(e,t,n,r,s,o){return this.throwIfDisposed(),fa(this,e,t,n,r,s,o)},oe.prototype.dilation2d=function(e,t,n,r,s){return this.throwIfDisposed(),ga(this,e,t,n,r,s)},oe.prototype.divNoNan=function(e){return this.throwIfDisposed(),ba(this,e)},oe.prototype.divStrict=function(e){return this.throwIfDisposed(),bu(this,e)},oe.prototype.div=function(e){return this.throwIfDisposed(),Be(this,e)},oe.prototype.dot=function(e){return this.throwIfDisposed(),ya(this,e)},oe.prototype.elu=function(){return this.throwIfDisposed(),wa(this)},oe.prototype.equalStrict=function(e){return this.throwIfDisposed(),cu(this,e)},oe.prototype.equal=function(e){return this.throwIfDisposed(),_n(this,e)},oe.prototype.erf=function(){return this.throwIfDisposed(),ka(this)},oe.prototype.exp=function(){return this.throwIfDisposed(),cn(this)},oe.prototype.expandDims=function(e){return this.throwIfDisposed(),is(this,e)},oe.prototype.expm1=function(){return this.throwIfDisposed(),va(this)},oe.prototype.fft=function(){return this.throwIfDisposed(),Sa(this)},oe.prototype.flatten=function(){return this.throwIfDisposed(),Qe(this,[this.size])},oe.prototype.floor=function(){return this.throwIfDisposed(),Un(this)},oe.prototype.floorDiv=function(e){return this.throwIfDisposed(),_e(this,e)},oe.prototype.gather=function(e,t){return this.throwIfDisposed(),ps(this,e,t)},oe.prototype.greaterEqualStrict=function(e){return this.throwIfDisposed(),hu(this,e)},oe.prototype.greaterEqual=function(e){return this.throwIfDisposed(),Bt(this,e)},oe.prototype.greaterStrict=function(e){return this.throwIfDisposed(),pu(this,e)},oe.prototype.greater=function(e){return this.throwIfDisposed(),Kn(this,e)},oe.prototype.ifft=function(){return this.throwIfDisposed(),Da(this)},oe.prototype.irfft=function(){return this.throwIfDisposed(),Fa(this)},oe.prototype.isFinite=function(){return this.throwIfDisposed(),Aa(this)},oe.prototype.isInf=function(){return this.throwIfDisposed(),Ta(this)},oe.prototype.isNaN=function(){return this.throwIfDisposed(),Ma(this)},oe.prototype.leakyRelu=function(e){return this.throwIfDisposed(),$a(this,e)},oe.prototype.lessEqualStrict=function(e){return this.throwIfDisposed(),du(this,e)},oe.prototype.lessEqual=function(e){return this.throwIfDisposed(),Rt(this,e)},oe.prototype.lessStrict=function(e){return this.throwIfDisposed(),fu(this,e)},oe.prototype.less=function(e){return this.throwIfDisposed(),Cn(this,e)},oe.prototype.localResponseNormalization=function(e,t,n,r){return this.throwIfDisposed(),Ba(this,e,t,n,r)},oe.prototype.logSigmoid=function(){return this.throwIfDisposed(),qa(this)},oe.prototype.logSoftmax=function(e){return this.throwIfDisposed(),Oa(this,e)},oe.prototype.logSumExp=function(e,t){return this.throwIfDisposed(),Wa(this,e,t)},oe.prototype.log=function(){return this.throwIfDisposed(),er(this)},oe.prototype.log1p=function(){return this.throwIfDisposed(),Ra(this)},oe.prototype.logicalAnd=function(e){return this.throwIfDisposed(),Ct(this,e)},oe.prototype.logicalNot=function(){return this.throwIfDisposed(),mr(this)},oe.prototype.logicalOr=function(e){return this.throwIfDisposed(),Ka(this,e)},oe.prototype.logicalXor=function(e){return this.throwIfDisposed(),Ga(this,e)},oe.prototype.matMul=function(e,t,n){return this.throwIfDisposed(),It(this,e,t,n)},oe.prototype.maxPool=function(e,t,n,r){return this.throwIfDisposed(),Ua(this,e,t,n,r)},oe.prototype.max=function(e,t){return this.throwIfDisposed(),La(this,e,t)},oe.prototype.maximumStrict=function(e){return this.throwIfDisposed(),yu(this,e)},oe.prototype.maximum=function(e){return this.throwIfDisposed(),ds(this,e)},oe.prototype.mean=function(e,t){return this.throwIfDisposed(),ja(this,e,t)},oe.prototype.min=function(e,t){return this.throwIfDisposed(),Ja(this,e,t)},oe.prototype.minimumStrict=function(e){return this.throwIfDisposed(),wu(this,e)},oe.prototype.minimum=function(e){return this.throwIfDisposed(),Ya(this,e)},oe.prototype.modStrict=function(e){return this.throwIfDisposed(),ku(this,e)},oe.prototype.mod=function(e){return this.throwIfDisposed(),Za(this,e)},oe.prototype.mulStrict=function(e){return this.throwIfDisposed(),vu(this,e)},oe.prototype.mul=function(e){return this.throwIfDisposed(),Te(this,e)},oe.prototype.neg=function(){return this.throwIfDisposed(),Re(this)},oe.prototype.norm=function(e,t,n){return this.throwIfDisposed(),Du(this,e,t,n)},oe.prototype.notEqualStrict=function(e){return this.throwIfDisposed(),mu(this,e)},oe.prototype.notEqual=function(e){return this.throwIfDisposed(),ti(this,e)},oe.prototype.oneHot=function(e,t=1,n=0){return this.throwIfDisposed(),io(this,e,t,n)},oe.prototype.onesLike=function(){return this.throwIfDisposed(),ni(this)},oe.prototype.pad=function(e,t){return this.throwIfDisposed(),Er(this,e,t)},oe.prototype.pool=function(e,t,n,r,s){return this.throwIfDisposed(),ui(this,e,t,n,r,s)},oe.prototype.powStrict=function(e){return this.throwIfDisposed(),xu(this,e)},oe.prototype.pow=function(e){return this.throwIfDisposed(),tr(this,e)},oe.prototype.prelu=function(e){return this.throwIfDisposed(),li(this,e)},oe.prototype.prod=function(e,t){return this.throwIfDisposed(),hi(this,e,t)},oe.prototype.reciprocal=function(){return this.throwIfDisposed(),Ti(this)},oe.prototype.relu=function(){return this.throwIfDisposed(),Mi(this)},oe.prototype.relu6=function(){return this.throwIfDisposed(),$i(this)},oe.prototype.reshapeAs=function(e){return this.throwIfDisposed(),Qe(this,e.shape)},oe.prototype.reshape=function(e){return this.throwIfDisposed(),Qe(this,e)},oe.prototype.resizeBilinear=function(e,t){return this.throwIfDisposed(),cl(this,e,t)},oe.prototype.resizeNearestNeighbor=function(e,t){return this.throwIfDisposed(),hl(this,e,t)},oe.prototype.reverse=function(e){return this.throwIfDisposed(),hr(this,e)},oe.prototype.rfft=function(){return this.throwIfDisposed(),Pi(this)},oe.prototype.round=function(){return this.throwIfDisposed(),zi(this)},oe.prototype.rsqrt=function(){return this.throwIfDisposed(),gn(this)},oe.prototype.selu=function(){return this.throwIfDisposed(),qi(this)},oe.prototype.separableConv2d=function(e,t,n,r,s,o){return this.throwIfDisposed(),Li(this,e,t,n,r,s,o)},oe.prototype.sigmoid=function(){return this.throwIfDisposed(),Lr(this)},oe.prototype.sign=function(){return this.throwIfDisposed(),Wi(this)},oe.prototype.sin=function(){return this.throwIfDisposed(),Yt(this)},oe.prototype.sinh=function(){return this.throwIfDisposed(),Xt(this)},oe.prototype.slice=function(e,t){return this.throwIfDisposed(),ss(this,e,t)},oe.prototype.softmax=function(e){return this.throwIfDisposed(),Hi(this,e)},oe.prototype.softplus=function(){return this.throwIfDisposed(),ji(this)},oe.prototype.spaceToBatchND=function(e,t){return this.throwIfDisposed(),At(this,e,t)},oe.prototype.split=function(e,t){return this.throwIfDisposed(),Lt(this,e,t)},oe.prototype.sqrt=function(){return this.throwIfDisposed(),ze(this)},oe.prototype.square=function(){return this.throwIfDisposed(),qe(this)},oe.prototype.squaredDifference=function(e){return this.throwIfDisposed(),Ji(this,e)},oe.prototype.squaredDifferenceStrict=function(e){return this.throwIfDisposed(),Su(this,e)},oe.prototype.squeeze=function(e){return this.throwIfDisposed(),Yi(this,e)},oe.prototype.stack=function(e,t){this.throwIfDisposed();const n=e instanceof oe?[this,e]:[this,...e];return us(n,t)},oe.prototype.step=function(e){return this.throwIfDisposed(),Me(this,e)},oe.prototype.stridedSlice=function(e,t,n,r,s,o,a,i){return this.throwIfDisposed(),Zi(this,e,t,n,r,s,o,a,i)},oe.prototype.subStrict=function(e){return this.throwIfDisposed(),Eu(this,e)},oe.prototype.sub=function(e){return this.throwIfDisposed(),Le(this,e)},oe.prototype.sum=function(e,t){return this.throwIfDisposed(),it(this,e,t)},oe.prototype.tan=function(){return this.throwIfDisposed(),Xi(this)},oe.prototype.tanh=function(){return this.throwIfDisposed(),jo(this)},oe.prototype.tile=function(e){return this.throwIfDisposed(),bn(this,e)},oe.prototype.toBool=function(){return this.throwIfDisposed(),Ae(this,"bool")},oe.prototype.toFloat=function(){return this.throwIfDisposed(),Ae(this,"float32")},oe.prototype.toInt=function(){return this.throwIfDisposed(),Ae(this,"int32")},oe.prototype.topk=function(e,t){return this.throwIfDisposed(),ru(this,e,t)},oe.prototype.transpose=function(e){return this.throwIfDisposed(),en(this,e)},oe.prototype.unsortedSegmentSum=function(e,t){return this.throwIfDisposed(),wn(this,e,t)},oe.prototype.unstack=function(e){return this.throwIfDisposed(),ou(this,e)},oe.prototype.where=function(e,t){return this.throwIfDisposed(),Pt(e,this,t)},oe.prototype.zerosLike=function(){return this.throwIfDisposed(),He(this)},se=Ml,e.Abs="Abs",e.Acos="Acos",e.Acosh="Acosh",e.AdadeltaOptimizer=_l,e.AdagradOptimizer=Bl,e.AdamOptimizer=Rl,e.AdamaxOptimizer=Cl,e.Add="Add",e.AddN="AddN",e.All="All",e.Any="Any",e.ArgMax="ArgMax",e.ArgMin="ArgMin",e.Asin="Asin",e.Asinh="Asinh",e.Atan="Atan",e.Atan2="Atan2",e.Atanh="Atanh",e.AvgPool="AvgPool",e.AvgPool3D="AvgPool3D",e.AvgPool3DBackprop="AvgPool3DBackprop",e.AvgPoolBackprop="AvgPoolBackprop",e.BatchMatMul="BatchMatMul",e.BatchToSpaceND="BatchToSpaceND",e.BroadcastTo="BroadcastTo",e.Cast="Cast",e.Ceil="Ceil",e.ClipByValue="ClipByValue",e.Complex="Complex",e.Concat="Concat",e.Conv2D="Conv2D",e.Conv2DBackpropFilter="Conv2DBackpropFilter",e.Conv2DBackpropInput="Conv2DBackpropInput",e.Conv3D="Conv3D",e.Conv3DBackpropFilterV2="Conv3DBackpropFilterV2",e.Conv3DBackpropInputV2="Conv3DBackpropInputV2",e.Cos="Cos",e.Cosh="Cosh",e.CropAndResize="CropAndResize",e.Cumsum="Cumsum",e.DataStorage=class{constructor(e,t){this.backend=e,this.dataMover=t,this.data=new WeakMap,this.dataIdsCount=0}get(e){return this.data.has(e)||this.dataMover.moveData(this.backend,e),this.data.get(e)}set(e,t){this.dataIdsCount++,this.data.set(e,t)}has(e){return this.data.has(e)}delete(e){return this.dataIdsCount--,this.data.delete(e)}numDataIds(){return this.dataIdsCount}},e.DepthToSpace="DepthToSpace",e.DepthwiseConv2dNative="DepthwiseConv2dNative",e.DepthwiseConv2dNativeBackpropFilter="DepthwiseConv2dNativeBackpropFilter",e.DepthwiseConv2dNativeBackpropInput="DepthwiseConv2dNativeBackpropInput",e.Diag="Diag",e.Dilation2D="Dilation2D",e.Dilation2DBackpropFilter="Dilation2DBackpropFilter",e.Dilation2DBackpropInput="Dilation2DBackpropInput",e.Div="Div",e.Elu="Elu",e.EluGrad="EluGrad",e.Environment=t,e.Equal="Equal",e.Erf="Erf",e.Exp="Exp",e.Expm1="Expm1",e.FFT="FFT",e.Fill="Fill",e.Floor="Floor",e.FloorDiv="FloorDiv",e.FromPixels="FromPixels",e.FusedBatchNorm="FusedBatchNorm",e.FusedConv2D="FusedConv2D",e.FusedDepthwiseConv2D="FusedDepthwiseConv2D",e.GatherNd="GatherNd",e.GatherV2="GatherV2",e.Greater="Greater",e.GreaterEqual="GreaterEqual",e.IFFT="IFFT",e.Identity="Identity",e.Imag="Imag",e.IsFinite="IsFinite",e.IsInf="IsInf",e.IsNan="IsNan",e.KernelBackend=class{time(e){return Ul("time")}read(e){return Ul("read")}readSync(e){return Ul("readSync")}numDataIds(){return Ul("numDataIds")}disposeData(e){return Ul("disposeData")}write(e,t,n){return Ul("write")}move(e,t,n,r){return Ul("move")}memory(){return Ul("memory")}floatPrecision(){return Ul("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}batchMatMul(e,t,n,r){return Ul("batchMatMul")}fusedBatchMatMul({a:e,b:t,transposeA:n,transposeB:r,bias:s,activation:o,preluActivationWeights:a}){return Ul("fusedBatchMatMul")}slice(e,t,n){return Ul("slice")}stridedSlice(e,t,n,r){return Ul("stridedSlice")}unstack(e,t){return Ul("unstack")}reverse(e,t){return Ul("reverse")}concat(e,t){return Ul("concat")}neg(e){return Ul("neg")}add(e,t){return Ul("add")}addN(e){return Ul("addN")}subtract(e,t){return Ul("subtract")}multiply(e,t){return Ul("multiply")}realDivide(e,t){return Ul("realDivide")}floorDiv(e,t){return Ul("floorDiv")}sum(e,t){return Ul("sum")}prod(e,t){return Ul("prod")}unsortedSegmentSum(e,t,n){return Ul("unsortedSegmentSum")}argMin(e,t){return Ul("argMin")}argMax(e,t){return Ul("argMax")}equal(e,t){return Ul("equal")}notEqual(e,t){return Ul("notEqual")}less(e,t){return Ul("less")}lessEqual(e,t){return Ul("lessEqual")}greater(e,t){return Ul("greater")}greaterEqual(e,t){return Ul("greaterEqual")}logicalNot(e){return Ul("logicalNot")}logicalAnd(e,t){return Ul("logicalAnd")}logicalOr(e,t){return Ul("logicalOr")}where(e){return Ul("where")}select(e,t,n){return Ul("select")}topk(e,t,n){return Ul("topk")}min(e,t){return Ul("min")}minimum(e,t){return Ul("minimum")}mod(e,t){return Ul("mod")}max(e,t){return Ul("max")}maximum(e,t){return Ul("maximum")}all(e,t){return Ul("all")}any(e,t){return Ul("any")}squaredDifference(e,t){return Ul("squaredDifference")}ceil(e){return Ul("ceil")}floor(e){return Ul("floor")}round(e){return Ul("round")}sign(e){return Ul("sign")}isNaN(e){return Ul("isNaN")}isInf(e){return Ul("isInf")}isFinite(e){return Ul("isFinite")}pow(e,t){return Ul("pow")}exp(e){return Ul("exp")}expm1(e){return Ul("expm1")}softmax(e,t){return Ul("softmax")}log(e){return Ul("log")}log1p(e){return Ul("log1p")}sqrt(e){return Ul("sqrt")}rsqrt(e){return Ul("rsqrt")}square(e){return Ul("square")}reciprocal(e){return Ul("reciprocal")}relu(e){return Ul("relu")}relu6(e){return Ul("relu6")}prelu(e,t){return Ul("prelu")}elu(e){return Ul("elu")}eluDer(e,t){return Ul("eluDer")}selu(e){return Ul("selu")}int(e){return Ul("int")}clip(e,t,n){return Ul("clip")}abs(e){return Ul("abs")}complexAbs(e){return Ul("complexAbs")}sigmoid(e){return Ul("sigmoid")}softplus(e){return Ul("softplus")}sin(e){return Ul("sin")}cos(e){return Ul("cos")}tan(e){return Ul("tan")}asin(e){return Ul("asin")}acos(e){return Ul("acos")}atan(e){return Ul("atan")}atan2(e,t){return Ul("atan2")}sinh(e){return Ul("sinh")}cosh(e){return Ul("cosh")}tanh(e){return Ul("tanh")}asinh(e){return Ul("asinh")}acosh(e){return Ul("acosh")}atanh(e){return Ul("atanh")}erf(e){return Ul("erf")}step(e,t){return Ul("step")}fusedConv2d({input:e,filter:t,convInfo:n,bias:r,activation:s,preluActivationWeights:o}){return Ul("fusedConv2d")}conv2d(e,t,n){return Ul("conv2d")}conv2dDerInput(e,t,n){return Ul("conv2dDerInput")}conv2dDerFilter(e,t,n){return Ul("conv2dDerFilter")}fusedDepthwiseConv2D({input:e,filter:t,convInfo:n,bias:r,activation:s,preluActivationWeights:o}){return Ul("fusedDepthwiseConv2D")}depthwiseConv2D(e,t,n){return Ul("depthwiseConv2D")}depthwiseConv2DDerInput(e,t,n){return Ul("depthwiseConv2DDerInput")}depthwiseConv2DDerFilter(e,t,n){return Ul("depthwiseConv2DDerFilter")}conv3d(e,t,n){return Ul("conv3d")}conv3dDerInput(e,t,n){return Ul("conv3dDerInput")}conv3dDerFilter(e,t,n){return Ul("conv3dDerFilter")}maxPool(e,t){return Ul("maxPool")}maxPoolBackprop(e,t,n,r){return Ul("maxPoolBackprop")}avgPool(e,t){return Ul("avgPool")}avgPoolBackprop(e,t,n){return Ul("avgPoolBackprop")}avgPool3d(e,t){return Ul("avgPool3d")}avgPool3dBackprop(e,t,n){return Ul("avgPool3dBackprop")}maxPool3d(e,t){return Ul("maxPool3d")}maxPool3dBackprop(e,t,n,r){return Ul("maxPool3dBackprop")}reshape(e,t){return Ul("reshape")}cast(e,t){return Ul("cast")}tile(e,t){return Ul("tile")}pad(e,t,n){return Ul("pad")}transpose(e,t){return Ul("transpose")}gather(e,t,n){return Ul("gather")}gatherND(e,t){return Ul("gatherND")}scatterND(e,t,n){return Ul("scatterND")}batchToSpaceND(e,t,n){return Ul("batchToSpaceND")}spaceToBatchND(e,t,n){return Ul("spaceToBatchND")}resizeBilinear(e,t,n,r){return Ul("resizeBilinear")}resizeBilinearBackprop(e,t,n){return Ul("resizeBilinearBackprop")}resizeNearestNeighbor(e,t,n,r){return Ul("resizeNearestNeighbor")}resizeNearestNeighborBackprop(e,t,n){return Ul("resizeNearestNeighborBackprop")}batchNorm(e,t,n,r,s,o){return Ul("batchNorm")}localResponseNormalization4D(e,t,n,r,s){return Ul("localResponseNormalization4D")}LRNGrad(e,t,n,r,s,o,a){return Ul("LRNGrad")}multinomial(e,t,n,r){return Ul("multinomial")}oneHot(e,t,n,r){return Ul("oneHot")}cumsum(e,t,n,r){return Ul("cumsum")}nonMaxSuppression(e,t,n,r,s){return Ul("nonMaxSuppression")}fft(e){return Ul("fft")}ifft(e){return Ul("ifft")}complex(e,t){return Ul("complex")}real(e){return Ul("real")}imag(e){return Ul("imag")}cropAndResize(e,t,n,r,s,o){return Ul("cropAndResize")}depthToSpace(e,t,n){return Ul("depthToSpace")}split(e,t,n){return Ul("split")}sparseToDense(e,t,n,r){return Ul("sparseToDense")}diag(e){return Ul("diag")}fill(e,t,n){return Ul("fill")}onesLike(e){return Ul("onesLike")}zerosLike(e){return Ul("zerosLike")}linspace(e,t,n){return Ul("linspace")}dispose(){return Ul("dispose")}},e.LRN="LRN",e.LRNBackprop="LRNBackprop",e.Less="Less",e.LessEqual="LessEqual",e.LinSpace="LinSpace",e.Log="Log",e.Log1p="Log1p",e.LogSoftmax="LogSoftmax",e.LogicalAnd="LogicalAnd",e.LogicalNot="LogicalNot",e.LogicalOr="LogicalOr",e.Max="Max",e.MaxPool="MaxPool",e.MaxPool3D="MaxPool3D",e.MaxPool3DBackprop="MaxPool3DBackprop",e.MaxPoolBackprop="MaxPoolBackprop",e.MaxPoolWithArgmax="MaxPoolWithArgmax",e.Maximum="Maximum",e.Mean="Mean",e.Min="Min",e.Minimum="Minimum",e.Mod="Mod",e.MomentumOptimizer=zl,e.Multiply="Multiply",e.Negate="Negate",e.NonMaxSuppressionV3="NonMaxSuppressionV3",e.NonMaxSuppressionV4="NonMaxSuppressionV4",e.NonMaxSuppressionV5="NonMaxSuppressionV5",e.NotEqual="NotEqual",e.OneHot="OneHot",e.OnesLike="OnesLike",e.Optimizer=$l,e.PadV2="PadV2",e.Pool="Pool",e.Pow="Pow",e.Prelu="Prelu",e.Prod="Prod",e.RMSPropOptimizer=ql,e.Range="Range",e.Real="Real",e.Reciprocal="Reciprocal",e.Relu="Relu",e.Relu6="Relu6",e.Reshape="Reshape",e.ResizeBilinear="ResizeBilinear",e.ResizeBilinearGrad="ResizeBilinearGrad",e.ResizeNearestNeighbor="ResizeNearestNeighbor",e.ResizeNearestNeighborGrad="ResizeNearestNeighborGrad",e.Reverse="Reverse",e.RotateWithOffset="RotateWithOffset",e.Round="Round",e.Rsqrt="Rsqrt",e.SGDOptimizer=Pl,e.ScatterNd="ScatterNd",e.SelectV2="SelectV2",e.Selu="Selu",e.Sigmoid="Sigmoid",e.Sign="Sign",e.Sin="Sin",e.Sinh="Sinh",e.Slice="Slice",e.Softmax="Softmax",e.Softplus="Softplus",e.SpaceToBatchND="SpaceToBatchND",e.SparseToDense="SparseToDense",e.SplitV="SplitV",e.Sqrt="Sqrt",e.Square="Square",e.SquaredDifference="SquaredDifference",e.Step="Step",e.StridedSlice="StridedSlice",e.Sub="Sub",e.Sum="Sum",e.Tan="Tan",e.Tanh="Tanh",e.Tensor=oe,e.TensorBuffer=ne,e.Tile="Tile",e.TopK="TopK",e.Transpose="Transpose",e.Unpack="Unpack",e.UnsortedSegmentSum="UnsortedSegmentSum",e.Variable=ae,e.ZerosLike="ZerosLike",e._FusedMatMul="_FusedMatMul",e.abs=_o,e.acos=Bo,e.acosh=Ro,e.add=Ze,e.addN=Co,e.addStrict=gu,e.all=Po,e.any=zo,e.argMax=qo,e.argMin=Lo,e.asin=Oo,e.asinh=Wo,e.atan=Ko,e.atan2=Go,e.atanh=Uo,e.avgPool=Vo,e.avgPool3d=Ho,e.backend=function(){return ke.backend},e.backend_util=Kl,e.basicLSTMCell=Jo,e.batchNorm=Zo,e.batchNorm2d=Xo,e.batchNorm3d=Qo,e.batchNorm4d=ea,e.batchToSpaceND=Wr,e.booleanMaskAsync=lu,e.broadcastTo=ta,e.browser=fo,e.buffer=na,e.cast=Ae,e.ceil=ra,e.clipByValue=sa,e.clone=cr,e.complex=Jn,e.concat=Hr,e.concat1d=oa,e.concat2d=aa,e.concat3d=ia,e.concat4d=ua,e.conv1d=la,e.conv2d=Ut,e.conv2dTranspose=ca,e.conv3d=ha,e.conv3dTranspose=pa,e.cos=kr,e.cosh=xr,e.cosineWindow=$u,e.cumsum=tn,e.customGrad=Pa,e.deprecationWarn=Ao,e.depthToSpace=da,e.depthwiseConv2d=fa,e.device_util=xe,e.diag=ma,e.dilation2d=ga,e.disableDeprecationWarnings=function(){n().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")},e.dispose=Mo,e.disposeVariables=function(){ke.disposeVariables()},e.div=Be,e.divNoNan=ba,e.divStrict=bu,e.dot=ya,e.dropout=Tu,e.elu=wa,e.enableDebugMode=function(){n().set("DEBUG",!0)},e.enableProdMode=function(){n().set("PROD",!0)},e.enclosingPowerOfTwo=Mu,e.engine=function(){return ke},e.env=n,e.equal=_n,e.equalStrict=cu,e.erf=ka,e.exp=cn,e.expandDims=is,e.expm1=va,e.eye=xa,e.fft=Sa,e.fill=Ea,e.findBackend=function(e){return ke.findBackend(e)},e.findBackendFactory=function(e){return ke.findBackendFactory(e)},e.floor=Un,e.floorDiv=_e,e.fused=Ou,e.gather=ps,e.gatherND=Au,e.gather_util=go,e.getBackend=function(){return ke.backendName},e.getGradient=l,e.getKernel=u,e.getKernelsForBackend=c,e.grad=function(e){return m(z(e),()=>"The f passed in grad(f) must be a function"),(t,n)=>{const r=Ne(t,"x","tf.grad",null),s=null!=n?Ne(n,"dy","tf.grad"):null;return ke.tidy(()=>{const{value:t,grads:n}=ke.gradients(()=>e(r),[r],s);return null!=s&&g(t.shape,s.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),za(n),n[0]})}},e.grads=function(e){return m(z(e),()=>"The f passed in grads(f) must be a function"),(t,n)=>{m(Array.isArray(t),()=>"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s");const r=Ie(t,"args","tf.grads",null),s=null!=n?Ne(n,"dy","tf.grads"):null;return ke.tidy(()=>{const{value:t,grads:n}=ke.gradients(()=>e(...r),r,s);return null!=s&&g(t.shape,s.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),za(n),n})}},e.greater=Kn,e.greaterEqual=Bt,e.greaterEqualStrict=hu,e.greaterStrict=pu,e.ifft=Da,e.imag=Na,e.image=Fl,e.inTopKAsync=_u,e.io=ao,e.irfft=Fa,e.isFinite=Aa,e.isInf=Ta,e.isNaN=Ma,e.keep=$o,e.kernel_impls=Gl,e.leakyRelu=$a,e.less=Cn,e.lessEqual=Rt,e.lessEqualStrict=du,e.lessStrict=fu,e.linalg=Al,e.linspace=_a,e.localResponseNormalization=Ba,e.log=er,e.log1p=Ra,e.logSigmoid=qa,e.logSoftmax=Oa,e.logSumExp=Wa,e.logicalAnd=Ct,e.logicalNot=mr,e.logicalOr=Ka,e.logicalXor=Ga,e.losses=Tl,e.matMul=It,e.math=lo,e.max=La,e.maxPool=Ua,e.maxPool3d=Va,e.maxPoolWithArgmax=Ha,e.maximum=ds,e.maximumStrict=yu,e.mean=ja,e.memory=function(){return ke.memory()},e.min=Ja,e.minimum=Ya,e.minimumStrict=wu,e.mod=Za,e.modStrict=ku,e.moments=Xa,e.movingAverage=Nu,e.mul=Te,e.mulStrict=vu,e.multiRNNCell=Qa,e.multinomial=ei,e.neg=Re,e.nextFrame=function(){return new Promise(e=>Wl(()=>e()))},e.norm=Du,e.notEqual=ti,e.notEqualStrict=mu,e.oneHot=io,e.ones=es,e.onesLike=ni,e.op=Fe,e.outerProduct=ri,e.pad=Er,e.pad1d=si,e.pad2d=oi,e.pad3d=ai,e.pad4d=ii,e.pool=ui,e.pow=tr,e.powStrict=xu,e.prelu=li,e.print=ci,e.prod=hi,e.profile=function(e){return ke.profile(e)},e.rand=pi,e.randomGamma=Di,e.randomNormal=Ni,e.randomUniform=Ii,e.range=Ai,e.ready=function(){return ke.ready()},e.real=Ia,e.reciprocal=Ti,e.registerBackend=function(e,t,n=1){return ke.registerBackend(e,t,n)},e.registerGradient=h,e.registerKernel=function(e){const{kernelName:t,backendName:n}=e,r=p(t,n);a.has(r)&&console.warn(`The kernel '${t}' for backend '${n}' is already registered`),a.set(r,e)},e.relu=Mi,e.relu6=$i,e.removeBackend=function(e){ke.removeBackend(e)},e.reshape=Qe,e.reverse=hr,e.reverse1d=_i,e.reverse2d=Bi,e.reverse3d=Ri,e.reverse4d=Ci,e.rfft=Pi,e.round=zi,e.rsqrt=gn,e.scalar=Pe,e.scatterND=Iu,e.scatter_util=ko,e.selu=qi,e.separableConv2d=Li,e.serialization=Eo,e.setBackend=function(e){return ke.setBackend(e)},e.setPlatform=function(e,t){n().setPlatform(e,t)},e.setdiff1dAsync=Oi,e.sigmoid=Lr,e.sign=Wi,e.signal=Il,e.sin=Yt,e.sinh=Xt,e.slice=ss,e.slice1d=Ki,e.slice2d=Gi,e.slice3d=Ui,e.slice4d=Vi,e.slice_util=Pr,e.softmax=Hi,e.softplus=ji,e.spaceToBatchND=At,e.sparseToDense=Fu,e.spectral=Nl,e.split=Lt,e.sqrt=ze,e.square=qe,e.squaredDifference=Ji,e.squaredDifferenceStrict=Su,e.squeeze=Yi,e.stack=us,e.step=Me,e.stridedSlice=Zi,e.sub=Le,e.subStrict=Eu,e.sum=it,e.sumOutType=function(e){return de(e,"int32")},e.tan=Xi,e.tanh=jo,e.tensor=Vr,e.tensor1d=Fi,e.tensor2d=Qi,e.tensor3d=co,e.tensor4d=eu,e.tensor5d=tu,e.tensor6d=nu,e.tensor_util=be,e.test_util=Fo,e.tidy=To,e.tile=bn,e.time=function(e){return ke.time(e)},e.topk=ru,e.train=Ol,e.transpose=en,e.truncatedNormal=su,e.unregisterGradient=function(e){if(!i.has(e))throw new Error(`The gradient '${e}' for backend is not registered`);i.delete(e)},e.unregisterKernel=function(e,t){const n=p(e,t);if(!a.has(n))throw new Error(`The kernel '${e}' for backend '${t}' is not registered`);a.delete(n)},e.unsortedSegmentSum=wn,e.unstack=ou,e.upcastType=de,e.util=J,e.valueAndGrad=function(e){return m(z(e),()=>"The f passed in valueAndGrad(f) must be a function"),(t,n)=>{m(t instanceof oe,()=>"The x passed in valueAndGrad(f)(x) must be a tensor"),m(null==n||n instanceof oe,()=>"The dy passed in valueAndGrad(f)(x, dy) must be a tensor");const{grads:r,value:s}=ke.gradients(()=>e(t),[t],n);return za(r),{grad:r[0],value:s}}},e.valueAndGrads=function(e){return m(z(e),()=>"The f passed in valueAndGrads(f) must be a function"),(t,n)=>{m(Array.isArray(t)&&t.every(e=>e instanceof oe),()=>"The args passed in valueAndGrads(f)(args) must be array of tensors"),m(null==n||n instanceof oe,()=>"The dy passed in valueAndGrads(f)(args, dy) must be a tensor");const r=ke.gradients(()=>e(...t),t,n);return null!=n&&g(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),za(r.grads),r}},e.variable=au,e.variableGrads=Ca,e.version_core="2.1.0",e.where=Pt,e.whereAsync=uu,e.zeros=Yn,e.zerosLike=He,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-core.es2017.min.js.map
